// config.h - projeto gens+. Rodrigo Cardoso.

#ifndef _CONFIG_H
#define _CONFIG_H

#include <windows.h>
#include <stdio.h>

#define GMAX_PATH     512
#define GMAX_RECENT_ROM 9

#ifdef __cplusplus
extern "C" {
#endif

extern char Recent_Rom[GMAX_RECENT_ROM][GMAX_PATH];
extern int  Recent_Rom_Type[GMAX_RECENT_ROM];

extern char State_Dir        [GMAX_PATH];
extern char SRAM_Dir         [GMAX_PATH];
extern char BRAM_Dir         [GMAX_PATH];
extern char Config_Dir       [GMAX_PATH];
extern char IPS_Dir          [GMAX_PATH];
extern char ScrShot_Dir      [GMAX_PATH];
extern char Rom_Dir          [GMAX_PATH];
extern char Cheats_Dir       [GMAX_PATH];
extern char Dump_Dir         [GMAX_PATH];
extern char Patch_Dir        [GMAX_PATH];
extern char US_CD_Bios       [GMAX_PATH];
extern char EU_CD_Bios       [GMAX_PATH];
extern char JA_CD_Bios       [GMAX_PATH];
extern char _32X_Genesis_Bios[GMAX_PATH];
extern char _32X_Master_Bios [GMAX_PATH];
extern char _32X_Slave_Bios  [GMAX_PATH];
extern char Genesis_Bios     [GMAX_PATH];
extern char CGOffline_Path   [GMAX_PATH];
extern char Manual_Path      [GMAX_PATH];
extern int  Current_State;
extern int  Compress_Save_States;
extern int  Compress_ScrShots;
extern int  Use_Last_Open_Rom_Dir;
extern int  Switch_Full_Screen;
extern int  Disable_Screen_Saver;

extern int   Show_FPS;
extern int   FPS_Transp;
extern int   FPS_Font;
extern int   Show_Message;
extern int   Message_Transp;
extern int   Message_Font;
extern DWORD Message_Color;
extern DWORD FPS_Color;

#define GFONT_NAME_SIZE  32         // tamanho mximo do nome de cada fonte

extern char Font1_Name[GFONT_NAME_SIZE];
extern char Font2_Name[GFONT_NAME_SIZE];
extern char Font3_Name[GFONT_NAME_SIZE];
extern COLORREF Font1_Color1;
extern COLORREF Font1_Color2;
extern COLORREF Font2_Color;
extern COLORREF Font3_Color;
extern WORD     Font1_Color1W;
extern WORD     Font1_Color2W;
extern WORD     Font2_ColorW;
extern WORD     Font3_ColorW;

typedef void (__fastcall* PRINTFUNC)(LPCSTR, DWORD, int, int);

extern PRINTFUNC Print_Message;
extern PRINTFUNC Print_FPS;


extern int      Intro_Style;
extern COLORREF Intro_Color;
extern WORD     Intro_ColorW;

extern int Full_Screen;
extern int Res_X, Res_Y;
extern int VSync_FS;
extern int VSync_W;
extern int Stretch_W;
extern int Stretch_FS;
extern int Blit_Soft;
extern int Show_LED;
extern int Use_State_MiniShot;
extern int Compress_Save_States;
extern int Run_Multiple_Instances;
extern int Multiple_Controls_Config;
extern int Show_LED;
extern int Auto_Pause;
extern int Auto_Fix_CS;
extern int Force_Mode;
extern int Device_FS;
extern int Device_W;

extern int Fast_Blur;
extern int Render_W;
extern int Render_FS;

extern int SMS_Bright_Palette;
extern int SMS_YM2413_Enable;
extern int SMS_YM2413_Quality;

int  __stdcall Save_Config(LPCSTR);
void __stdcall Save_Control_Config(FILE *);
int  Save_As_Config(HWND);
int  __stdcall Load_Config(LPCSTR File_Name, LPVOID Game_Active);
void __stdcall Load_Control_Config(LPCSTR File_Name);
int  Load_As_Config(HWND hWnd, void *Game_Active);
BOOL Check_Config_File(LPCSTR);

#ifdef __cplusplus
}
#endif


BOOL Select_Dir(HWND, LPSTR, LPCSTR);

// arquivo de fontes
#define GFONTS_FILE_NAME "font.bin" // nome do arquivo de fontes
#define GFONTS_FILE_TYPE 0x004E4647 // identifica o arquivo de fontes (os 4 primeiros bytes)

// fontes
typedef struct _FONTHDR {
  char     pszName[GFONT_NAME_SIZE]; // nome da fonte
  DWORD    dwType;                   // tipo da fonte (1, 2 ou 3)
  UINT     uFileAdr;                 // endereo da fonte no arquivo de fontes
  COLORREF c1;
  COLORREF c2;                       // s  vlido se o tipo for 1
} FONTHDR;

/* carrega as fontes do arquivo, se file for NULL, a prpria funo abre e fecha o
   arquivo de fontes */
BOOL __stdcall Load_Fonts_From_File(FILE *, BOOL);
FILE *__stdcall Get_Fonts_Info(HWND);

void Show_Config_Window(void);

#endif // _CONFIG_H
