
#include "config.h"
#include "misc.h"
#include "gmain.h"
#include "ggraphic.h"
#include "vdp_io.h"
#include "gio.h"
#include "gmenu.h"
#include "grom.h"
#include "gens.h"
#include "vdp_rend.h"
#include "gdsound.h"
#include "mem_m68k.h"
#include "ym2612.h"
#include "psg.h"
#include "pcm.h"
#include "pwm.h"
#include "cd_sys.h"
#include "cpu_sh2.h"
#include "cd_aspi.h"
#include "gdinput.h"
#include "script.h"
#include "resource.h"

char Recent_Rom[GMAX_RECENT_ROM][GMAX_PATH] = { "", "", "", "", "", "", "", "", "" };
int  Recent_Rom_Type[GMAX_RECENT_ROM]       = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };

char State_Dir        [GMAX_PATH] = "";
char SRAM_Dir         [GMAX_PATH] = "";
char BRAM_Dir         [GMAX_PATH] = "";
char Config_Dir       [GMAX_PATH] = "";
char IPS_Dir          [GMAX_PATH] = "";
char ScrShot_Dir      [GMAX_PATH] = "";
char Rom_Dir          [GMAX_PATH] = "";
char Cheats_Dir       [GMAX_PATH] = "";
char Dump_Dir         [GMAX_PATH] = "";
char Patch_Dir        [GMAX_PATH] = "";
char US_CD_Bios       [GMAX_PATH] = "";
char EU_CD_Bios       [GMAX_PATH] = "";
char JA_CD_Bios       [GMAX_PATH] = "";
char _32X_Genesis_Bios[GMAX_PATH] = "";
char _32X_Master_Bios [GMAX_PATH] = "";
char _32X_Slave_Bios  [GMAX_PATH] = "";
char Genesis_Bios     [GMAX_PATH] = "";
char CGOffline_Path   [GMAX_PATH] = "";
char Manual_Path      [GMAX_PATH] = "";

int  Current_State         = 0;
int  Compress_Save_States  = 1;
int  Compress_ScrShots     = 1;
int  Use_Last_Open_Rom_Dir = 0;
int  Switch_Full_Screen    = 1;
int  Disable_Screen_Saver  = 1;

int   Show_FPS             = 0;
int   FPS_Transp           = 0;
int   FPS_Font             = 1;
int   Show_Message         = 0;
int   Message_Transp       = 0;
int   Message_Font         = 1;
DWORD Message_Color        = 0;
DWORD FPS_Color            = 0;

char Font1_Name[GFONT_NAME_SIZE]    = "";
char Font2_Name[GFONT_NAME_SIZE]    = "";
char Font3_Name[GFONT_NAME_SIZE]    = "";
COLORREF Font1_Color1   = 0x00000000;
COLORREF Font1_Color2   = 0x00FFFFFF;
COLORREF Font2_Color    = 0x00000000;
COLORREF Font3_Color    = 0x00000000;
WORD     Font1_Color1W  = 0;
WORD     Font1_Color2W  = 0;
WORD     Font2_ColorW   = 0;
WORD     Font3_ColorW   = 0;

PRINTFUNC Print_Message = NULL;
PRINTFUNC Print_FPS     = NULL;

int      Intro_Style    = 0;
COLORREF Intro_Color    = 0x00FFFFFF;
WORD     Intro_ColorW   = 0;

int Full_Screen              = -1;
int Res_X                    = 640;
int Res_Y                    = 480;
int VSync_FS                 = 0;
int VSync_W                  = 0;
int Stretch_W                = 0;
int Stretch_FS               = 0;
int Blit_Soft                = 0;
int Show_LED                 = 0;
int Use_State_MiniShot       = 1;
int Auto_Pause               = 0;
int Auto_Fix_CS              = 0;
int Run_Multiple_Instances   = 0;
int Multiple_Controls_Config = 0;
int Force_Mode               = 0;
int Device_FS                = 0;
int Device_W                 = 0;

int Fast_Blur  = 0;
int Render_W   = 0;
int Render_FS  = 0;

int SMS_Bright_Palette = 1;
int SMS_YM2413_Enable  = 1;
int SMS_YM2413_Quality = 0;

int __stdcall Save_Config(LPCSTR File_Name)
{
  FILE *fcfg;
  int   i;

  fcfg = fopen(File_Name, "wt");
  if(!fcfg) return 0;

  fprintf(fcfg, "%s\n\n", "; Gens+ REWiND! configuration file"); //MK2k
  fprintf(fcfg, "%s\n", "; configuration file information");
  fprintf(fcfg, "[%s]\n", "Application");
  fprintf(fcfg, "%s=%s\n", "Name", GENSNAME);
  fprintf(fcfg, "%s=%d.%d.%d.%d\n", "Version", GENSVER4, GENSVER3, GENSVER2, GENSVER1);

  fprintf(fcfg, "\n%s\n", "; general options");
  fprintf(fcfg, "[%s]\n", "General");
  fprintf(fcfg, "%s=%d\n", "File Type Index", File_Type_Index);
  fprintf(fcfg, "%s=%d\n", "State Number", Current_State);
  fprintf(fcfg, "%s=%d\n", "Language", Language);
  fprintf(fcfg, "%s=%d\n", "Window X", Window_Pos.x);
  fprintf(fcfg, "%s=%d\n", "Window Y", Window_Pos.y);
  fprintf(fcfg, "%s=%d\n", "Intro Style", Intro_Style);
  fprintf(fcfg, "%s=%d\n", "Intro Color", Intro_Color);
  fprintf(fcfg, "%s=%d\n", "Compress Save States", Compress_Save_States);
  fprintf(fcfg, "%s=%d\n", "Compress Screen Shots", Compress_ScrShots);
  fprintf(fcfg, "%s=%d\n", "Multiple Control Config", Multiple_Controls_Config);
  fprintf(fcfg, "%s=%d\n", "Multiple Instances", Run_Multiple_Instances);
  fprintf(fcfg, "%s=%d\n", "State Preview", Use_State_MiniShot);
  fprintf(fcfg, "%s=%d\n", "Auto Fix Checksum", Auto_Fix_CS & 1);
  fprintf(fcfg, "%s=%d\n", "Auto Pause", Auto_Pause & 1);
  fprintf(fcfg, "%s=%d\n", "LED", Show_LED & 1);
  fprintf(fcfg, "%s=%d\n", "Use Last Open Rom Dir", Use_Last_Open_Rom_Dir);
  fprintf(fcfg, "%s=%d\n", "Switch Full Screen", Switch_Full_Screen);
  fprintf(fcfg, "%s=%d\n", "Disable screen saver", Disable_Screen_Saver);
  for(i = 0; i < GMAX_RECENT_ROM; i++)
  {
    fprintf(fcfg, "%s %d=%s\n", "Rom", i, Recent_Rom[i]);
    fprintf(fcfg, "%s %d=%d\n", "Rom Type", i, Recent_Rom_Type[i]);
  }

  fprintf(fcfg, "\n%s\n", "; gens directories");
  fprintf(fcfg, "[%s]\n", "Directories");
  fprintf(fcfg, "%s=%s\n", "Roms", Rom_Dir);
  fprintf(fcfg, "%s=%s\n", "Saved States", State_Dir);
  fprintf(fcfg, "%s=%s\n", "SRAM Backup", SRAM_Dir);
  fprintf(fcfg, "%s=%s\n", "BRAM Backup", BRAM_Dir);
  fprintf(fcfg, "%s=%s\n", "Sound Dump", Dump_Dir);
  fprintf(fcfg, "%s=%s\n", "Screen Shots", ScrShot_Dir);
  fprintf(fcfg, "%s=%s\n", "Patches", Patch_Dir);
  fprintf(fcfg, "%s=%s\n", "IPS Patches", IPS_Dir);
  fprintf(fcfg, "%s=%s\n", "Cheats", Cheats_Dir);
  fprintf(fcfg, "%s=%s\n", "Config", Config_Dir);


  fprintf(fcfg, "\n%s\n", "; gens files");
  fprintf(fcfg, "[%s]\n", "Files");
  fprintf(fcfg, "%s=%s\n", "Genesis Bios", Genesis_Bios);
  fprintf(fcfg, "%s=%s\n", "USA CD Bios", US_CD_Bios);
  fprintf(fcfg, "%s=%s\n", "EUROPE CD Bios", EU_CD_Bios);
  fprintf(fcfg, "%s=%s\n", "JAPAN CD Bios", JA_CD_Bios);
  fprintf(fcfg, "%s=%s\n", "32X 68000 Bios", _32X_Genesis_Bios);
  fprintf(fcfg, "%s=%s\n", "32X Master SH2 Bios", _32X_Master_Bios);
  fprintf(fcfg, "%s=%s\n", "32X Slave SH2 Bios", _32X_Slave_Bios);
  fprintf(fcfg, "%s=%s\n", "GCOfline", CGOffline_Path);
  fprintf(fcfg, "%s=%s\n", "Gens manual", Manual_Path);

  fprintf(fcfg, "\n%s\n", "; interface options");
  fprintf(fcfg, "[%s]\n", "Interface");
  fprintf(fcfg, "%s=%d\n", "Show FPS", Show_FPS & 1);
  fprintf(fcfg, "%s=%d\n", "Transparent FPS", FPS_Transp);
  fprintf(fcfg, "%s=%d\n", "FPS Font", FPS_Font);
  fprintf(fcfg, "%s=%d\n", "Show Message", Show_Message & 1);
  fprintf(fcfg, "%s=%d\n", "Transparent Message", Message_Transp);
  fprintf(fcfg, "%s=%d\n", "Message Font", Message_Font);
  fprintf(fcfg, "%s=%s\n", "Font1 Name", Font1_Name);
  fprintf(fcfg, "%s=%u\n", "Font1 Body Color", Font1_Color1);
  fprintf(fcfg, "%s=%u\n", "Font1 Border Color", Font1_Color2);
  fprintf(fcfg, "%s=%s\n", "Font2 Name", Font2_Name);
  fprintf(fcfg, "%s=%u\n", "Font2 Color", Font2_Color);
  fprintf(fcfg, "%s=%s\n", "Font3 Name", Font3_Name);
  fprintf(fcfg, "%s=%u\n", "Font3 Color", Font3_Color);

  fprintf(fcfg, "\n%s\n", "; graphics options");
  fprintf(fcfg, "[%s]\n", "Graphics");
  fprintf(fcfg, "%s=%d\n", "Full Screen", Full_Screen & 1);
  fprintf(fcfg, "%s=%d\n", "Full Screen Res X", Res_X);
  fprintf(fcfg, "%s=%d\n", "Full Screen Res Y", Res_Y);
  fprintf(fcfg, "%s=%d\n", "Full Screen VSync", VSync_FS & 1);
  fprintf(fcfg, "%s=%d\n", "Window VSync", VSync_W & 1);
  fprintf(fcfg, "%s=%d\n", "Render Windowed", Render_W);
  fprintf(fcfg, "%s=%d\n", "Render Fullscreen", Render_FS);
  fprintf(fcfg, "%s=%d\n", "Window Stretch", Stretch_W & 1);
  fprintf(fcfg, "%s=%d\n", "Full Screen Stretch", Stretch_FS & 1);
  fprintf(fcfg, "%s=%d\n", "Software Blit", Blit_Soft & 1);
  fprintf(fcfg, "%s=%d\n", "Contrast", Contrast_Level);
  fprintf(fcfg, "%s=%d\n", "Brightness", Brightness_Level);
  fprintf(fcfg, "%s=%d\n", "Greyscale", Greyscale & 1);
  fprintf(fcfg, "%s=%d\n", "Invert", Invert_Color & 1);
  fprintf(fcfg, "%s=%d\n", "Sprite limit", Sprite_Over & 1);
  fprintf(fcfg, "%s=%d\n", "Frame skip", Frame_Skip);
  fprintf(fcfg, "%s=%d\n", "Fast Blur", Fast_Blur & 1);
  if     (Force_Mode == 1) fprintf(fcfg, "%s=%d\n", "Force 555", 1);
  else if(Force_Mode == 0) fprintf(fcfg, "%s=%d\n", "Force 565", 1);
  fprintf(fcfg, "%s=%d\n", "Full Screen Device", Device_FS);
  fprintf(fcfg, "%s=%d\n", "Window Device", Device_W);

  fprintf(fcfg, "\n%s\n", "; sound options");
  fprintf(fcfg, "[%s]\n", "Sound");
  fprintf(fcfg, "%s=%d\n", "State", Sound_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "Rate", Sound_Rate);
  fprintf(fcfg, "%s=%d\n", "Stereo", Sound_Stereo);
  fprintf(fcfg, "%s=%d\n", "Volume", Sound_Volume);
  fprintf(fcfg, "%s=%d\n", "Use Lowpass Filter", Use_LowPass_Filter);
  fprintf(fcfg, "%s=%d\n", "Echo", Sound_Echo);
  fprintf(fcfg, "%s=%d\n", "Z80 State", Z80_State & 1);
  fprintf(fcfg, "%s=%d\n", "YM2612 State", YM2612_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "PSG State", PSG_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "PSG Improvement", PSG_Improv & 1);
  fprintf(fcfg, "%s=%d\n", "DAC State", DAC_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "DAC Improvement", DAC_Improv & 1);
  fprintf(fcfg, "%s=%d\n", "PCM State", PCM_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "PWM State", PWM_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "CDDA State", CDDA_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "YM2612 Improvement", YM2612_Improv & 1);
  fprintf(fcfg, "%s=%d\n", "YM2612 SSGEG", YM2612_Enable_SSGEG & 1);

  fprintf(fcfg, "\n%s\n", "; CPU");
  fprintf(fcfg, "[%s]\n", "CPU");
  fprintf(fcfg, "%s=%d\n", "Country", Country);
  fprintf(fcfg, "%s=%d\n", "Prefered Country 1", Country_Order[0]);
  fprintf(fcfg, "%s=%d\n", "Prefered Country 2", Country_Order[1]);
  fprintf(fcfg, "%s=%d\n", "Prefered Country 3", Country_Order[2]);
  fprintf(fcfg, "%s=%d\n", "Perfect Synchro", SegaCD_Accurate);
  fprintf(fcfg, "%s=%d\n", "Main SH2 Speed", MSH2_Speed);
  fprintf(fcfg, "%s=%d\n", "Slave SH2 Speed", SSH2_Speed);

  fprintf(fcfg, "\n[%s]\n", "System");
  fprintf(fcfg, "%s=%d\n", "CD Drive", CUR_DEV);

  if (BRAM_Ex_State & 0x100) fprintf(fcfg, "%s=%d\n", "Ram Cart Size", BRAM_Ex_Size);
  else                       fprintf(fcfg, "%s=%d\n", "Ram Cart Size", -1);

  fprintf(fcfg, "\n[%s]\n", "Master System");
  fprintf(fcfg, "%s=%d\n", "Use bright palette", SMS_Bright_Palette & 1);
  fprintf(fcfg, "%s=%d\n", "Enable YM2413", SMS_YM2413_Enable & 1);
  fprintf(fcfg, "%s=%d\n", "YM2413 high quality", SMS_YM2413_Quality & 1);

  putc('\n', fcfg);
  Save_Control_Config(fcfg);

  fclose(fcfg);

  return 1;
}

#define SET_CONTROL_CONFIG_ITEM(item, sufix) \
  fprintf(fcfg, "P%s.%s=%d\n", prefix[i], sufix, item);

void __stdcall Save_Control_Config(FILE *fcfg)
{
  int i;
  const char prefix[8][4] = { "1", "2", "1B", "1C", "1D", "2B", "2C", "2D" };

  fprintf(fcfg, "%s\n", "; gens keys configuration");
  fprintf(fcfg, "[%s]\n", "Input");

  for(i = 0; i < 8; i++)
  {
    fprintf(fcfg, "%s %s\n", "; joystick", prefix[i]);
    SET_CONTROL_CONFIG_ITEM(Control[i].Type & ((i < 2) ? 0x13 : 0x03), "Type");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Up, "Up");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Down, "Down");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Left, "Left");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Right, "Right");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Start, "Start");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].A, "A");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].B, "B");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].C, "C");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Mode, "Mode");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].X, "X");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Y, "Y");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Z, "Z");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].Rewind, "Rewind"); //MK2k: Added Key Profile
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[0], "HotKey1");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[1], "HotKey2");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[2], "HotKey3");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[3], "HotKey4");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[0], "HotKey Buttons1");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[1], "HotKey Buttons2");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[2], "HotKey Buttons3");
    SET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[3], "HotKey Buttons4");
  }
}


int Save_As_Config(HWND hWnd)
{
  char Name[2048];
  OPENFILENAME ofn;

  SetCurrentDirectory(Gens_Path);

  strcpy(Name, "gens.ini");
  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize     = sizeof(OPENFILENAME);
  ofn.hwndOwner       = hWnd;
  ofn.hInstance       = ghInstance;
  ofn.lpstrFile       = Name;
  ofn.nMaxFile        = 2047;
  ofn.lpstrFilter     = "Configuration files (*.ini)\0*.ini\0All files (*.*)\0*.*\0\0";
  ofn.nFilterIndex    = 1;
  ofn.lpstrInitialDir = Gens_Path;
  ofn.lpstrDefExt     = "cfg";
  ofn.Flags           = OFN_HIDEREADONLY;

  if(GetSaveFileName(&ofn))
  {
    Save_Config(Name);
    strcpy(Str_Tmp, "config saved in ");
    strcat(Str_Tmp, Name);
    Put_Info(Str_Tmp, 2000);
    return 1;
  }
  else return 0;
}


int __stdcall Load_Config(LPCSTR File_Name, LPVOID Game_Active)
{
  int        new_val, res, i;
  const char general[]     = "General";
  const char directories[] = "Directories";
  const char files[]       = "Files";
  const char interf[]      = "Interface";
  const char graphic[]     = "Graphics";
  const char sound[]       = "Sound";
  const char cpu[]         = "CPU";
  const char system[]      = "System";
  const char sms[]         = "Master System";
  char       pszTmp[16];
  char       Conf_File[GMAX_PATH];

  SetCurrentDirectory(Gens_Path);
  strncpy(Conf_File, File_Name, GMAX_PATH);

  CRam_Flag = 1;

  // general
  File_Type_Index = GetPrivateProfileInt(general, "File Type Index", 1, Conf_File);
  Current_State   = GetPrivateProfileInt(general, "State Number", 0, Conf_File);
  Language        = GetPrivateProfileInt(general, "Language", 0, Conf_File);
  Window_Pos.x    = GetPrivateProfileInt(general, "Window X",
    (GetSystemMetrics(SM_CXFULLSCREEN) / 2) - 160, Conf_File);
  Window_Pos.y    = GetPrivateProfileInt(general, "Window Y",
    (GetSystemMetrics(SM_CYFULLSCREEN) / 2) - 120, Conf_File);
  Intro_Style     = GetPrivateProfileInt(general, "Intro Style", 2, Conf_File); //MK2k: I like the "Strange Effect" the most ;)
  Intro_Color     = GetPrivateProfileInt(general, "Intro Color", 0x00FFFFFF, Conf_File);
  Intro_ColorW    = Color_24_to_16(Intro_Color);
  Sleep_Time      = GetPrivateProfileInt(general, "Allow Idle", 0, Conf_File) & 1;
  Gens_Priority   = GetPrivateProfileInt(general, "Priority", 1, Conf_File);
  Compress_Save_States = GetPrivateProfileInt(general, "Compress Save States", 1, Conf_File);
  Compress_ScrShots    = GetPrivateProfileInt(general, "Compress Screen Shots", 1, Conf_File);
  Multiple_Controls_Config = GetPrivateProfileInt(general, "Multiple Control Config", 0, Conf_File);
  Run_Multiple_Instances   = GetPrivateProfileInt(general, "Multiple Instances", 0, Conf_File);
  Use_State_MiniShot = GetPrivateProfileInt(general, "State Preview", 1, Conf_File);
  Auto_Fix_CS   = GetPrivateProfileInt(general, "Auto Fix Checksum", 0, Conf_File);
  Auto_Pause    = GetPrivateProfileInt(general, "Auto Pause", 0, Conf_File);
  Show_LED      = GetPrivateProfileInt(general, "LED", 1, Conf_File);
  Use_Last_Open_Rom_Dir = GetPrivateProfileInt(general, "Use Last Open Rom Dir", 1, Conf_File);
  Switch_Full_Screen    = GetPrivateProfileInt(general, "Switch Full Screen", 0, Conf_File); //MK2k: No switching to full screen as default
  Disable_Screen_Saver  = GetPrivateProfileInt(general, "Disable screen saver", 1, Conf_File);
  for(i = 0; i < GMAX_RECENT_ROM; i++)
  {
    sprintf(pszTmp, "Rom %d", i);
    GetPrivateProfileString(general, pszTmp, "", Recent_Rom[i], GMAX_PATH, Conf_File);
    sprintf(pszTmp, "Rom Type %d", i);
    Recent_Rom_Type[i] = GetPrivateProfileInt(general, pszTmp, 0, Conf_File);
  }

  // directories
  GetPrivateProfileString(directories, "Roms", ".\\Roms\\", Rom_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Saved States", ".\\Save\\", State_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "SRAM Backup", ".\\RAM\\", SRAM_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "BRAM Backup", ".\\RAM\\", BRAM_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Sound Dump", ".\\Dump\\", Dump_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Screen Shots", ".\\Shots\\", ScrShot_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Patches", ".\\Patch\\", Patch_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "IPS Patches", ".\\Patch\\", IPS_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Cheats", ".\\Cheats\\", Cheats_Dir, GMAX_PATH, Conf_File);
  GetPrivateProfileString(directories, "Config", ".\\Config\\", Config_Dir, GMAX_PATH, Conf_File);

  // files
	GetPrivateProfileString(files, "Genesis Bios", ".\\Bios\\Genesis_OS_ROM.bin", Genesis_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "USA CD Bios", ".\\Bios\\us_scd1_9210.bin", US_CD_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "EUROPE CD Bios", ".\\Bios\\eu_mcd1_9210.bin", EU_CD_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "JAPAN CD Bios", ".\\Bios\\jp_mcd1_9112.bin", JA_CD_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "32X 68000 Bios", ".\\Bios\\32X_G_bios.bin", _32X_Genesis_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "32X Master SH2 Bios", ".\\Bios\\32X_M_bios.bin", _32X_Master_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "32X Slave SH2 Bios", ".\\Bios\\32X_S_bios.bin", _32X_Slave_Bios, GMAX_PATH, Conf_File); //MK2k: default to Bios directory
  GetPrivateProfileString(files, "GCOffline", ".\\GCOffline.chm", CGOffline_Path, 1024, Conf_File);
  GetPrivateProfileString(files, "Gens manual", ".\\manual.exe", Manual_Path, 1024, Conf_File);

  // interface
  GetPrivateProfileString(interf, "Font1 Name", "Out Run", Font1_Name, GFONT_NAME_SIZE, Conf_File);
  Font1_Color1   = GetPrivateProfileInt(interf, "Font1 Body Color", 0x00FFFFFF, Conf_File);
  Font1_Color1W  = Color_24_to_16(Font1_Color1);
  Font1_Color2   = GetPrivateProfileInt(interf, "Font1 Border Color", 0x00000000, Conf_File);
  Font1_Color2W  = Color_24_to_16(Font1_Color2);
  GetPrivateProfileString(interf, "Font2 Name", "Shining Force 2", Font2_Name, GFONT_NAME_SIZE, Conf_File);
  Font2_Color    = GetPrivateProfileInt(interf, "Font2 Color", 0x00000000, Conf_File);
  Font2_ColorW   = Color_24_to_16(Font2_Color);
  GetPrivateProfileString(interf, "Font3 Name", "Default", Font3_Name, GFONT_NAME_SIZE, Conf_File);
  Font3_Color    = GetPrivateProfileInt(interf, "Font3 Color", 0x00000000, Conf_File);
  Font3_ColorW   = Color_24_to_16(Font3_Color);
  Show_FPS       = GetPrivateProfileInt(interf, "Show FPS", 0, Conf_File);
  FPS_Transp     = GetPrivateProfileInt(interf, "Transparent FPS", 0, Conf_File);
  FPS_Font       = GetPrivateProfileInt(interf, "FPS Font", 1, Conf_File);
  if(FPS_Transp)
  {
    switch(FPS_Font)
    { case 2:  Print_FPS = Print_Text2_Transp; FPS_Color = (DWORD)Font2_ColorW; break;
      case 3:  Print_FPS = Print_Text3_Transp; FPS_Color = (DWORD)Font3_ColorW; break;
      default: Print_FPS = Print_Text1_Transp; FPS_Color = MAKELONG(Font1_Color1W, Font1_Color2W); break; }
  }
  else
  {
    switch(FPS_Font)
    { case 2:  Print_FPS = Print_Text2; FPS_Color = (DWORD)Font2_ColorW; break;
      case 3:  Print_FPS = Print_Text3; FPS_Color = (DWORD)Font3_ColorW; break;
      default: Print_FPS = Print_Text1; FPS_Color = MAKELONG(Font1_Color1W, Font1_Color2W); break; }
  }
  Show_Message   = GetPrivateProfileInt(interf, "Show Message", 1, Conf_File);
  Message_Transp = GetPrivateProfileInt(interf, "Transparent Message", 0, Conf_File);
  Message_Font   = GetPrivateProfileInt(interf, "Message Font", 1, Conf_File);
  if(Message_Transp)
  {
    switch(Message_Font)
    { case 2:  Print_Message = Print_Text2_Transp; Message_Color = (DWORD)Font2_ColorW; break;
      case 3:  Print_Message = Print_Text3_Transp; Message_Color = (DWORD)Font3_ColorW; break;
      default: Print_Message = Print_Text1_Transp; Message_Color = MAKELONG(Font1_Color1W, Font1_Color2W); break; }
  }
  else
  {
    switch(Message_Font)
    { case 2:  Print_Message = Print_Text2; Message_Color = (DWORD)Font2_ColorW; break;
      case 3:  Print_Message = Print_Text3; Message_Color = (DWORD)Font3_ColorW; break;
      default: Print_Message = Print_Text1; Message_Color = MAKELONG(Font1_Color1W, Font1_Color2W); break; }
  }

  // graphics
  if      (GetPrivateProfileInt(graphic, "Force 555", 0, Conf_File)) Force_Mode = 1;
  else if (GetPrivateProfileInt(graphic, "Force 565", 0, Conf_File)) Force_Mode = 0;
  else                                                               Force_Mode = 2;

  RMax_Level       = GetPrivateProfileInt(graphic, "Red Max", 255, Conf_File);
  GMax_Level       = GetPrivateProfileInt(graphic, "Green Max", 255, Conf_File);
  BMax_Level       = GetPrivateProfileInt(graphic, "Blue Max", 255, Conf_File);
  Contrast_Level   = GetPrivateProfileInt(graphic, "Contrast", 100, Conf_File);
  Brightness_Level = GetPrivateProfileInt(graphic, "Brightness", 100, Conf_File);
  Greyscale        = GetPrivateProfileInt(graphic, "Greyscale", 0, Conf_File);
  Invert_Color     = GetPrivateProfileInt(graphic, "Invert", 0, Conf_File);

  Recalculate_Palettes();

  Full_Screen = GetPrivateProfileInt(graphic, "Full Screen", 0, Conf_File);
  Res_X       = GetPrivateProfileInt(graphic, "Full Screen Res X", 640, Conf_File);
  Res_Y       = GetPrivateProfileInt(graphic, "Full Screen Res Y", 480, Conf_File);
  VSync_FS    = GetPrivateProfileInt(graphic, "Full Screen VSync", 0, Conf_File);
  VSync_W     = GetPrivateProfileInt(graphic, "Window VSync", 0, Conf_File);
  Render_W    = GetPrivateProfileInt(graphic, "Render Windowed", 0, Conf_File);
  Render_FS   = GetPrivateProfileInt(graphic, "Render Fullscreen", 1, Conf_File);

  Stretch_W   = GetPrivateProfileInt(graphic, "Window Stretch", 1, Conf_File); //MK2k: Window stretch on per default
  Stretch_FS  = GetPrivateProfileInt(graphic, "Full Screen Stretch", 0, Conf_File);
  Blit_Soft   = GetPrivateProfileInt(graphic, "Software Blit", 0, Conf_File);
  Sprite_Over = GetPrivateProfileInt(graphic, "Sprite limit", 1, Conf_File);
  Frame_Skip  = GetPrivateProfileInt(graphic, "Frame skip", -1, Conf_File);
  Fast_Blur   = GetPrivateProfileInt(graphic, "Fast Blur", 0, Conf_File);
  Device_FS   = GetPrivateProfileInt(graphic, "Full Screen Device", GDEVICE_DDRAW, Conf_File);
  Device_W    = GetPrivateProfileInt(graphic, "Window Device", GDEVICE_DDRAW, Conf_File);

  Set_Render(ghWnd, Full_Screen, -1, -1, TRUE);

  // sound
  Sound_Rate         = GetPrivateProfileInt(sound, "Rate", 22050, Conf_File);
  Sound_Stereo       = GetPrivateProfileInt(sound, "Stereo", 1, Conf_File);
  Sound_Volume       = GetPrivateProfileInt(sound, "Volume", 100, Conf_File);
  Use_LowPass_Filter = GetPrivateProfileInt(sound, "Use Lowpass Filter", 0, Conf_File);
  Sound_Echo         = GetPrivateProfileInt(sound, "Echo", 0, Conf_File);

  if (GetPrivateProfileInt(sound, "Z80 State", 1, Conf_File)) Z80_State |= 1;
  else Z80_State &= ~1;

  res = 0;
  new_val = GetPrivateProfileInt(sound, "State", 1, Conf_File);
  if (new_val != Sound_Enable)
  { if (Change_Sound(ghWnd)) res = 1; }
  else res = 1;
  if (res)
  {
    YM2612_Enable = GetPrivateProfileInt(sound, "YM2612 State", 1, Conf_File);
    PSG_Enable    = GetPrivateProfileInt(sound, "PSG State", 1, Conf_File);
    DAC_Enable    = GetPrivateProfileInt(sound, "DAC State", 1, Conf_File);
    PCM_Enable    = GetPrivateProfileInt(sound, "PCM State", 1, Conf_File);
    PWM_Enable    = GetPrivateProfileInt(sound, "PWM State", 1, Conf_File);
    CDDA_Enable   = GetPrivateProfileInt(sound, "CDDA State", 1, Conf_File);
  }

  YM2612_Improv = GetPrivateProfileInt(sound, "YM2612 Improvement", 0, Conf_File);
  DAC_Improv    = GetPrivateProfileInt(sound, "DAC Improvement", 0, Conf_File);
  PSG_Improv    = GetPrivateProfileInt(sound, "PSG Improvement", 0, Conf_File);
  YM2612_Enable_SSGEG = GetPrivateProfileInt(sound, "YM2612 SSGEG", 0, Conf_File);

  // CPU
  Country          = GetPrivateProfileInt(cpu, "Country", -1, Conf_File);
  Country_Order[0] = GetPrivateProfileInt(cpu, "Prefered Country 1", 0, Conf_File);
  Country_Order[1] = GetPrivateProfileInt(cpu, "Prefered Country 2", 1, Conf_File);
  Country_Order[2] = GetPrivateProfileInt(cpu, "Prefered Country 3", 2, Conf_File);

  SegaCD_Accurate = GetPrivateProfileInt(cpu, "Perfect Synchro", 0, Conf_File);

  MSH2_Speed = GetPrivateProfileInt(cpu, "Main SH2 Speed", 100, Conf_File);
  SSH2_Speed = GetPrivateProfileInt(cpu, "Slave SH2 Speed", 100, Conf_File);

  if(MSH2_Speed < 0) MSH2_Speed = 0;
  if(SSH2_Speed < 0) SSH2_Speed = 0;

  Check_Country_Order();

  CUR_DEV       = GetPrivateProfileInt(system, "CD Drive", 0, Conf_File);
  BRAM_Ex_Size  = GetPrivateProfileInt(system, "Ram Cart Size", 3, Conf_File);

  if(BRAM_Ex_Size == -1)
  {
    BRAM_Ex_State &= 1;
    BRAM_Ex_Size = 0;
  }
  else BRAM_Ex_State |= 0x100;

  // Master System
  SMS_Bright_Palette = GetPrivateProfileInt(sms, "Use bright palette", 1, Conf_File);
  SMS_YM2413_Enable  = GetPrivateProfileInt(sms, "Enable YM2413", 1, Conf_File);
  SMS_YM2413_Quality = GetPrivateProfileInt(sms, "YM2413 high quality", 0, Conf_File);

  Load_Control_Config(Conf_File);
  Load_Fonts_From_File(NULL, FALSE);

  Make_IO_Table();
  DestroyMenu(ghMenu);

  if (Full_Screen) Build_Main_Menu();
  else SetMenu(ghWnd, Build_Main_Menu());    // Update new menu

  return 1;
}

#define GET_CONTROL_CONFIG_ITEM(item, sufix)      \
          sprintf(buf, "P%s.%s", prefix[i], sufix); \
          item = GetPrivateProfileInt(input, buf, item, File_Name);

void __stdcall Load_Control_Config(LPCSTR File_Name)
{
  const char prefix[8][4] = { "1", "2", "1B", "1C", "1D", "2B", "2C", "2D" };
  const char input[] = "Input";
  char buf[32];
  int i;

  for(i = 0; i < 8; i++)
  {
    GET_CONTROL_CONFIG_ITEM(Control[i].Type, "Type");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Up, "Up");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Down, "Down");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Left, "Left");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Right, "Right");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Start, "Start");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].A, "A");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].B, "B");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].C, "C");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Mode, "Mode");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].X, "X");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Y, "Y");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Z, "Z");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].Rewind, "Rewind"); //MK2k: Added Key Profile
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[0], "HotKey1");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[1], "HotKey2");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[2], "HotKey3");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey[3], "HotKey4");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[0], "HotKey Buttons1");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[1], "HotKey Buttons2");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[2], "HotKey Buttons3");
    GET_CONTROL_CONFIG_ITEM(Keys_Def[i].HotKey_Buttons[3], "HotKey Buttons4");
  }
}

int Load_As_Config(HWND hWnd, void *Game_Active)
{
  char Name[2048];
  OPENFILENAME ofn;

  SetCurrentDirectory(Gens_Path);

  strcpy(Name, "gens.ini");
  memset(&ofn, 0, sizeof(OPENFILENAME));

  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner       = hWnd;
  ofn.hInstance       = ghInstance;
  ofn.lpstrFile       = Name;
  ofn.nMaxFile        = 2047;
  ofn.lpstrFilter     = "Configuration files (*.ini)\0*.ini\0All files (*.*)\0*.*\0\0";
  ofn.nFilterIndex    = 1;
  ofn.lpstrInitialDir = Gens_Path;
  ofn.lpstrDefExt     = "cfg";
  ofn.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;

  if(GetOpenFileName(&ofn))
  {
    Load_Config(Name, Game_Active);
    strcpy(Str_Tmp, "config loaded from ");
    strcat(Str_Tmp, Name);
    Put_Info(Str_Tmp, 2000);
    return 1;
  }
  else return 0;
}

/* l a seo "Application" do arquivo de configurao, se o arquivo for compatvel,
   retorna TRUE */
BOOL Check_Config_File(LPCSTR lpCfgFile)
{
  char  pszAppName[16];
  char  pszAppVer[64];
  LPSTR pszTmp;
  DWORD pdwVer[4];
  int   i, l, c, v;

  GetPrivateProfileString("Application", "Name", ".", pszAppName, 16, lpCfgFile);
  if(strcmpi(pszAppName, GENSNAME)) return FALSE;
  
  GetPrivateProfileString("Application", "Version", ".", pszAppVer, 64, lpCfgFile);
  memset(pdwVer, 0xFF, sizeof(pdwVer));
  v = l = 0;
  pszTmp = pszAppVer;
  for(i = 0; i < 64; i++)
  {
    c = pszAppVer[i];
    if(c == '.' || c == ',' || !c)
    {
      if(l)
      {
        pszAppVer[i] = 0;
        if(!Str2Int(pszTmp, pdwVer + (v++))) break;
        l = 0;
        pszTmp = pszAppVer + i + 1;
        if(v > 3) break;
      }
      if(!c) break;
    }
    else l++;
  }

  return TRUE;
}
