
#ifndef SAVE_H_
#define SAVE_H_

#include <windows.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define GENESIS_STATE_FILE_LENGHT    0x22478
#define GENESIS_STATE_FILE_LENGHT_EX 0x25550
#define SEGACD_STATE_FILE_LENGHT     (0x22500 + 0xE0000)
#define G32X_STATE_FILE_LENGHT       (0x22500 + 0x82A00)
#define SCD32X_STATE_FILE_LENGHT     (0x22500 + 0xE0000 + 0x82A00)
#define MAX_STATE_FILE_LENGHT        SCD32X_STATE_FILE_LENGHT
extern  BYTE State_Buffer[MAX_STATE_FILE_LENGHT];

#define MINISHOT_ID                  0x00534D47
#define MINISHOT_SX                  80
#define MINISHOT_SY                  60
#define MINISHOT_SIZE                (MINISHOT_SX * MINISHOT_SY * 2)
extern  BYTE  MiniShot_Data[MINISHOT_SIZE + 4];
extern  DWORD MiniShot_ID;
extern  WORD  MiniShot_Buffer[MINISHOT_SIZE / 2];

int    Change_File_S(LPSTR Dest, LPSTR Dir, LPSTR Titre, LPSTR Filter, LPSTR Ext);
int    Change_File_L(LPSTR Dest, LPSTR Dir, LPSTR Titre, LPSTR Filter, LPSTR Ext);
HANDLE Get_State_File(void);
void   Get_State_File_Name(LPSTR name);
int    Load_State(LPSTR Name);
int    Save_State(LPSTR Name);
void   Import_Genesis(LPBYTE Data);
void   Export_Genesis(LPBYTE Data);
void   Import_SegaCD(LPBYTE Data);
void   Export_SegaCD(LPBYTE Data);
void   Import_32X(LPBYTE Data);
void   Export_32X(LPBYTE Data);
int    Load_SRAM(void);
int    Save_SRAM(void);
int    Load_BRAM(void);
int    Save_BRAM(void);
void   Format_Backup_Ram(void);

void allocate_Memstates(int maxnumstates);
void free_Memstates();
void save_Memstate();
int load_Memstate();
int Load_Memstate(BYTE *memBuf);
int Save_Memstate(BYTE *memBuf);

//MK2k
extern int numMemstates;
extern int memstateSize;
extern int memstateAllocated;

struct Memstate
{
	int hasData;
	BYTE *buf;
	struct Memstate *prev;
	struct Memstate *next;
};

extern struct Memstate *ptr_Memstates, *prev_Memstate, *next_Memstate;

void writeLog(char *cText);
void allocate_Memstates(int datasize);
void free_Memstates();
void save_Memstate();
int load_Memstate();
int Load_Memstate(BYTE *memBuf);
int Save_Memstate(BYTE *memBuf);

#ifdef __cplusplus
};
#endif

#endif