
#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include <string.h>
#include "gens.h"
#include "gmain.h"
#include "gmenu.h"
#include "ggraphic.h"
#include "gddraw.h"
#include "ggdi.h"
#include "gdsound.h"
#include "gdinput.h"
#include "Debug.h"
#include "grom.h"
#include "state.h"
#include "resource.h"
#include "misc.h"
#include "blit.h"
#include "ggenie.h"
#include "Cpu_68k.h"
#include "Star_68k.h"
#include "Cpu_SH2.h"
#include "Cpu_Z80.h"
#include "z80.h"
#include "mem_M68K.h"
#include "mem_S68K.h"
#include "mem_SH2.h"
#include "mem_Z80.h"
#include "gio.h"
#include "psg.h"
#include "ym2612.h"
#include "pwm.h"
#include "vdp_io.h"
#include "vdp_rend.h"
#include "vdp_32X.h"
#include "LC89510.h"
#include "gfx_cd.h"
#include "cd_aspi.h"
#include "net.h"
#include "pcm.h"
#include "htmlhelp.h"
#include "CCnet.h"
#include "wave.h"
#include "cheatproc.h"
#include "vgm.h"
#include "sgm.h"
#include "giflib.h"
#include "sms.h"
#include "movie.h"

extern "C" void Read_To_68K_Space(int adr);

HINSTANCE  ghInstance;
HACCEL     hAccelTable;
WNDCLASS   WndClass;
HWND       ghWnd;
const char gWndTitle[] = "Gens+ REWiND! - Idle"; //MK2k

char Str_Tmp      [1024];
char Gens_Path    [GMAX_PATH];
char Language_Path[GMAX_PATH];

LPSTR *language_name = NULL;

LPGROM_INFO Game = NULL;
int Active = 0;
int Paused = 0;
int A_Paused = 0;
int Net_Play = 0;
int FS_Minimised = 0;
int Language = 0;
int Country = -1;
int Country_Order[3];
int Kaillera_Client_Running = 0;
int SegaCD_Accurate = 0;
int Gens_Running = 0;
int WinNT_Flag = 0;
int Gens_Priority;
int Turbo_Mode = 0;

POINT Window_Pos;

LRESULT WINAPI WinProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK GGenieProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ColorProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK DirectoriesProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK FilesProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ControllerProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK HotkeysProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK OptionProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK AboutProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK CheatsProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK SearchValueProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK RomInfoProc(HWND, UINT, WPARAM, LPARAM);


void Set_Title(LPCSTR lpSystem, LPCSTR lpRom)
{
  char pszTmp[256];
  if(!lpRom) lpRom = "No rom";
  if(lpSystem) sprintf(pszTmp, "%s - [%s: %s]", GENSTITLE, lpSystem, lpRom);
  else         sprintf(pszTmp, "%s - [%s]", GENSTITLE, lpRom);
  SetWindowText(ghWnd, pszTmp);
}


int Set_Render(HWND hWnd, int Num, bool Force);

int Change_VSync(HWND hWnd)
{
  int *p_vsync;

  if(Full_Screen)
  {
    End_Graphics_FS();
    p_vsync = &VSync_FS;
  }
  else p_vsync = &VSync_W;

  *p_vsync = 1 - *p_vsync;

  if(*p_vsync) MESSAGE_L("Vertical Sync Enabled", "Vertical Sync Enabled", 2000)
  else MESSAGE_L("Vertical Sync Disabled", "Vertical Sync Disabled", 2000)

  Build_Main_Menu();
  if(Full_Screen) return Init_Graphics_FS(ghWnd);
  else return 1;
}


void Set_Frame_Skip(HWND hWnd, int Num)
{
  Frame_Skip = Num;

  if(Frame_Skip != -1)
    MESSAGE_NUM_L("Frame skip set to %d", "Frame skip set to %d", Frame_Skip, 2000)
  else
    MESSAGE_L("Frame skip set to Auto", "Frame skip set to Auto", 2000)

  Build_Main_Menu();
}


void Switch_Turbo_Mode(void)
{
	Turbo_Mode = !Turbo_Mode;

  if(Turbo_Mode)
    MESSAGE_L("Turbo Mode Enabled", "Turbo mode enabled", 2000)
  else
    MESSAGE_L("Turbo Mode Disabled", "Turbo mode disabled", 2000)

  Build_Main_Menu();
}


void Set_Current_State(HWND hWnd, int Num)
{
  HANDLE f;
  DWORD  d;

  Current_State = Num;
  f = Get_State_File();
  if(f != INVALID_HANDLE_VALUE)
  {
    MiniShot_ID = 0;
    SetFilePointer(f, -(int)sizeof(MiniShot_Data), NULL, FILE_END);
    if(ReadFile(f, MiniShot_Data, sizeof(MiniShot_Data), &d, NULL))
    {
      if(d == sizeof(MiniShot_Data) && MiniShot_ID == MINISHOT_ID)
      { Show_MiniShot(3000); }
    }
    CloseHandle(f);
    MESSAGE_NUM_L("SLOT %d [OCCUPIED]", "SLOT %d [OCCUPIED]", Current_State, 3000);
  }
  else
  {
    MESSAGE_NUM_L("SLOT %d [EMPTY]", "SLOT %d [EMPTY]", Current_State, 3000);
    Erase_MiniShot();
  }

  Build_Main_Menu();
}


int Change_Stretch(void)
{
  LPINT pst;

  pst = Full_Screen ? &Stretch_FS : &Stretch_W;

  Flag_Clr_Scr = 1;

  if(*pst = !*pst)
    MESSAGE_L("Stretched mode", "Stretched mode", 2000)
  else
    MESSAGE_L("Correct ratio mode", "Correct ratio mode", 2000)

  Build_Main_Menu();
  return(1);
}


int Change_Blit_Style(void)
{
  if((!Full_Screen) || (Render_FS > 1)) return(0);

  Flag_Clr_Scr = 1;

  if(Blit_Soft = (1 - Blit_Soft))
    MESSAGE_L("Force software blit for Full-Screen", "Force software blit for Full-Screen", 2000)
  else
    MESSAGE_L("Enable hardware blit for Full-Screen", "Enable hardware blit for Full-Screen", 2000)

  return(1);
}


int Set_Sprite_Over(HWND hWnd, int Num)
{
  if(Sprite_Over = Num)
    MESSAGE_L("Sprite Limit Enabled", "Sprite Limit Enabled", 2000)
  else
    MESSAGE_L("Sprite Limit Disabled", "Sprite Limit Disabled", 2000)

  Build_Main_Menu();

  return 1;
}


int Change_Debug(HWND hWnd, int Debug_Mode)
{
  if(!Game) return 0;

  Flag_Clr_Scr = 1;
  Clear_Sound_Buffer();

  if(Debug_Mode == Debug) Debug = 0;
  else Debug = Debug_Mode;

  Build_Main_Menu();
  return 1;
}


int Change_Fast_Blur(HWND hWnd)
{
  Flag_Clr_Scr = 1;

  if(Fast_Blur = (1 - Fast_Blur))
    MESSAGE_L("Fast Blur Enabled", "Fast Blur Enabled", 2000)
  else
    MESSAGE_L("Fast Blur Disabled", "Fast Blur Disabled", 2000)

  Build_Main_Menu();

  return 1;
}


int __stdcall Set_Render(HWND hWnd, int Full, int Device, int Num, int Force)
{
  int  Old_Rend, *Rend, Old_Dev;
  void (**Blit)(unsigned char*, int, int, int, int);

  if(Full)
  {
    Rend    = &Render_FS;
    Blit    = &Blit_FS;
    Old_Dev = Device_FS;
  }
  else
  {
    Rend    = &Render_W;
    Blit    = &Blit_W;
    Old_Dev = Device_W;
  }

  Old_Rend = *Rend;
  Flag_Clr_Scr = 1;

  switch(Num)
  {
    case -1:
      switch(Old_Rend)
      {
        case 0:
          if(Have_MMX) *Blit = Blit_X1_MMX;
          else         *Blit = Blit_X1;
          break;

        case 1:
          if(Have_MMX) *Blit = Blit_X2_MMX;
          else         *Blit = Blit_X2;
          break;

        case 2:
          if(Have_MMX) *Blit = Blit_X2_Int_MMX;
          else         *Blit =  Blit_X2_Int;
          break;

        case 3:
          if(Have_MMX) *Blit = Blit_Scanline_MMX;
          else         *Blit = Blit_Scanline;
          break;

        case 4:
          if(Have_MMX) *Blit = Blit_Scanline_Int_MMX;
          else         *Blit = Blit_Scanline_Int;
          break;

        case 5:
          if(Have_MMX) *Blit = Blit_Scale2x_MMX;
          else         *Blit = Blit_Scale2x;
          break;

        case 6:
          if(Have_MMX) *Blit = Blit_Scanline_50_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 7:
          if(Have_MMX) *Blit = Blit_Scanline_25_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 8:
          if(Have_MMX) *Blit = Blit_Scanline_50_Int_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 9:
          if(Have_MMX) *Blit = Blit_Scanline_25_Int_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 10:
          if(Have_MMX) *Blit = Blit_2xSAI_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 11:
          if(Have_MMX) *Blit = Blit_Super2xSAI_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 12:
          if(Have_MMX) *Blit = Blit_2xSuperEagle_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 13:
          if(Have_MMX) *Blit = Blit_HQ2x_MMX;
          else       { *Rend = 1; *Blit = Blit_X2; }
          break;

        case 14:
          if(!Full || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
          {
            if(Have_MMX) *Blit = Blit_X3_MMX;
            else         *Blit = Blit_X3;
          }
          break;

        case 15:
          if(!Full || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
          {
            if(Have_MMX) *Blit = Blit_X3_Int;
            else         *Blit = Blit_X3_Int;
          }
          break;

        case 16:
          if(!Full || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
          {
            if(Have_MMX) *Blit = Blit_Scale3x;
            else         *Blit = Blit_Scale3x;
          }
          break;

        case 17:
          if(!Full || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
          {
            if(Have_MMX) *Blit = Blit_HQ2x_MMX;
            else       { *Rend = 1; *Blit = Blit_X2; }
          }
          break;

        default:
          *Rend = 1;
          if(Have_MMX) *Blit = Blit_X2_MMX;
          else *Blit = Blit_X2;
          break;
      }
      break;

    case 0:
      *Rend = 0;
      if(Have_MMX) *Blit = Blit_X1_MMX;
      else         *Blit = Blit_X1;
      MESSAGE_L("Render: NORMAL", "Render: NORMAL", 2500)
      break;

    case 1:
      *Rend = 1;
      if(Have_MMX) *Blit = Blit_X2_MMX;
      else         *Blit = Blit_X2;
      MESSAGE_L("Render: DOUBLE", "Render: DOUBLE", 2500)
      break;

    case 2:
      *Rend = 2;
      if(Have_MMX) *Blit = Blit_X2_Int_MMX;
      else         *Blit = Blit_X2_Int;
      MESSAGE_L("Render: INTERPOLATED", "Render: INTERPOLATED", 2500)
      break;

    case 3:
      *Rend = 3;
      if(Have_MMX) *Blit = Blit_Scanline_MMX;
      else         *Blit = Blit_Scanline;
      MESSAGE_L("Render: FULL SCANLINE", "Render: FULL SCANLINE", 2500)
      break;

    case 4:
      *Rend = 4;
      if(Have_MMX) *Blit = Blit_Scanline_Int_MMX;
      else         *Blit = Blit_Scanline_Int;
      MESSAGE_L("Render: INTERPOLATED SCANLINE", "Render: INTERPOLATED SCANLINE", 2500)
      break;

    case 5:
      *Rend = 5;
      if(Have_MMX) *Blit = Blit_Scale2x_MMX;
      else         *Blit = Blit_Scale2x;
      MESSAGE_L("Render: SCALE 2X", "Render: SCALE 2X", 2500)
      break;

    case 6:
      if(Have_MMX)
      {
        *Rend = 6;
        *Blit = Blit_Scanline_50_MMX;
        MESSAGE_L("Render: 50% SCANLINE", "Render: 50% SCANLINE", 2500)
      }
      break;

    case 7:
      if(Have_MMX)
      {
        *Rend = 7;
        *Blit = Blit_Scanline_25_MMX;
        MESSAGE_L("Render: 25% SCANLINE", "Render: 25% SCANLINE", 2500)
      }
      break;

    case 8:
      if(Have_MMX)
      {
        *Rend = 8;
        *Blit = Blit_Scanline_50_Int_MMX;
        MESSAGE_L("Render: INTERPOLATED 50% SCANLINE", "Render: INTERPOLATED 50% SCANLINE", 2500)
      }
      break;

    case 9:
      if(Have_MMX)
      {
        *Rend = 9;
        *Blit = Blit_Scanline_25_Int_MMX;
        MESSAGE_L("Render: INTERPOLATED 25% SCANLINE", "Render: INTERPOLATED 25% SCANLINE", 2500)
      }
      break;

    case 10:
      if(Have_MMX)
      {
        *Rend = 10;
        *Blit = Blit_2xSAI_MMX;
        MESSAGE_L("Render: KREED 2XSAI", "Render: KREED 2XSAI", 2500)
      }
      break;

    case 11:
      if(Have_MMX)
      {
        *Rend = 11;
        *Blit = Blit_Super2xSAI_MMX;
        MESSAGE_L("Render: KREED SUPER 2XSAI", "Render: KREED SUPER 2XSAI", 2500)
      }
      break;

    case 12:
      if(Have_MMX)
      {
        *Rend = 12;
        *Blit = Blit_2xSuperEagle_MMX;
        MESSAGE_L("Render: KREED SUPEREAGLE", "Render: KREED SUPEREAGLE", 2500)
      }
      break;

    case 13:
      if(Have_MMX)
      {
        *Rend = 13;
        *Blit = Blit_HQ2x_MMX;
        MESSAGE_L("Render: HQ2X", "Render: HQ2X", 2500)
      }
      break;

    case 14:
      if(!Full_Screen || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
      {
        *Rend = 14;
        if(Have_MMX) *Blit = Blit_X3_MMX;
        else         *Blit = Blit_X3;
        MESSAGE_L("Render: TRIPLE", "Render: TRIPLE", 2500)
      }
      break;

    case 15:
      if(!Full_Screen || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
      {
        *Rend = 15;
        if(Have_MMX) *Blit = Blit_X3_Int;
        else         *Blit = Blit_X3_Int;
        MESSAGE_L("Render: INTERPOLATED3X", "Render: INTERPOLATED3X", 2500)
      }
      break;

    case 16:
      if(!Full_Screen || (Res_X >= (320 * 3) && Res_Y >= (240 * 3)))
      {
        *Rend = 16;
        *Blit = Blit_Scale3x;
        MESSAGE_L("Render: SCALE3X", "Render: SCALE3X", 2500)
      }
      break;

    case 17:
      if((!Full_Screen || (Res_X >= (320 * 3) && Res_Y >= (240 * 3))) && Have_MMX)
      {
        *Rend = 17;
        *Blit = Blit_HQ3x_MMX;
        MESSAGE_L("Render: HQ3X", "Render: HQ3X", 2500)
      }
      break;

    default:
      *Rend = 1;
      if(Have_MMX) *Blit = Blit_X2_MMX;
      else *Blit = Blit_X2;
      MESSAGE_L("Render: DOUBLE", "Render: DOUBLE", 2500)
      break;
  }

  if(Device == -1) Device = Old_Dev;

  if(Full != Full_Screen || Num < 2 || Old_Rend < 2 || Old_Dev != Device || Force)
  {
    RECT r;

    if(Full_Screen) End_Graphics_FS();
    else            End_Graphics_W();

    if(Sound_Initialised) Clear_Sound_Buffer();

    if(Full_Screen = Full)
    {
      while(ShowCursor(TRUE) < 1);
      while(ShowCursor(FALSE) >= 0);

      if(Device == GDEVICE_D3D)
      {
        Device_FS = GDEVICE_D3D;
        Init_Graphics_FS         = Init_D3D;
        End_Graphics_FS          = End_D3D;
        Flip_FS                  = Flip_D3D_FS;
        Clear_Primary_Screen_FS  = Clear_D3D_Primary_Screen;
        Clear_Back_Screen_FS     = Clear_D3D_Back_Screen;
        Restore_Primary          = Restore_D3D_Primary;
      }
      else
      {
        Device_FS = GDEVICE_DDRAW;
        Init_Graphics_FS         = Init_DDraw;
        End_Graphics_FS          = End_DDraw;
        Flip_FS                  = Flip_DDraw_FS;
        Clear_Primary_Screen_FS  = Clear_DDraw_Primary_Screen;
        Clear_Back_Screen_FS     = Clear_DDraw_Back_Screen;
        Restore_Primary          = Restore_DDraw_Primary;
      }

      SetWindowPos(hWnd, NULL, 0, 0, 320 * ( *Rend ? (*Rend < 14 ? 2 : 3) : 1),
        240 * ( *Rend ? (*Rend < 14 ? 2 : 3) : 1), SWP_NOZORDER | SWP_NOACTIVATE);
      SetWindowLong(hWnd, GWL_STYLE, NULL);
      Init_Graphics_FS(ghWnd);
    }
    else
    {
      DEVMODE dm;

      memset(&dm, 0, sizeof(DEVMODE));
      dm.dmSize = sizeof(DEVMODE);
      dm.dmBitsPerPel = 16; //MK2k: Keep 16bit per pixel (full screen didn't work with 32bitPP)
		  //dm.dmBitsPerPel = 32;	//MK2k: Set to 32bits per pixel in order to avoid display mode change upon start
      dm.dmFields = DM_BITSPERPEL;

      ChangeDisplaySettings(&dm, 0);

      while(ShowCursor(FALSE) >= 0);
      while(ShowCursor(TRUE) < 1);

      if(Device == GDEVICE_GDI) // GDI
      {
        Device_W = GDEVICE_GDI;
        Init_Graphics_W         = Init_GDI;
        End_Graphics_W          = End_GDI;
        Flip_W                  = Flip_GDI;
        Clear_Primary_Screen_W  = Clear_GDI_Primary_Screen;
        Clear_Back_Screen_W     = Clear_GDI_Back_Screen;
      }
      else if(Device == GDEVICE_DDRAW) // DDRAW
      {
        Device_W = GDEVICE_DDRAW;
        Init_Graphics_W         = Init_DDraw;
        End_Graphics_W          = End_DDraw;
        Flip_W                  = Flip_DDraw_W;
        Clear_Primary_Screen_W  = Clear_DDraw_Primary_Screen;
        Clear_Back_Screen_W     = Clear_DDraw_Back_Screen;
      }
      else if(Device == GDEVICE_D3D)
      {
        Device_W = GDEVICE_D3D;
        Init_Graphics_W         = Init_D3D;
        End_Graphics_W          = End_D3D;
        Flip_W                  = Flip_D3D_W;
        Clear_Primary_Screen_W  = Clear_D3D_Primary_Screen;
        Clear_Back_Screen_W     = Clear_D3D_Back_Screen;
      }

      SetWindowLong(hWnd, GWL_STYLE, GetWindowLong(hWnd, GWL_STYLE) | WS_OVERLAPPEDWINDOW);
      SetRect(&r, 0, 0, 320 * ( *Rend ? (*Rend < 14 ? 2 : 3) : 1),
        240 * ( *Rend ? (*Rend < 14 ? 2 : 3) : 1));
      AdjustWindowRectEx(&r, GetWindowLong(hWnd, GWL_STYLE), 1, GetWindowLong(hWnd, GWL_EXSTYLE));
      SetWindowPos(hWnd, NULL, Window_Pos.x, Window_Pos.y, r.right - r.left, r.bottom - r.top, SWP_NOZORDER | SWP_NOACTIVATE);
      Init_Graphics_W(ghWnd);
    }

    Build_Main_Menu();
  }

  Build_Main_Menu();

  return 1;
}


int Set_Resolution(int x, int y)
{
  char msg[64];
  int  rend;

  if(x != Res_X || y != Res_Y)
  {
    if(Render_FS > 13 && ((x < 320 * 3) || (y < 240 * 3))) rend = 1;
    else rend = -1;
    Res_X = x; Res_Y = y;
    if(Full_Screen) Set_Render(ghWnd, Full_Screen, -1, rend, TRUE);
    Build_Main_Menu();
    sprintf(msg, "Screen resolution: %dx%d", x, y);
    Put_Info(msg, 2000);
  }
  return 0;
}


int Change_SegaCD_Synchro(void)
{
  if(SegaCD_Accurate)
  {
    SegaCD_Accurate = 0;

    if(SegaCD_Started)
    {
      Update_Frame = Do_SegaCD_Frame;
      Update_Frame_Fast = Do_SegaCD_Frame_No_VDP;
    }

    MESSAGE_L("SegaCD normal mode", "SegaCD normal mode", 2000)
  }
  else
  {
    SegaCD_Accurate = 1;

    if(SegaCD_Started)
    {
      Update_Frame = Do_SegaCD_Frame_Cycle_Accurate;
      Update_Frame_Fast = Do_SegaCD_Frame_No_VDP_Cycle_Accurate;
    }

    MESSAGE_L("SegaCD perfect synchro mode (SLOW)", "SegaCD perfect synchro mode (slower)", 2000)
  }

  Build_Main_Menu();

  return 1;
}


int Change_SegaCD_SRAM_Size(int num)
{
  if(num == -1)
  {
    BRAM_Ex_State &= 1;
    MESSAGE_L("SegaCD SRAM cart removed", "SegaCD SRAM cart removed", 2000)
  }
  else
  {
    char bsize[256];

    BRAM_Ex_State |= 0x100;
    BRAM_Ex_Size = num;

    sprintf(bsize, "SegaCD SRAM cart plugged (%d Kb)", 8 << num);
    MESSAGE_L(bsize, bsize, 2000)
  }

  Build_Main_Menu();

  return 1;
}


int Change_Z80(HWND hWnd)
{
  if(Z80_State & 1)
  {
    Z80_State &= ~1;
    MESSAGE_L("Z80 Disabled", "Z80 Disabled", 2000)
  }
  else
  {
    Z80_State |= 1;
    MESSAGE_L("Z80 Enabled", "Z80 Enabled", 2000)
  }

  Build_Main_Menu();

  return 1;
}


int Change_DAC(HWND hWnd)
{
  if(DAC_Enable)
  {
    DAC_Enable = 0;
    MESSAGE_L("DAC Disabled", "DAC Disabled", 2000)
  }
  else
  {
    DAC_Enable = 1;
    MESSAGE_L("DAC Enabled", "DAC Enabled", 2000)
  }

  Build_Main_Menu();

  return 1;
}


int Change_DAC_Improv(HWND hWnd)
{
  if(DAC_Improv)
  {
    DAC_Improv = 0;
    MESSAGE_L("Normal DAC sound", "Normal DAC sound", 2000)
  }
  else
  {
    DAC_Improv = 1;
    MESSAGE_L("Improved DAC sound (voices)", "Improved DAC sound (voices)", 2000)
  }

  Build_Main_Menu();

  return 1;
}


int Change_YM2612(HWND hWnd)
{
  if(YM2612_Enable)
  {
    YM2612_Enable = 0;
    MESSAGE_L("YM2612 Disabled", "YM2612 Disabled", 2000)
  }
  else
  {
    YM2612_Enable = 1;
    MESSAGE_L("YM2612 Enabled", "YM2612 Enabled", 2000)
  }

  Build_Main_Menu();

  return 1;
}


void Change_YM2612_Improv(HWND hWnd)
{
  BYTE Reg_1[0x200];

  if(YM2612_Improv)
  {
    YM2612_Improv = 0;
    MESSAGE_L("Normal YM2612 emulation", "Normal YM2612 emulation", 2000)
  }
  else
  {
    YM2612_Improv = 1;
    MESSAGE_L("High Quality YM2612 emulation", "High Quality YM2612 emulation", 2000)
  }

  YM2612_Save(Reg_1);

  if(CPU_Mode)
  {
    YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
  }
  else
  {
    YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
  }

  YM2612_Restore(Reg_1);
  Build_Main_Menu();
}

void Change_YM2612_SSGEG(HWND hWnd)
{
  if(YM2612_Enable_SSGEG)
  {
    YM2612_Enable_SSGEG = 0;
    MESSAGE_L("Disable YM2612 SSG-EG envelope", "Disable YM2612 SSG-EG envelope", 2000)
  }
  else
  {
    YM2612_Enable_SSGEG = 1;
    MESSAGE_L("Enable YM2612 SSG-EG envelope", "Enable YM2612 SSG-EG envelope", 2000)
  }
  Build_Main_Menu();
}


int Change_PSG(HWND hWnd)
{
  if(PSG_Enable)
  {
    PSG_Enable = 0;
    MESSAGE_L("PSG Disabled", "PSG Disabled", 2000)
  }
  else
  {
    PSG_Enable = 1;
    MESSAGE_L("PSG Enabled", "PSG Enabled", 2000)
  }

  Build_Main_Menu();
  return 1;
}


int Change_PSG_Improv(HWND hWnd)
{
  if(PSG_Improv)
  {
    PSG_Improv = 0;
    MESSAGE_L("Normal PSG sound", "Normal PSG sound", 2000)
  }
  else
  {
    PSG_Improv = 1;
    MESSAGE_L("Improved PSG sound", "Improved PSG sound", 2000)
  }

  return 1;
}


int Change_PCM(HWND hWnd)
{
  if(PCM_Enable)
  {
    PCM_Enable = 0;
    MESSAGE_L("PCM Sound Disabled", "PCM Sound Disabled", 2000)
  }
  else
  {
    PCM_Enable = 1;
    MESSAGE_L("PCM Sound Enabled", "PCM Sound Enabled", 2000)
  }

  Build_Main_Menu();
  return 1;
}


int Change_PWM(HWND hWnd)
{
  if(PWM_Enable)
  {
    PWM_Enable = 0;
    MESSAGE_L("PWM Sound Disabled", "PWM Sound Disabled", 2000)
  }
  else
  {
    PWM_Enable = 1;
    MESSAGE_L("PWM Sound Enabled", "PWM Sound Enabled", 2000)
  }

  Build_Main_Menu();
  return 1;
}


int Change_CDDA(HWND hWnd)
{
  if(CDDA_Enable)
  {
    CDDA_Enable = 0;
    MESSAGE_L("CD Audio Sound Disabled", "CD Audio Sound Disabled", 2000)
  }
  else
  {
    CDDA_Enable = 1;
    MESSAGE_L("CD Audio Enabled", "CD Audio Enabled", 2000)
  }

  Build_Main_Menu();
  return(1);
}


int Change_Sound(HWND hWnd)
{
  if(Sound_Enable)
  {
    End_Sound();

    Sound_Enable = 0;
    YM2612_Enable = 0;
    PSG_Enable = 0;
    DAC_Enable = 0;
    PCM_Enable = 0;
    PWM_Enable = 0;
    CDDA_Enable = 0;

    MESSAGE_L("Sound Disabled", "Sound Disabled", 2000)
  }
  else
  {
    if(!Init_Sound(hWnd))
    {
      Sound_Enable = 0;
      YM2612_Enable = 0;
      PSG_Enable = 0;
      DAC_Enable = 0;
      PCM_Enable = 0;
      PWM_Enable = 0;
      CDDA_Enable = 0;

      return 0;
    }

    Sound_Enable = 1;
    Play_Sound();

    if(!(Z80_State & 1)) Change_Z80(hWnd);

    YM2612_Enable = 1;
    PSG_Enable = 1;
    DAC_Enable = 1;
    PCM_Enable = 1;
    PWM_Enable = 1;
    CDDA_Enable = 1;

    MESSAGE_L("Sound Enabled", "Sound Enabled", 2000)
  }

  Build_Main_Menu();
  return 1;
}

void Change_Echo(void)
{
  if(Sound_Echo)
  {
    if(Echo_Buffer) { free(Echo_Buffer); Echo_Buffer = NULL; }
    Sound_Echo = 0;
    MESSAGE_L("Echo disabled", "Echo disabled", 2000);
  }
  else
  {
    if(!Echo_Buffer) Echo_Buffer = calloc(5513, 4);
    if(Echo_Buffer)
    {
      memset(Echo_Buffer, 0, 5513 * 4);
      Sound_Echo = 1;
      MESSAGE_L("Echo enabled", "Echo enabled", 2000);
    }
    else
    { MESSAGE_L("Error eco buffer", "Error on create echo buffer", 2000); }
  }
  Build_Main_Menu();
}

void Change_LowPass_Filter(void)
{
  if(Use_LowPass_Filter)
  { Use_LowPass_Filter = 0;
    MESSAGE_L("Low-pass filter disabled", "Low-pass filter disabled", 2000); }
  else
  { Use_LowPass_Filter = 1;
    MESSAGE_L("Low-pass filter enabled", "Low-pass filter enabled", 2000); }
  Build_Main_Menu();
}


int Change_Sample_Rate(HWND hWnd, int Rate)
{
  BYTE Reg_1[0x200];

  switch (Rate)
  {
  case 0:
    Sound_Rate = 11025;
    MESSAGE_L("Sound rate set to 11025", "Sound rate set to 11025", 2000)
    break;

  case 1:
    Sound_Rate = 22050;
    MESSAGE_L("Sound rate set to 22050", "Sound rate set to 22050", 2000)
    break;

  case 2:
    Sound_Rate = 44100;
    MESSAGE_L("Sound rate set to 44100", "Sound rate set to 44100", 2000)
    break;
  }

  if(Sound_Enable)
  {
    PSG_Save_State();
    YM2612_Save(Reg_1);

    End_Sound();
    Sound_Enable = 0;

    if(CPU_Mode)
    {
      YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_PAL / 15, Sound_Rate);
    }
    else
    {
      YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
    }

    if(SegaCD_Started) Set_Rate_PCM(Sound_Rate);
    YM2612_Restore(Reg_1);
    PSG_Restore_State();

    if(!Init_Sound(hWnd)) return 0;

    Sound_Enable = 1;
    Play_Sound();
  }

  Build_Main_Menu();

  return 1;
}

extern LPDIRECTSOUNDBUFFER lpDSBuffer;

int Change_Volume(HWND hWnd, int vol)
{
  char    szTmp[32];

  Sound_Volume = vol;
  sprintf(szTmp, "Sound Volume: %d", vol);
  Build_Main_Menu();
  MESSAGE_L(szTmp, szTmp, 2000);

  return 1;
}

int Change_Sound_Stereo(HWND hWnd)
{
  unsigned char Reg_1[0x200];

  if(Sound_Stereo)
  {
    Sound_Stereo = 0;
    MESSAGE_L("Mono sound", "Mono sound", 2000)
  }
  else
  {
    Sound_Stereo = 1;
    MESSAGE_L("Stereo sound", "Stereo sound", 2000)
  }

  if(Sound_Enable)
  {
    PSG_Save_State();
    YM2612_Save(Reg_1);

    End_Sound();
    Sound_Enable = 0;

    if(CPU_Mode)
    {
      YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_PAL / 15, Sound_Rate);
    }
    else
    {
      YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
    }

    if(SegaCD_Started) Set_Rate_PCM(Sound_Rate);
    YM2612_Restore(Reg_1);
    PSG_Restore_State();

    if(!Init_Sound(hWnd)) return(0);

    Sound_Enable = 1;
    Play_Sound();
  }

  Build_Main_Menu();
  return(1);
}


int Change_Country(HWND hWnd, int Num)
{
  unsigned char Reg_1[0x200];

  Flag_Clr_Scr = 1;

  switch(Country = Num)
  {
    default:
    case -1:
      if(Genesis_Started || _32X_Started) Detect_Country_Genesis();
      else if(SegaCD_Started) Detect_Country_SegaCD();
      break;

    case 0:
      Game_Mode = 0;
      CPU_Mode = 0;
      break;

    case 1:
      Game_Mode = 1;
      CPU_Mode = 0;
      break;

    case 2:
      Game_Mode = 1;
      CPU_Mode = 1;
      break;

    case 3:
      Game_Mode = 0;
      CPU_Mode = 1;
      break;
  }

  if(CPU_Mode)
  {
    CPL_Z80 = Round_Double((((double) CLOCK_PAL / 15.0) / 50.0) / 312.0);
    CPL_M68K = Round_Double((((double) CLOCK_PAL / 7.0) / 50.0) / 312.0);
    CPL_MSH2 = Round_Double(((((((double) CLOCK_PAL / 7.0) * 3.0) / 50.0) / 312.0) * (double) MSH2_Speed) / 100.0);
    CPL_SSH2 = Round_Double(((((((double) CLOCK_PAL / 7.0) * 3.0) / 50.0) / 312.0) * (double) SSH2_Speed) / 100.0);

    VDP_Num_Lines = 312;
    VDP_Status |= 0x0001;
    _32X_VDP.Mode &= ~0x8000;

    CD_Access_Timer = 2080;
    Timer_Step = 136752;
  }
  else
  {
    CPL_Z80 = Round_Double((((double) CLOCK_NTSC / 15.0) / 60.0) / 262.0);
    CPL_M68K = Round_Double((((double) CLOCK_NTSC / 7.0) / 60.0) / 262.0);
    CPL_MSH2 = Round_Double(((((((double) CLOCK_NTSC / 7.0) * 3.0) / 60.0) / 262.0) * (double) MSH2_Speed) / 100.0);
    CPL_SSH2 = Round_Double(((((((double) CLOCK_NTSC / 7.0) * 3.0) / 60.0) / 262.0) * (double) SSH2_Speed) / 100.0);

    VDP_Num_Lines = 262;
    VDP_Status &= 0xFFFE;
    _32X_VDP.Mode |= 0x8000;

    CD_Access_Timer = 2096;
    Timer_Step = 135708;
  }

  if(Sound_Enable)
  {
    PSG_Save_State();
    YM2612_Save(Reg_1);

    End_Sound();
    Sound_Enable = 0;

    if(CPU_Mode)
    {
      YM2612_Init(CLOCK_PAL / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_PAL / 15, Sound_Rate);
    }
    else
    {
      YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
      PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
    }

    if(SegaCD_Started) Set_Rate_PCM(Sound_Rate);
    YM2612_Restore(Reg_1);
    PSG_Restore_State();

    if(!Init_Sound(hWnd)) return(0);

    Sound_Enable = 1;
    Play_Sound();
  }

  if(Game_Mode)
  {
    if(CPU_Mode) MESSAGE_L("Europe system (50 FPS)", "Europe system (50 FPS)", 2000)
    else MESSAGE_L("USA system (60 FPS)", "USA system (60 FPS)", 2000)
  }
  else
  {
    if(CPU_Mode) MESSAGE_L("Japan system (50 FPS)", "Japan system (50 FPS)", 2000)
    else MESSAGE_L("Japan system (60 FPS)", "Japan system (60 FPS)", 2000)
  }

  if(Genesis_Started)
  {
    if((CPU_Mode == 1) || (Game_Mode == 0))
      Set_Title("MD", Rom_Name);
    else
      Set_Title("Genesis", Rom_Name);
  }
  else if(_32X_Started)
  {
    if(CPU_Mode == 1)
      Set_Title("32X (PALM)", Rom_Name);
    else
      Set_Title("32X (NTSC)", Rom_Name);
  }
  else if(SegaCD_Started)
  {
    if((CPU_Mode == 1) || (Game_Mode == 0))
      Set_Title("MegaCD", Rom_Name);
    else
      Set_Title("SegaCD", Rom_Name);
  }

  Build_Main_Menu();
  return 1;
}


int Change_Country_Order(int Num)
{
  char c_str[4][4] = {"USA", "JAP", "EUR"};
  char str_w[128];
  int sav = Country_Order[Num];

  if(Num == 1) Country_Order[1] = Country_Order[0];
  else if(Num == 2)
  {
    Country_Order[2] = Country_Order[1];
    Country_Order[1] = Country_Order[0];
  }
  Country_Order[0] = sav;

  if(Country == -1) Change_Country(ghWnd, -1);    // Update Country

  wsprintf(str_w, "Country detection order : %s %s %s", c_str[Country_Order[0]], c_str[Country_Order[1]], c_str[Country_Order[2]]);
  MESSAGE_L(str_w, str_w, 2000)

  Build_Main_Menu();

  return 1;
}


int Check_If_Kaillera_Running(void)
{
  if(Kaillera_Client_Running)
  {
    if(Sound_Initialised) Clear_Sound_Buffer();
    MessageBox(ghWnd, "You can't do it during netplay, you have to close rom and kaillera client before", "info", MB_OK);
    return 1;
  }

  return 0;
}


int WINAPI Play_Net_Game(char *game, int player, int maxplayers)
{
  MSG msg;
  char name[2048];
  HANDLE f;
  WIN32_FIND_DATA fd;

  SetCurrentDirectory(Rom_Dir);

  sprintf(name, "%s.*", game);
  memset(&fd, 0, sizeof(fd));
  fd.dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
  f = FindFirstFile(name, &fd);

  if(f == INVALID_HANDLE_VALUE) return 1;

  if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
  {
    sprintf(name, "%s%s", Rom_Dir, fd.cFileName);
    Pre_Load_Rom(ghWnd, name);
  }

  if((!Genesis_Started) && (!_32X_Started)) return 1;

  Net_Play = 1;
  SetFocus(ghWnd);

  if(maxplayers > 4) maxplayers = 4;
  if(player > 4) player = 0;

  Controller_1_Type &= 0xF;
  Controller_2_Type &= 0xF;
  if(maxplayers > 2) Controller_1_Type |= 0x10;
  Make_IO_Table();

  Kaillera_Keys[0] = Kaillera_Keys[1] = Kaillera_Keys[2] = Kaillera_Keys[3] = 0xFF;
  Kaillera_Keys[4] = Kaillera_Keys[5] = Kaillera_Keys[6] = Kaillera_Keys[7] = 0xFF;
  Kaillera_Keys[8] = Kaillera_Keys[9] = 0xFF;
  Kaillera_Error = 0;

  while (Net_Play)
  {
    if(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
    {
      if(!GetMessage(&msg, NULL, 0, 0)) return msg.wParam;
      if(!TranslateAccelerator (ghWnd, hAccelTable, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }
    else if((Active) && (!Paused))
    {
      Update_Emulation_Netplay(ghWnd, player, maxplayers);
    }
    else
    {
      Flip(ghWnd);
      Sleep(100);
    }
  }

  Kaillera_End_Game();

  return 0;
}


int Start_Netplay(void)
{
  kailleraInfos K_Infos;
  char name[2048];
  char *Liste_Games = NULL, *LG = NULL, *Min_Game, *Cur_Game;
  int cursize = 8192, num = 0, dep = 0, len;
  int backup_infos[32];
  HANDLE f;
  WIN32_FIND_DATA fd;

  if(Kaillera_Initialised == 0)
  {
    MessageBox(ghWnd, "You need the KAILLERACLIENT.DLL file to enable this feature", "Info", MB_OK);
    return 0;
  }

  if(Kaillera_Client_Running) return 0;

  SetCurrentDirectory(Rom_Dir);

  Liste_Games = (char *) malloc(cursize);
  Liste_Games[0] = 0;
  Liste_Games[1] = 0;

  memset(&fd, 0, sizeof(fd));
  fd.dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
  f = FindFirstFile("*.bin", &fd);
  if(f != INVALID_HANDLE_VALUE)
  {
    if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
      len = strlen(fd.cFileName) - 4;
      fd.cFileName[len++] = 0;
      if((dep + len) > cursize)
      {
        cursize += 8192;
        Liste_Games = (char*) realloc(Liste_Games, cursize);
      }
      strcpy(Liste_Games + dep, fd.cFileName);
      dep += len;
      num++;
    }

    while (FindNextFile(f, &fd))
    {
      if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
      {
        len = strlen(fd.cFileName) - 4;
        fd.cFileName[len++] = 0;
        if((dep + len) > cursize)
        {
          cursize += 8192;
          Liste_Games = (char*) realloc(Liste_Games, cursize);
        }
        strcpy(Liste_Games + dep, fd.cFileName);
        dep += len;
        num++;
      }
    }
  }

  memset(&fd, 0, sizeof(fd));
  fd.dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
  f = FindFirstFile("*.smd", &fd);
  if(f != INVALID_HANDLE_VALUE)
  {
    if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
      len = strlen(fd.cFileName) - 4;
      fd.cFileName[len++] = 0;
      if((dep + len) > cursize)
      {
        cursize += 8192;
        Liste_Games = (char*) realloc(Liste_Games, cursize);
      }
      strcpy(Liste_Games + dep, fd.cFileName);
      dep += len;
      num++;
    }

    while (FindNextFile(f, &fd))
    {
      if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
      {
        len = strlen(fd.cFileName) - 4;
        fd.cFileName[len++] = 0;
        if((dep + len) > cursize)
        {
          cursize += 8192;
          Liste_Games = (char*) realloc(Liste_Games, cursize);
        }
        strcpy(Liste_Games + dep, fd.cFileName);
        dep += len;
        num++;
      }
    }
  }

  memset(&fd, 0, sizeof(fd));
  fd.dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
  f = FindFirstFile("*.32X", &fd);
  if(f != INVALID_HANDLE_VALUE)
  {
    if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
      len = strlen(fd.cFileName) - 4;
      fd.cFileName[len++] = 0;
      if((dep + len) > cursize)
      {
        cursize += 8192;
        Liste_Games = (char*) realloc(Liste_Games, cursize);
      }
      strcpy(Liste_Games + dep, fd.cFileName);
      dep += len;
      num++;
    }

    while (FindNextFile(f, &fd))
    {
      if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
      {
        len = strlen(fd.cFileName) - 4;
        fd.cFileName[len++] = 0;
        if((dep + len) > cursize)
        {
          cursize += 8192;
          Liste_Games = (char*) realloc(Liste_Games, cursize);
        }
        strcpy(Liste_Games + dep, fd.cFileName);
        dep += len;
        num++;
      }
    }
  }

  memset(&fd, 0, sizeof(fd));
  fd.dwFileAttributes = FILE_ATTRIBUTE_ARCHIVE;
  f = FindFirstFile("*.zip", &fd);
  if(f != INVALID_HANDLE_VALUE)
  {
    if(!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
    {
      len = strlen(fd.cFileName) - 4;
      fd.cFileName[len++] = 0;
      if((dep + len) > cursize)
      {
        cursize += 8192;
        Liste_Games = (char*) realloc(Liste_Games, cursize);
      }
      strcpy(Liste_Games + dep, fd.cFileName);
      dep += len;
      num++;
    }

    while (FindNextFile(f, &fd))
    {
      if(!(fd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY))
      {
        len = strlen(fd.cFileName) - 4;
        fd.cFileName[len++] = 0;
        if((dep + len) > cursize)
        {
          cursize += 8192;
          Liste_Games = (char*) realloc(Liste_Games, cursize);
        }
        strcpy(Liste_Games + dep, fd.cFileName);
        dep += len;
        num++;
      }
    }
  }

  Liste_Games[dep] = 0;
  LG = (char*) malloc(dep);
  dep = 0;

  for(; num > 0; num--)
  {
    Min_Game = Cur_Game = Liste_Games;

    while(*Cur_Game)
    {
      if(stricmp(Cur_Game, Min_Game) < 0) Min_Game = Cur_Game;
      Cur_Game += strlen(Cur_Game) + 1;
    }

    strlwr(Min_Game);
    strcpy(LG + dep, Min_Game);
    dep += strlen(Min_Game) + 1;
    Min_Game[0] = -1;
  }

  GetWindowText(ghWnd, name, 2046);
  backup_infos[0] = Controller_1_Type;
  backup_infos[1] = Controller_2_Type;

  memset(&K_Infos, 0, sizeof(K_Infos));

  K_Infos.appName = "Gens 2.10";
  K_Infos.gameList = LG;
  K_Infos.gameCallback = Play_Net_Game;

//  K_Infos.chatReceivedCallback = NULL;
//  K_Infos.clientDroppedCallback = NULL;
//  K_Infos.moreInfosCallback = NULL;

  Kaillera_Set_Infos(&K_Infos);

  Kaillera_Client_Running = 1;
  Kaillera_Select_Server_Dialog(NULL);
  Kaillera_Client_Running = 0;

  Controller_1_Type = backup_infos[0];
  Controller_2_Type = backup_infos[1];
  Make_IO_Table();
  SetWindowText(ghWnd, name);

  free(Liste_Games);
  free(LG);

  return 1;
}


#ifdef CC_SUPPORT
void CC_End_Callback(char mess[256])
{
  MessageBox(ghWnd, mess, "Console Classix", MB_OK);

  if(Sound_Initialised) Clear_Sound_Buffer();
  Debug = 0;
  Free_Rom(Game);
  Build_Main_Menu();
}
#endif


BOOL Init(HINSTANCE hInst, int nCmdShow)
{
  int i;

  Net_Play          = 0;
  Full_Screen       = -1;
  VDP_Num_Vis_Lines = 224;
  Res_X             = 640;
  Res_Y             = 480;
  VSync_W           = 0;
  VSync_FS          = 0;
  Stretch_W         = 0;
  Stretch_FS        = 0;
  Sprite_Over       = 1;
  Render_W          = 0;
  Render_FS         = 0;
  Show_Message      = 1;

  Sound_Enable      = 0;
  Sound_Segs        = 8;
  Sound_Stereo      = 1;
  Sound_Initialised = 0;
  Sound_Is_Playing  = 0;
  WAV_Dumping       = 0;
  GYM_Dumping       = 0;

  FS_Minimised    = 0;
  Game            = NULL;
  Genesis_Started = 0;
  SegaCD_Started  = 0;
  _32X_Started    = 0;
  SMS_Started     = 0;
  Debug           = 0;
  CPU_Mode        = 0;
  Window_Pos.x    = 0;
  Window_Pos.y    = 0;

  WndClass.style         = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
  WndClass.lpfnWndProc   = WinProc;
  WndClass.cbClsExtra    = 0;
  WndClass.cbWndExtra    = 0;
  WndClass.hInstance     = hInst;
  WndClass.hIcon         = LoadIcon(hInst, MAKEINTRESOURCE(IDI_GENS00));
  WndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
  WndClass.hbrBackground = NULL;
  WndClass.lpszMenuName  = NULL;
  WndClass.lpszClassName = "GENS_CLASS";

  RegisterClass(&WndClass);

  ghInstance = hInst;

  ghWnd = CreateWindowEx(NULL, "GENS_CLASS", "", WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, CW_USEDEFAULT, 320 * 2, 240 * 2, NULL, NULL, hInst, NULL);
  if(!ghWnd) return FALSE;
  Set_Title(NULL, NULL);

  hAccelTable = LoadAccelerators(hInst, MAKEINTRESOURCE(RAC));

  Identify_CPU();

  i = GetVersion();

  // Get major and minor version numbers of Windows

  if(((i & 0xFF) > 4) || (i & 0x80000000)) WinNT_Flag = 0;
  else WinNT_Flag = 1;

  i = GetCurrentDirectory(sizeof(Gens_Path), Gens_Path);
  if(Gens_Path[i] != '\\' && Gens_Path[i] != '/') Gens_Path[i++] = '\\';
  sprintf(Language_Path, "%s%s", Gens_Path, "language.dat");
  sprintf(Str_Tmp, "%s%s", Gens_Path, "\\gens.ini");

  MSH2_Init();
  SSH2_Init();
  M68K_Init();
  S68K_Init();
  Z80_Init();

  YM2612_Init(CLOCK_NTSC / 7, Sound_Rate, YM2612_Improv);
  PSG_Init(CLOCK_NTSC / 15, Sound_Rate);
  PWM_Init();

  Load_Config(Str_Tmp, NULL);
  ShowWindow(ghWnd, nCmdShow);

  if(!Init_Input(hInst, ghWnd))
  {
    End_Sound();
    if(Full_Screen) End_Graphics_FS();
    else            End_Graphics_W();
    return FALSE;
  }

  Init_CD_Driver();
  Init_Network();
  Init_Tab();
  Build_Main_Menu();

  switch(Gens_Priority)
  {
    case 0:
      SetThreadPriority(hInst, THREAD_PRIORITY_BELOW_NORMAL);
      break;

    case 2:
      SetThreadPriority(hInst, THREAD_PRIORITY_ABOVE_NORMAL);
      break;

    case 3:
      SetThreadPriority(hInst, THREAD_PRIORITY_HIGHEST);
      break;

    case 5:
      SetThreadPriority(hInst, THREAD_PRIORITY_TIME_CRITICAL);
      break;
  }

  Gens_Running = 1;

  return TRUE;
}


void End_All_And_Save_Settings(void)
{
  // free the rom before save settings (because of the controller configuration)
  Free_Rom(Game);

  sprintf(Str_Tmp, "%s%s", Gens_Path, "gens.ini");
  Save_Config(Str_Tmp);

  if(Full_Screen) End_Graphics_FS();
  else            End_Graphics_W();
  End_Input();
  YM2612_End();
  End_Sound();
  End_CD_Driver();
  End_Network();
}

//Rewound Note: Main Loop!
int __stdcall WinMain(HINSTANCE hInst, HINSTANCE, LPSTR lpCmdLine, int nCmdShow)
{
  MSG    msg;
  HANDLE hMutex = INVALID_HANDLE_VALUE;
  int    i;

  i = GetCurrentDirectory(1000, Str_Tmp);
  strcpy(Str_Tmp + i, "\\gens.ini");

  Run_Multiple_Instances = GetPrivateProfileInt("General", "Run Multiple Instances", 0, Str_Tmp);
  if(!Run_Multiple_Instances)
  {
    hMutex = CreateMutex(NULL, FALSE, "GENS_MUTEX");
    if(GetLastError() == ERROR_ALREADY_EXISTS)
    { if(hMutex != INVALID_HANDLE_VALUE) CloseHandle(hMutex); return 0; }// a instance is alread running
  }

  InitCommonControls();

  Init(hInst, nCmdShow);

  // Have to do it *before* load by command line
  Init_Genesis_Bios();

  // For hq2x filter
  Blit_HQ2x_InitLUTs();

  if(lpCmdLine[0])
  {
    int src;

#ifdef CC_SUPPORT
//    src = CC_Connect("CCGEN://Stef:gens@emu.consoleclassix.com/sonicthehedgehog2.gen", (char *) Rom_Data, CC_End_Callback);
    src = CC_Connect(lpCmdLine, (char *) Rom_Data, CC_End_Callback);

    if(src == 0)
    {
      Load_Rom_CC(CCRom.RName, CCRom.RSize);
      Build_Main_Menu();
    }
    else if(src == 1)
    {
      MessageBox(NULL, "Error during connection", NULL, MB_OK);
    }
    else if(src == 2)
    {
#endif
    src = 0;

		memset(Str_Tmp, 0, 1024);

    if(lpCmdLine[src] == '"')
    {
      src++;

      while ((lpCmdLine[src] != '"') && (lpCmdLine[src] != 0))
      {
        Str_Tmp[src - 1] = lpCmdLine[src];
        src++;
      }

      Str_Tmp[src - 1] = 0;
    }
    else
    {
      while (lpCmdLine[src] != 0)
      {
        Str_Tmp[src] = lpCmdLine[src];
        src++;
      }

      Str_Tmp[src] = 0;
    }

    Pre_Load_Rom(ghWnd, Str_Tmp);

#ifdef CC_SUPPORT
    }
#endif
  }
  while (Gens_Running)
  {
    while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
    {
      if(!GetMessage(&msg, NULL, 0, 0)) Gens_Running = 0;
      if(!TranslateAccelerator(ghWnd, hAccelTable, &msg))
      {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
      }
    }

#ifdef GENS_DEBUG
    if(Debug)            // DEBUG
    {
      Update_Debug_Screen();
      Flip(ghWnd);
    }
    else
#endif
    if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
    {
      if((Active) && (!Paused)) // EMULATION
      {
        Update_Emulation(ghWnd);
      }
      else                       // EMULATION PAUSED
      {
        Black_White_Screen_Grad();
        Flip(ghWnd);
        Sleep(250);
      }
    }
    else if(GYM_Playing)         // PLAY GYM
    {
      Play_GYM();
      Update_Gens_Logo(ghWnd);
    }
    else if(Intro_Style == 1)    // GENS LOGO EFFECT
    {
      Update_Gens_Logo(ghWnd);
      Sleep(5);
    }
    else if(Intro_Style == 2)    // STRANGE EFFECT
    {
      Update_Crazy_Effect(ghWnd);
      Sleep(10);
    }
    else if(Intro_Style == 3)    // GENESIS BIOS
    {
      Do_Genesis_Frame();
      Flip(ghWnd);
      Sleep(20);
    }
    else if(Intro_Style == 4)    // TV EFFECT
    {
      Update_TV_Effect(ghWnd);
      Sleep(20);
    }
    else if(Intro_Style == 5)    // CIRCLES EFFECT
    {
      Update_Circle_Effect(ghWnd);
      Sleep(10);
    }
    else if(Intro_Style == 6)    // BURN
    {
      Update_Burn_Effect(ghWnd);
      Sleep(10);
    }
    else if(Intro_Style == 7)    // SMOKE
    {
      Update_Smoke_Effect(ghWnd);
      Sleep(10);
    }
    else if(Intro_Style == 10)   // NEW INTRO STYLE
    {
      Update_New_Effect(ghWnd);
      Sleep(10);
    }
    else                          // BLANK SCREEN (MAX IDLE)
    {
      if(Full_Screen) Clear_Back_Screen_FS(ghWnd);
      else            Clear_Back_Screen_W(ghWnd);
      Flip(ghWnd);
      Sleep(200);
    }
  }

  End_All_And_Save_Settings();

  ChangeDisplaySettings(NULL, 0);

  DestroyWindow(ghWnd);

  while(PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
  {
    if(!GetMessage(&msg, NULL, 0, 0)) return msg.wParam;
  }

  if(hMutex != INVALID_HANDLE_VALUE) CloseHandle(hMutex);

  return 0;
}


long PASCAL WinProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  DWORD dwID;
  RECT  r;

  switch(message)
  {
    case WM_ACTIVATE:
      if(Gens_Running == 0) break;

      if(LOWORD(wParam) != WA_INACTIVE)
      {

        if(FS_Minimised)
        {
          Active = 1;
          FS_Minimised = 0;
          Set_Render(hWnd, 1, -1, -1, TRUE);
        }

        else if(Auto_Pause && !Active)
        {
          Active = 1;
          if(Paused && A_Paused) SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(ID_EMULATION_PAUSED, 0), 0);
          A_Paused = 0;
          Clear_Sound_Buffer();
        }
      }
      else
      {
        if((Full_Screen) && ((BOOL) HIWORD(wParam)) && (Active))
        {
          Set_Render(hWnd, 0, -1, -1, FALSE);
          FS_Minimised = 1;
        }

        if(Auto_Pause && Active)
        {
          Active = 0;
          if(!Paused)
          {
            SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(ID_EMULATION_PAUSED, 0), 0);
            A_Paused = 1;
          }
          Clear_Sound_Buffer();
        }
      }
      break;

    case WM_SYSCOMMAND:
      if(wParam == SC_SCREENSAVE && Disable_Screen_Saver) return 0; // disable screen saver
      break;

    case WM_MENUSELECT:
     case WM_ENTERSIZEMOVE:
      Clear_Sound_Buffer();
      break;

     case WM_EXITSIZEMOVE:
      if(!Full_Screen)
      {
        GetWindowRect(ghWnd, &r);
        Window_Pos.x = r.left;
        Window_Pos.y = r.top;
      }
      break;

    case WM_CLOSE:
      if((Check_If_Kaillera_Running())) return 0;
      Gens_Running = 0;
      return 0;

    case WM_RBUTTONDOWN:
      if(Full_Screen)
      {
        Clear_Sound_Buffer();
        SetCursorPos(40, 30);
        while (ShowCursor(false) >= 0);
        while (ShowCursor(true) < 0);
        Restore_Primary();
        TrackPopupMenu(ghMenu, TPM_LEFTALIGN | TPM_TOPALIGN, 20, 20, NULL, hWnd, NULL);
        while (ShowCursor(true) < 0);
        while (ShowCursor(false) >= 0);
      }
      break;

    case WM_CREATE:
      Active = 1;
      break;

    case WM_PAINT:
      if(Full_Screen) Clear_Primary_Screen_FS(ghWnd);
      else            Clear_Primary_Screen_W(ghWnd);
      Flag_Clr_Scr = -1;
      Flip(hWnd);
      break;

    case WM_COMMAND:
      dwID = LOWORD(wParam);
      if(dwID >= ID_HELP_LANG && dwID < (ID_HELP_LANG + 50))
      {
        Language = dwID - ID_HELP_LANG;
        Build_Main_Menu();
        return 0;
      }
      else if(dwID >= ID_FILES_OPENRECENTROM0 &&
              dwID < (ID_FILES_OPENRECENTROM0 + GMAX_RECENT_ROM))
      {
        if((Check_If_Kaillera_Running())) return 0;
        if(GYM_Playing) Stop_Play_GYM();
        return Pre_Load_Rom(ghWnd, Recent_Rom[dwID - ID_FILES_OPENRECENTROM0]);
      }
      else switch(dwID)
      {
        case ID_FILES_QUIT:
          PostMessage(hWnd, WM_CLOSE, 0, 0);
          return 0;

        case ID_FILES_OPENROM:
          if((Check_If_Kaillera_Running())) return 0;
          MINIMIZE
          return Get_Rom(hWnd);

        case ID_FILES_BOOTCD:
          if(Num_CD_Drive == 0) return 1;
          if(Check_If_Kaillera_Running()) return 0;
          if(GYM_Playing) Stop_Play_GYM();
          Free_Rom(Game);      // Don't forget it !
          SegaCD_Started = Init_SegaCD(NULL);
          Build_Main_Menu();
          return SegaCD_Started;

        case ID_FILES_OPENCLOSECD:
          if(SegaCD_Started) Change_CD();
          return 0;

        case ID_FILES_NETPLAY:
          MINIMIZE
          if(GYM_Playing) Stop_Play_GYM();
          Start_Netplay();
          return 0;

        case ID_FILES_CLOSEROM:
          if(Sound_Initialised) Clear_Sound_Buffer();
          Debug = 0;
          if(Net_Play || Switch_Full_Screen)
          {
            if(Full_Screen) Set_Render(hWnd, 0, -1, -1, TRUE);
          }
          Free_Rom(Game);
          Build_Main_Menu();
          return 0;

        case ID_FILES_CHEATS:
          if(Cheats_File) fclose(Cheats_File);
          Cheats_File = Compile_Cheats_File(NULL, NULL);
          if(Cheats_File)
          {
            MINIMIZE
            DialogBox(ghInstance, MAKEINTRESOURCE(IDD_CHEATS), hWnd, (DLGPROC)CheatsProc);
            fclose(Cheats_File);
            Cheats_File = NULL;
          }
          return 0;

        case ID_FILES_SAVERAM:
          Save_Ram();
          return 0;

        case ID_FILES_SEARCHVALUE:
          if(!(*Rom_Name)) return 0;
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_SEARCHVALUE), hWnd, (DLGPROC) SearchValueProc);
          Build_Main_Menu();
          return 0;

        case ID_FILES_GAMEGENIE:
          if(Check_If_Kaillera_Running()) return 0;
          if(!Genesis_Started && !_32X_Started && !SegaCD_Started) return 0;
          MINIMIZE
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_GAMEGENIE), hWnd, (DLGPROC) GGenieProc);
          return 0;

        case ID_FILES_LOADSTATE:
          if(Check_If_Kaillera_Running()) return 0;
          if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
          {
            Str_Tmp[0] = 0;
            Get_State_File_Name(Str_Tmp);
            Load_State(Str_Tmp);
          }
          return 0;

        case ID_FILES_LOADSTATEAS:
          if(Check_If_Kaillera_Running()) return 0;
          if(Genesis_Started || _32X_Started || SegaCD_Started)
          {
            Str_Tmp[0] = 0;
            Change_File_L(Str_Tmp, State_Dir, "Load state", "State files (*.gs?)\0*.gs*\0All files (*.*)\0*.*\0\0", "");
            Load_State(Str_Tmp);
          }
          else if(SMS_Started)
          {
            Str_Tmp[0] = 0;
            Change_File_L(Str_Tmp, State_Dir, "Load state", "State files (*.ms?)\0*.ms*\0All files (*.*)\0*.*\0\0", "");
            Load_State(Str_Tmp);
          }
          return 0;

        case ID_FILES_SAVESTATE:
          if(Check_If_Kaillera_Running()) return 0;
          if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
          {
            Str_Tmp[0] = 0;
            Get_State_File_Name(Str_Tmp);
            Save_State(Str_Tmp);
          }
          return 0;

        case ID_FILES_SAVESTATEAS:
          if(Check_If_Kaillera_Running()) return 0;
          if(Genesis_Started || _32X_Started || SegaCD_Started)
          {
            Change_File_S(Str_Tmp, State_Dir, "Save state", "State files (*.gs?)\0*.gs*\0All files (*.*)\0*.*\0\0", "");
            Save_State(Str_Tmp);
          }
          else if(SMS_Started)
          {
            Change_File_S(Str_Tmp, State_Dir, "Save state", "State files (*.ms?)\0*.ms*\0All files (*.*)\0*.*\0\0", "");
            Save_State(Str_Tmp);
          }
          return 0;

        case ID_FILES_PREVIOUSSTATE:
          Set_Current_State(hWnd, (Current_State + 9) % 10);
          return 0;

        case ID_FILES_NEXTSTATE:
          Set_Current_State(hWnd, (Current_State + 1) % 10);
          return 0;

        case ID_FILES_CLEARHISTORY:
          memset(Recent_Rom, 0, sizeof(Recent_Rom));
          Build_Main_Menu();
          return 0;

        case ID_FILES_ROMINFO:
          if(!Game || !(*Rom_Name)) return 0;
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_ROMINFO), hWnd, (DLGPROC) RomInfoProc);
          return 0;

		    case ID_FILES_PLAY_MOVIE:
          if(!Genesis_Started && !_32X_Started && !SegaCD_Started && !*Rom_Name) return 0;
			    if     (Movie_Status & MOVIE_RECORDING) return 0; // the emulator is recording a movie
          // the emulator is playing a movie (stop it)
          else if(Movie_Status & MOVIE_PLAYING)
          { StopPlayMovie(); return 0; }
          // try to open the movie file
          sprintf(Movie_File_Name, "%s.%s", Rom_Name, "gir");
			    if(Change_File_L(Movie_File_Name, Dump_Dir, "Load Movie", "Gens+ Input Record (*.gir; *.giz)\0*.gir;*.giz*\0All Files\0*.*\0\0", "gir"))
          {
			      if(!StartPlayMovie()) // trying to start to play the movie file
			      {
				      MESSAGE_L("Error opening movie file", "Error opening movie file", 2000)
				      Movie_Status = MOVIE_FINISHED;
			      }
          }
			    return 0;

        case ID_FILES_RECORD_MOVIE:
          if(!Genesis_Started && !_32X_Started && !SegaCD_Started && !*Rom_Name) return 0;
			    if     (Movie_Status & MOVIE_PLAYING) return 0;
          // the emulator is recording a movie (stop it)
          else if(Movie_Status & MOVIE_RECORDING)
          {
            StopRecordMovie(); // stop recording the file
            LANGUAGE_STRING("Wish to Compress Movie", "Do you wish to compress the movie?", Str_Tmp, 1024);
            MINIMIZE
            // asking for the user if he wants to compress the file
            if(MessageBox(hWnd, Str_Tmp, "Gens+ REWiND!", MB_YESNO | MB_ICONQUESTION) == IDYES) //MK2k
            { CompressMovieFile(); }
            return 0;
          }
          // try to open the movie file
          sprintf(Movie_File_Name, "%s.%s", Rom_Name, "gir");
			    if(Change_File_S(Movie_File_Name, Dump_Dir, "Save Movie", "Gens+ Input Record (*.gir)\0*.gir*\0All Files\0*.*\0\0", "gir"))
          {
			      if(!StartRecordMovie(TRUE)) // trying to start to record the movie file
			      {
				      MESSAGE_L("Error creating movie file", "Error creating movie file", 2000)
				      Movie_Status = MOVIE_FINISHED;
  			    }
          }
			    return 0;

        case ID_FILES_OPENANDRECORDINPUT:
          if((Check_If_Kaillera_Running())) return 0;
          MINIMIZE
          if(Get_Rom(hWnd))
          {
            // try to open the movie file
            sprintf(Movie_File_Name, "%s.%s", Rom_Name, "gir");
  			    if(Change_File_S(Movie_File_Name, Dump_Dir, "Save Movie", "Gens+ Input Record (*.gir)\0*.gir*\0All Files\0*.*\0\0", "gir"))
            {
			        if(!StartRecordMovie(FALSE)) // trying to start to record the movie file
			        {
				        MESSAGE_L("Error creating file", "Error creating file", 2000)
				        Movie_Status = MOVIE_FINISHED;
			        }
            }
          }
		      return 0;

        case ID_GRAPHICS_DEVICE_GDI:
        case ID_GRAPHICS_DEVICE_DDRAW:
        case ID_GRAPHICS_DEVICE_D3D:
          Set_Render(hWnd, Full_Screen, dwID - ID_GRAPHICS_DEVICE_GDI, -1, FALSE);
          break;

        case ID_GRAPHICS_VSYNC:
          Change_VSync(hWnd);
          return 0;

        case ID_GRAPHICS_SWITCH_MODE:
          if(Full_Screen) Set_Render(hWnd, 0, -1, -1, TRUE);
          else            Set_Render(hWnd, 1, -1, Render_FS, TRUE);
          return 0;

        case ID_GRAPHICS_FS_RES1:
          Set_Resolution(640, 480);
          return 0;
        case ID_GRAPHICS_FS_RES2:
          Set_Resolution(800, 600);
          return 0;
        case ID_GRAPHICS_FS_RES3:
          Set_Resolution(1024, 768);
          return 0;

        case ID_GRAPHICS_COLOR_ADJUST:
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_COLOR), hWnd, (DLGPROC) ColorProc);
          return 0;

        case ID_GRAPHICS_RENDER_NORMAL:
        case ID_GRAPHICS_RENDER_DOUBLE:
        case ID_GRAPHICS_RENDER_DOUBLE_INT:
        case ID_GRAPHICS_RENDER_FULLSCANLINE:
        case ID_GRAPHICS_RENDER_INTESCANLINE:
        case ID_GRAPHICS_RENDER_SCALE2X:
        case ID_GRAPHICS_RENDER_50SCANLINE:
        case ID_GRAPHICS_RENDER_25SCANLINE:
        case ID_GRAPHICS_RENDER_INT50SCANLIN:
        case ID_GRAPHICS_RENDER_INT25SCANLIN:
        case ID_GRAPHICS_RENDER_2XSAI:
        case ID_GRAPHICS_RENDER_2XSUPERSAI:
        case ID_GRAPHICS_RENDER_2XSUPEREAGLE:
        case ID_GRAPHICS_RENDER_HQ2X:
        case ID_GRAPHICS_RENDER_TRIPLE:
        case ID_GRAPHICS_RENDER_TRIPLE_INT:
        case ID_GRAPHICS_RENDER_SCALE3X:
        case ID_GRAPHICS_RENDER_HQ3X:
          Set_Render(hWnd, Full_Screen, -1, dwID - ID_GRAPHICS_RENDER_NORMAL, TRUE);
          return 0;

        case ID_GRAPHICS_PREVIOUS_RENDER:
          if((Full_Screen) && (Render_FS > 0)) Set_Render(hWnd, 1, -1, Render_FS - 1, FALSE);
          else if((!Full_Screen) && (Render_W > 0)) Set_Render(hWnd, 0, -1, Render_W - 1, FALSE);
          return 0;

        case ID_GRAPHICS_NEXT_RENDER:
          if((Full_Screen) && (Render_FS < 9)) Set_Render(hWnd, 1, -1, Render_FS + 1, FALSE);
          else if((!Full_Screen) && (Render_W < 9)) Set_Render(hWnd, 0, -1, Render_W + 1, FALSE);
          return 0;

        case ID_GRAPHICS_STRETCH:
          Change_Stretch();
          return 0;

        case ID_GRAPHICS_FORCESOFT:
          Change_Blit_Style();
          return 0;

        case ID_GRAPHICS_FRAMESKIP_AUTO:
          Set_Frame_Skip(hWnd, -1);
          return 0;

        case ID_GRAPHICS_FRAMESKIP_0:
        case ID_GRAPHICS_FRAMESKIP_1:
        case ID_GRAPHICS_FRAMESKIP_2:
        case ID_GRAPHICS_FRAMESKIP_3:
        case ID_GRAPHICS_FRAMESKIP_4:
        case ID_GRAPHICS_FRAMESKIP_5:
        case ID_GRAPHICS_FRAMESKIP_6:
        case ID_GRAPHICS_FRAMESKIP_7:
        case ID_GRAPHICS_FRAMESKIP_8:
          Set_Frame_Skip(hWnd, LOWORD(wParam) - ID_GRAPHICS_FRAMESKIP_0);
          return 0;

        case ID_GRAPHICS_FRAMESKIP_MINUS:
          if(Frame_Skip == -1)    Set_Frame_Skip(hWnd, 0);
          else if(Frame_Skip > 0) Set_Frame_Skip(hWnd, Frame_Skip - 1);
          return 0;

        case ID_GRAPHICS_FRAMESKIP_PLUS:
          if(Frame_Skip == -1)    Set_Frame_Skip(hWnd, 1);
          else if(Frame_Skip < 8) Set_Frame_Skip(hWnd, Frame_Skip + 1);
          return 0;

        case ID_GRAPHICS_TURBO_MODE:
          Switch_Turbo_Mode();
          return 0;

        case ID_GRAPHICS_SPRITEOVER:
          Set_Sprite_Over(hWnd, Sprite_Over ^ 1);
          return 0;

        case ID_GRAPHICS_SHOT:
          if(*Rom_Name &&
            (Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started))
            Save_Shot();
          return 0;

        case ID_FILES_CHANGESTATE_0:
        case ID_FILES_CHANGESTATE_1:
        case ID_FILES_CHANGESTATE_2:
        case ID_FILES_CHANGESTATE_3:
        case ID_FILES_CHANGESTATE_4:
        case ID_FILES_CHANGESTATE_5:
        case ID_FILES_CHANGESTATE_6:
        case ID_FILES_CHANGESTATE_7:
        case ID_FILES_CHANGESTATE_8:
        case ID_FILES_CHANGESTATE_9:
          Set_Current_State(hWnd, LOWORD(wParam) - ID_FILES_CHANGESTATE_0);
          return 0;

#ifdef GENS_DEBUG
        case ID_CPU_DEBUG_GENESIS_68000:
          Change_Debug(hWnd, 1);
          return 0;

        case ID_CPU_DEBUG_GENESIS_Z80:
          Change_Debug(hWnd, 2);
          return 0;

        case ID_CPU_DEBUG_GENESIS_VDP:
          Change_Debug(hWnd, 3);
          return 0;

        case ID_CPU_DEBUG_SEGACD_68000:
          Change_Debug(hWnd, 4);
          return 0;

        case ID_CPU_DEBUG_SEGACD_CDC:
          Change_Debug(hWnd, 5);
          return 0;

        case ID_CPU_DEBUG_SEGACD_GFX:
          Change_Debug(hWnd, 6);
          return 0;

        case ID_CPU_DEBUG_32X_MAINSH2:
          Change_Debug(hWnd, 7);
          return 0;

        case ID_CPU_DEBUG_32X_SUBSH2:
          Change_Debug(hWnd, 8);
          return 0;

        case ID_CPU_DEBUG_32X_VDP:
          Change_Debug(hWnd, 9);
          return 0;
#endif

        case ID_CPU_RESET:
          if(Check_If_Kaillera_Running()) return 0;

          if(Genesis_Started)
          {
            Reset_Genesis();
            MESSAGE_L("Genesis reseted", "Genesis reset", 2000)
          }
          else if(_32X_Started)
          {
            Reset_32X();
            MESSAGE_L("32X reseted", "32X reset", 2000)
          }
          else if(SegaCD_Started)
          {
            Reset_SegaCD();
            MESSAGE_L("SegaCD reseted", "SegaCD reset", 2000)
          }
          else if(SMS_Started)
          {
            SMS_Reset();
            MESSAGE_L("Master System reseted", "Master System reset", 2000);
          }
          return 0;

        case ID_CPU_RESET68K:
          if(Check_If_Kaillera_Running()) return 0;
          if(Game)
          {
            Paused = 0;
            main68k_reset();
            if(Genesis_Started) MESSAGE_L("68000 CPU reseted", "68000 CPU reseted", 2000)
            else if(SegaCD_Started) MESSAGE_L("Main 68000 CPU reseted", "Main 68000 CPU reseted", 2000)
          }
          return 0;

        case ID_CPU_RESET_MSH2:
          if(Check_If_Kaillera_Running()) return 0;
          if((Game) && (_32X_Started))
          {
            Paused = 0;
            SH2_Reset(&M_SH2, 1);
            MESSAGE_L("Master SH2 reseted", "Master SH2 reseted", 2000)
          }
          return 0;

        case ID_CPU_RESET_SSH2:
          if(Check_If_Kaillera_Running()) return 0;
          if((Game) && (_32X_Started))
          {
            Paused = 0;
            SH2_Reset(&S_SH2, 1);
            MESSAGE_L("Slave SH2 reseted", "Slave SH2 reseted", 2000)
          }
          return 0;

        case ID_CPU_RESET_SUB68K:
          if(Check_If_Kaillera_Running()) return 0;
          if((Game) && (SegaCD_Started))
          {
            Paused = 0;
            sub68k_reset();
            MESSAGE_L("Sub 68000 CPU reseted", "Sub 68000 CPU reseted", 2000)
          }
          return 0;

        case ID_CPU_RESETZ80:
          if(Check_If_Kaillera_Running()) return 0;
          if(Game)
          {
            z80_Reset(&M_Z80);
            MESSAGE_L("CPU Z80 reseted", "CPU Z80 reseted", 2000)
          }
          return 0;

        case ID_CPU_ACCURATE_SYNCHRO:
          Change_SegaCD_Synchro();
          return 0;

        case ID_CPU_COUNTRY_AUTO:
          Change_Country(hWnd, -1);
          return 0;

        case ID_CPU_COUNTRY_JAPAN:
          Change_Country(hWnd, 0);
          return 0;

        case ID_CPU_COUNTRY_USA:
          Change_Country(hWnd, 1);
          return 0;

        case ID_CPU_COUNTRY_EUROPE:
          Change_Country(hWnd, 2);
          return 0;

        case ID_CPU_COUNTRY_MISC:
          Change_Country(hWnd, 3);
          return 0;

        case ID_CPU_COUNTRY_ORDER + 0:
        case ID_CPU_COUNTRY_ORDER + 1:
        case ID_CPU_COUNTRY_ORDER + 2:
          Change_Country_Order(LOWORD(wParam) - ID_CPU_COUNTRY_ORDER);
          return 0;

        case ID_SOUND_Z80ENABLE:
          Change_Z80(hWnd);
          return 0;

        case ID_SOUND_YM2612ENABLE:
          Change_YM2612(hWnd);
          return 0;

        case ID_SOUND_PSGENABLE:
          Change_PSG(hWnd);
          return 0;

        case ID_SOUND_DACENABLE:
          Change_DAC(hWnd);
          return 0;

        case ID_SOUND_PCMENABLE:
          Change_PCM(hWnd);
          return 0;

        case ID_SOUND_PWMENABLE:
          Change_PWM(hWnd);
          return 0;

        case ID_SOUND_CDDAENABLE:
          Change_CDDA(hWnd);
          return 0;

        case ID_SOUND_DACIMPROV:
          Change_DAC_Improv(hWnd);
          return 0;

        case ID_SOUND_PSGIMPROV:
          Change_PSG_Improv(hWnd);
          return 0;

        case ID_SOUND_YMIMPROV:
          Change_YM2612_Improv(hWnd);
          return 0;

        case ID_SOUND_YM_SSGEG:
          Change_YM2612_SSGEG(hWnd);
          return 0;

        case ID_SOUND_ECHO:
          Change_Echo();
          return 0;

        case ID_SOUND_LOWPASS:
          Change_LowPass_Filter();
          return 0;

        case ID_SOUND_ENABLE:
          Change_Sound(hWnd);
          return 0;

        case ID_SOUND_RATE_11000:
          Change_Sample_Rate(hWnd, 0);
          return 0;

        case ID_SOUND_RATE_22000:
          Change_Sample_Rate(hWnd, 1);
          return 0;

        case ID_SOUND_RATE_44000:
          Change_Sample_Rate(hWnd, 2);
          return 0;

        case ID_SOUND_VOLUME_0:
          Change_Volume(hWnd, 0);
          return 0;

        case ID_SOUND_VOLUME_25:
          Change_Volume(hWnd, 25);
          return 0;

        case ID_SOUND_VOLUME_50:
          Change_Volume(hWnd, 50);
          return 0;

        case ID_SOUND_VOLUME_75:
          Change_Volume(hWnd, 75);
          return 0;

        case ID_SOUND_VOLUME_100:
          Change_Volume(hWnd, 100);
          return 0;

        case ID_SOUND_VOLUME_125:
          Change_Volume(hWnd, 125);
          return 0;

        case ID_SOUND_VOLUME_150:
          Change_Volume(hWnd, 150);
          return 0;

        case ID_SOUND_VOLUME_175:
          Change_Volume(hWnd, 175);
          return 0;

        case ID_SOUND_VOLUME_200:
          Change_Volume(hWnd, 200);
          return 0;

        case ID_SOUND_STEREO:
          Change_Sound_Stereo(hWnd);
          return 0;

        case ID_SOUND_STARTWAVDUMP:
          if(WAV_Dumping) Stop_WAV_Dump();
          else Start_WAV_Dump();
          Build_Main_Menu();
          return 0;

        case ID_SOUND_STARTGYMDUMP:
          if(Genesis_Started || _32X_Started || SegaCD_Started)
          {
            if(GYM_Dumping) Stop_GYM_Dump();
            else Start_GYM_Dump();
            Build_Main_Menu();
          }
          return 0;

        case ID_SOUND_STARTSGMDUMP:
          if(Genesis_Started || _32X_Started || SegaCD_Started)
          {
            if(SGM_File)
            {
              Stop_SGM_Dump();
              LANGUAGE_STRING("Wish to Compress", "Do you wish to compress the file?", Str_Tmp, 1024);
              MINIMIZE
              // asking for the user if he wants to compress the file
              if(MessageBox(hWnd, Str_Tmp, "Gens+ REWiND!", MB_YESNO | MB_ICONQUESTION) == IDYES) //MK2k
              { Compress_SGM_File(); }
              return 0;
            }
            else Start_SGM_Dump();
            Build_Main_Menu();
          }
          return 0;

        case ID_SOUND_STARTVGMDUMP:
          if(SMS_Started) // only SMS suports VGM logging
          {
            if(VGM_File) Stop_VGM_Dump();
            else Start_VGM_Dump();
            Build_Main_Menu();
          }
          return 0;

        case ID_SOUND_PLAYGYM:
          MINIMIZE
          if(!Genesis_Started && !SegaCD_Started && !_32X_Started)
          {
            if(GYM_Playing) Stop_Play_GYM();
            else Start_Play_GYM();
          }
          Build_Main_Menu();
          return 0;

        case ID_OPTIONS_FASTBLUR:
          Change_Fast_Blur(hWnd);
          return 0;

        case ID_OPTIONS_SHOWFPS:
          if(Show_FPS) Show_FPS = 0;
          else Show_FPS = 1;
          return 0;

        case ID_OPTIONS_CONFIGURATION:
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          Show_Config_Window();
          Build_Main_Menu();
          return 0;

        case ID_OPTIONS_JOYPADSETTING:
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          End_Input();
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_CONTROLLER), hWnd, (DLGPROC) ControllerProc);
          if(!Init_Input(ghInstance, ghWnd)) return false;
          Build_Main_Menu();
          return 0;

        case ID_OPTIONS_HOTKEYS:
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_HOTKEYS), hWnd, (DLGPROC) HotkeysProc);
          Build_Main_Menu();
          return 0;

        case ID_OPTION_CDDRIVE_0:
        case ID_OPTION_CDDRIVE_1:
        case ID_OPTION_CDDRIVE_2:
        case ID_OPTION_CDDRIVE_3:
        case ID_OPTION_CDDRIVE_4:
        case ID_OPTION_CDDRIVE_5:
        case ID_OPTION_CDDRIVE_6:
        case ID_OPTION_CDDRIVE_7:
          if(Num_CD_Drive > (LOWORD(wParam) - ID_OPTION_CDDRIVE_0))
          {
            CUR_DEV = LOWORD(wParam) - ID_OPTION_CDDRIVE_0;
          }
          Build_Main_Menu();
          return 0;

        case ID_OPTION_SRAMSIZE_0:
          Change_SegaCD_SRAM_Size(-1);
          return 0;

        case ID_OPTION_SRAMSIZE_8:
          Change_SegaCD_SRAM_Size(0);
          return 0;

        case ID_OPTION_SRAMSIZE_16:
          Change_SegaCD_SRAM_Size(1);
          return 0;

        case ID_OPTION_SRAMSIZE_32:
          Change_SegaCD_SRAM_Size(2);
          return 0;

        case ID_OPTION_SRAMSIZE_64:
          Change_SegaCD_SRAM_Size(3);
          return 0;

        case ID_OPTIONS_SAVECONFIG:
          strcpy(Str_Tmp, Gens_Path);
          strcat(Str_Tmp, "gens.ini");
          Save_Config(Str_Tmp);
          return 0;

        case ID_OPTIONS_LOADCONFIG:
          if(Check_If_Kaillera_Running()) return 0;
          MINIMIZE
          Load_As_Config(hWnd, Game);
          return 0;

        case ID_OPTIONS_SAVEASCONFIG:
          MINIMIZE
          Save_As_Config(hWnd);
          return 0;

        case ID_HELP_ABOUT:
          Clear_Sound_Buffer();
          DialogBox(ghInstance, MAKEINTRESOURCE(IDD_ABOUT), hWnd, (DLGPROC) AboutProc);
          return 0;

        case ID_HELP_HELP:
          if(Game)
          {
            if(Genesis_Started)
            {
              HtmlHelp(GetDesktopWindow(), CGOffline_Path, HH_HELP_CONTEXT, Calculate_CRC32());
            }
          }
          else
          {
            if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)    // Can be used to test if file exist
            {
              strcpy(Str_Tmp, Manual_Path);
              strcat(Str_Tmp, " index.html");
              system(Str_Tmp);
            }
          }

          /* Gens manual file :
          **
          **  File menu            manual.exe helpfilemenu.html
          **  Graphics menu          manual.exe helpgraphicsmenu.html
          **  CPU menu            manual.exe helpcpumenu.html
          **  Sound menu            manual.exe helpsoundmenu.html
          **  Options menu          manual.exe helpoptionmenu.html
          **  Netplay              manual.exe helpnetplay.html
          **
          **  Game Genie            manual.exe helpgamegenie.html
          **  Misc/General options      manual.exe helpmisc.html
          **  Joypad/Controllers settings    manual.exe helpjoypads.html
          **  Directories/file configuration  manual.exe helpdir.html
          **
          **  Help menu            manual.exe helphelpmenu.html
          **  Mega-CD                         manual.exe helpmegacd.html
          **  FAQ                             manual.exe helpfaq.html
          **  Default Keys/keyboard shortcuts manual.exe helpkeys.html
          **  Multitap                        manual.exe helpmultitap.html
          */
          return 0;

        case ID_HELP_MENU_FILE:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpfilemenu.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_MENU_GRAPHICS:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpgraphicsmenu.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_MENU_CPU:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpcpumenu.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_MENU_SOUND:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpsoundmenu.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_MENU_OPTIONS:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpoptionmenu.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_NETPLAY:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpnetplay.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_MEGACD:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpmegacd.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_FAQ:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpfaq.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_HELP_KEYS:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpkeys.html");
            system(Str_Tmp);
          }
          return 0;

        case ID_EMULATION_PAUSED:
          if(!Genesis_Started && !_32X_Started && !SegaCD_Started && !SMS_Started)
            return 0;
          if(Debug)
          {
            Change_Debug(ghWnd, 0);
            Paused = 0;
          }
          else if(Paused)
          {
            Paused = 0;
          }
          else
          {
            Paused = 1;
//            Black_White_Screen();
            Clear_Sound_Buffer();
          }
          Build_Main_Menu();
          return 0;

        case ID_EMULATION_NEXT_FRAME:
          if(!Genesis_Started && !_32X_Started && !SegaCD_Started) return 0;
          if(Debug || !Active || !Paused) return 0;
          Update_Emulation_One(hWnd);
//          Black_White_Screen();
          return 0;
      }
      break;

/*
      // A device has be modified (new CD inserted for instance)
      case WM_DEVICECHANGE:
        ASPI_Mechanism_State(0, NULL);
        break;
*/

#ifdef GENS_DEBUG
    case WM_KEYDOWN:
      if(Debug) Debug_Event((lParam >> 16) & 0x7F);
      break;
#endif

    case WM_KNUX:
      MESSAGE_L("Communicating", "Communicating ...", 2000)

      switch(wParam)
      {
        case 0:
          switch(lParam)
          {
            case 0:
              return 4;

            case 1:
              GetWindowText(ghWnd, Str_Tmp, 1024);
              return (long) (char *) Str_Tmp;

            case 2:
              return 5;

            case 3:
              return GENS_VERSION_H;

            default:
              return -1;
          }

        case 1:
          switch(lParam)
          {
            case 0:
              return((long) (unsigned short *)&Ram_68k[0]);
            case 1:
              return(64 * 1024);
            case 2:
              return(1);
            default:
              return(-1);
          }

        case 2:
          switch(lParam)
          {
            case 0:
              return((long) (unsigned char *)&Ram_Z80[0]);
            case 1:
              return(8 * 1024);
            case 2:
              return(0);
            default:
              return(-1);
          }

        case 3:
          switch(lParam)
          {
            case 0:
              return((long) (char *)&Rom_Data[0]);
            case 1:
              return(0);
            case 2:
              return(Rom_Size);
            default:
              return(-1);
          }

        case 4:
          switch(lParam)
          {
            case 0:
              return(0);
            case 1:
              return((Game != NULL)?1:0);
            case 2:
              return(0);
            default:
              return(-1);
          }

        default:
          return(-1);
      }
  }

  return DefWindowProc(hWnd, message, wParam, lParam);
}


int Build_Language_String(void)
{
  int sec_alloue = 1, poscar = 0;
  enum etat_sec {DEB_LIGNE, SECTION, NORMAL} etat = DEB_LIGNE;
  FILE *LFile;
  int c;

  if(language_name)
  {
    free(language_name);
    language_name = NULL;
  }

  language_name = (char**)malloc(sec_alloue * sizeof(char*));
  language_name[0] = NULL;

  LFile = fopen(Language_Path, "rtS");
  if(LFile)
  {
    while((c = getc(LFile)) != EOF)
    {
      switch(etat)
      {
        case DEB_LIGNE:
          switch(c)
          {
            case '[':
              etat = SECTION;
              sec_alloue++;
              language_name = (char**)realloc(language_name, sec_alloue * sizeof(char*));
              language_name[sec_alloue - 2] = (char*)malloc(32 * sizeof(char));
              language_name[sec_alloue - 1] = NULL;
              poscar = 0;
              break;

            case '\n':
              break;

            default: etat = NORMAL;
              break;
          }
          break;

        case NORMAL:
          switch(c)
          {
            case '\n':
              etat = DEB_LIGNE;
              break;

            default:
              break;
          }
          break;

        case SECTION:
          switch(c)
          {
            case ']':
              language_name[sec_alloue - 2][poscar] = 0;
              etat = DEB_LIGNE;
              break;

            default:
              if(poscar < 32)
                language_name[sec_alloue - 2][poscar++] = c;
              break;
          }
          break;
      }
    }

    fclose(LFile);
  }

  if(sec_alloue == 1)
  {
    language_name = (char**)realloc(language_name, 2 * sizeof(char*));
    language_name[0] = (char*)malloc(32 * sizeof(char));
    strcpy(language_name[0], "English");
    language_name[1] = NULL;
    WritePrivateProfileString("English", "Menu Language", "&English menu", Language_Path);
  }

  return 0;
}


LRESULT CALLBACK GGenieProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  int i, j, value;
  char tmp[1024];

  switch(uMsg)
  {
    case WM_INITDIALOG:
      Build_Language_String();
      Center_Dialog(hDlg);

      WORD_L(IDC_INFO_GG, "Informations GG", "", "Informations about GG/Patch codes");
      WORD_L(IDC_GGINFO1, "Game Genie info 1", "", "Both Game Genie code and Patch code are supported.");
      WORD_L(IDC_GGINFO2, "Game Genie info 2", "", "Highlight a code to activate it.");
      WORD_L(IDC_GGINFO3, "Game Genie info 3", "", "yntax for Game Genie code :  XXXX-XXXX");
      WORD_L(IDC_GGINFO4, "Game Genie info 4", "", "Syntax for Patch code :  XXXXXX:YYYY    (address:data)");

      WORD_L(ID_GGADD, "Add code", "", "Add &code");
      WORD_L(ID_GGREMOVE, "Remove selected codes", "", "&Remove selected codes");
      WORD_L(ID_GGDESACTIVE, "Desactive all codes", "", "&Desactive all codes");

      for(i = 0; i < 256; i++)
      {
        if(Liste_GG[i].code[0] != 0)
        {
          strcpy(Str_Tmp, Liste_GG[i].code);
          while (strlen(Str_Tmp) < 20) strcat(Str_Tmp, " ");
          strcat(Str_Tmp, Liste_GG[i].name);

          SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, (WPARAM) 0, (LONG) (LPTSTR) Str_Tmp);

          if(Liste_GG[i].active)
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETSEL, (WPARAM) 1, (LONG) i);
          else
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETSEL, (WPARAM) 0, (LONG) i);

          if((Liste_GG[i].restore != 0xFFFFFFFF) && (Liste_GG[i].addr < Rom_Size) && (Genesis_Started))
          {
            Rom_Data[Liste_GG[i].addr] = (unsigned char)(Liste_GG[i].restore & 0xFF);
            Rom_Data[Liste_GG[i].addr + 1] = (unsigned char)((Liste_GG[i].restore & 0xFF00) >> 8);
          }
        }
      }
      return true;
      break;

    case WM_COMMAND:
      switch(LOWORD(wParam))
      {
        case ID_GGADD:
          if(GetDlgItemText(hDlg, IDC_EDIT1, Str_Tmp, 14))
          {
            if((strlen(Str_Tmp) == 9) || (strlen(Str_Tmp) == 11))
            {
              strupr(Str_Tmp);
              while (strlen(Str_Tmp) < 20) strcat(Str_Tmp, " ");

              GetDlgItemText(hDlg, IDC_EDIT2, (char *) (Str_Tmp + strlen(Str_Tmp)), 240);

              SendDlgItemMessage(hDlg, IDC_LIST1, LB_ADDSTRING, (WPARAM) 0, (LONG) (LPTSTR) Str_Tmp);

              SetDlgItemText(hDlg, IDC_EDIT1, "");
              SetDlgItemText(hDlg, IDC_EDIT2, "");
            }
          }
          return true;
          break;

        case ID_GGREMOVE:
          value = SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);
          if(value == LB_ERR) value = 0;

          for(i = value - 1; i >= 0; i--)
          {
            if(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETSEL, (WPARAM) i, NULL) > 0)
              SendDlgItemMessage(hDlg, IDC_LIST1, LB_DELETESTRING , (WPARAM) i, (LPARAM) 0);
          }
          return true;
          break;

        case ID_GGDESACTIVE:
          value = SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);
          if(value == LB_ERR) value = 0;

          for(i = value - 1; i >= 0; i--)
          {
            SendDlgItemMessage(hDlg, IDC_LIST1, LB_SETSEL , (WPARAM) 0, (LPARAM) i);
          }
          return true;
          break;

        case ID_OK:
          value = SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETCOUNT, (WPARAM) 0, (LPARAM) 0);
          if(value == LB_ERR) value = 0;

          for(i = 0; i < 256; i++)
          {
            Liste_GG[i].code[0] = 0;
            Liste_GG[i].name[0] = 0;
            Liste_GG[i].active = 0;
            Liste_GG[i].addr = 0xFFFFFFFF;
            Liste_GG[i].data = 0;
            Liste_GG[i].restore = 0xFFFFFFFF;
          }

          for(i = 0; i < value; i++)
          {
            if(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETTEXT, (WPARAM) i, (LONG) (LPTSTR) tmp) != LB_ERR)
            {
              j = 0;

              while ((tmp[j] != ' ') && (tmp[j] != 0)) j++;

              memcpy(Liste_GG[i].code, tmp, j);
              Liste_GG[i].code[j] = 0;

              while ((tmp[j] == ' ') && (tmp[j] != 0)) j++;

              strcpy(Liste_GG[i].name, (char *) (tmp + j));

              if(SendDlgItemMessage(hDlg, IDC_LIST1, LB_GETSEL, (WPARAM) i, NULL) > 0)
                Liste_GG[i].active = 1;
              else Liste_GG[i].active = 0;
            }
          }

          for(i = 0; i < value; i++)
          {
            if((Liste_GG[i].code[0] != 0) && (Liste_GG[i].addr == 0xFFFFFFFF) && (Liste_GG[i].data == 0))
            {
              decode(Liste_GG[i].code, (patch *) (&(Liste_GG[i].addr)));

              if((Liste_GG[i].restore == 0xFFFFFFFF) && (Liste_GG[i].addr < Rom_Size) && (Genesis_Started))
              {
                Liste_GG[i].restore = (unsigned int) (Rom_Data[Liste_GG[i].addr] & 0xFF);
                Liste_GG[i].restore += (unsigned int) ((Rom_Data[Liste_GG[i].addr + 1] & 0xFF) << 8);
              }
            }
          }

        case ID_CANCEL:
          EndDialog(hDlg, true);
          return true;
          break;


        case ID_HELP_HELP:
          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpgamegenie.html");
            system(Str_Tmp);
          }
          else
          {
            MessageBox(NULL, "You need to configure the Manual Path to have help", "info", MB_OK);
          }
          return true;
          break;
      }
      break;

    case WM_CLOSE:
      EndDialog(hDlg, true);
      return true;
      break;
  }

  return false;
}


LRESULT CALLBACK AboutProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch(uMsg)
  {
    case WM_INITDIALOG:
      HANDLE hRes;
      LPSTR  pszText;
      if(Full_Screen)
      { while(ShowCursor(false) >= 0);
        while(ShowCursor(true) < 0); }
      hRes = FindResource(ghInstance, MAKEINTRESOURCE(ID_ABOUT), RT_RCDATA);
      if(hRes)
      { hRes    = LoadResource(ghInstance, (HRSRC)hRes);
        pszText = (LPSTR)LockResource(hRes);
        SetDlgItemText(hDlg, IDC_EDIT_ABOUT, pszText); }
      Center_Dialog(hDlg);
      return 1;

    case WM_COMMAND:
      switch(wParam)
      {
        case IDCANCEL:
        case IDOK:
          if(Full_Screen)
          { while (ShowCursor(true) < 0);
            while (ShowCursor(false) >= 0); }
          EndDialog(hDlg, true);
          return 1;
      }
      break;

    case WM_CLOSE:
      if(Full_Screen)
      { while (ShowCursor(true) < 0);
        while (ShowCursor(false) >= 0); }
      EndDialog(hDlg, true);
      return 1;
  }

  return 0;
}


LRESULT CALLBACK ColorProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch(uMsg)
  {
    case WM_INITDIALOG:
      Build_Language_String();

      if(Full_Screen)
      {
        while (ShowCursor(false) >= 0);
        while (ShowCursor(true) < 0);
      }

      Center_Dialog(hDlg);

      LANGUAGE_STRING("Color Adjustement", "Color adjustement", Str_Tmp, 1024);
      SetWindowText(hDlg, Str_Tmp);
      WORD_L(IDC_STATIC_CONT, "Contrast", "", "Contrast");
      WORD_L(IDC_STATIC_BRIGHT, "Brightness", "", "Brightness");
      WORD_L(IDC_CHECK_GREYSCALE, "Greyscale", "", "Greyscale");
      WORD_L(IDC_CHECK_INVERT, "Invert", "", "Invert");

      SendDlgItemMessage(hDlg, IDC_SLIDER_CONTRASTE, TBM_SETRANGE, TRUE, MAKELONG(0, 200));
      SendDlgItemMessage(hDlg, IDC_SLIDER_CONTRASTE, TBM_SETPOS, TRUE, Contrast_Level);
      SendDlgItemMessage(hDlg, IDC_SLIDER_LUMINOSITE, TBM_SETRANGE, TRUE, MAKELONG(0, 200));
      SendDlgItemMessage(hDlg, IDC_SLIDER_LUMINOSITE, TBM_SETPOS, TRUE, Brightness_Level);

      SendDlgItemMessage(hDlg, IDC_CHECK_GREYSCALE, BM_SETCHECK, (WPARAM) (Greyscale)?BST_CHECKED:BST_UNCHECKED, 0);
      SendDlgItemMessage(hDlg, IDC_CHECK_INVERT, BM_SETCHECK, (WPARAM) (Invert_Color)?BST_CHECKED:BST_UNCHECKED, 0);

      return 1;

    case WM_COMMAND:
      switch(wParam)
      {
        case IDCANCEL:
          SendMessage(hDlg, WM_CLOSE, 0, 0);
          break;

        case IDOK:
          Contrast_Level = SendDlgItemMessage(hDlg, IDC_SLIDER_CONTRASTE, TBM_GETPOS, 0, 0);
          Brightness_Level = SendDlgItemMessage(hDlg, IDC_SLIDER_LUMINOSITE, TBM_GETPOS, 0, 0);
          Greyscale = (SendDlgItemMessage(hDlg, IDC_CHECK_GREYSCALE, BM_GETCHECK, 0, 0) == BST_CHECKED)?1:0;
          Invert_Color = (SendDlgItemMessage(hDlg, IDC_CHECK_INVERT, BM_GETCHECK, 0, 0) == BST_CHECKED)?1:0;
          Recalculate_Palettes();
          if(Genesis_Started || _32X_Started || SegaCD_Started)
          {
            CRam_Flag = 1;
            if(!Paused) Update_Emulation_One(ghWnd);
          }
          SendMessage(hDlg, WM_CLOSE, 0, 0);
          break;

        case ID_DEFAULT:
          SendDlgItemMessage(hDlg, IDC_SLIDER_CONTRASTE, TBM_SETPOS, (WPARAM) (BOOL) TRUE, (LPARAM) (LONG) (100));
          SendDlgItemMessage(hDlg, IDC_SLIDER_LUMINOSITE, TBM_SETPOS, (WPARAM) (BOOL) TRUE, (LPARAM) (LONG) (100));
          SendDlgItemMessage(hDlg, IDC_CHECK_GREYSCALE, BM_SETCHECK, BST_UNCHECKED, 0);
          SendDlgItemMessage(hDlg, IDC_CHECK_INVERT, BM_SETCHECK, BST_UNCHECKED, 0);
          break;

        case ID_HELP_HELP:
/*          if(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY)
          {
            strcpy(Str_Tmp, Manual_Path);
            strcat(Str_Tmp, " helpmisc.html");
            system(Str_Tmp);
          }
          else
          {
            MessageBox(NULL, "You need to configure the Manual Path to have help", "info", MB_OK);
          }
*/          break;
      }
      break;

    case WM_CLOSE:
      if(Full_Screen)
      { while (ShowCursor(1) < 0);
        while (ShowCursor(0) >= 0); }
      EndDialog(hDlg, 0);
      break;
  }

  return 0;
}

LRESULT CALLBACK RomInfoProc(HWND hDlg, UINT uMes, WPARAM wParam, LPARAM lParam)
{
  switch(uMes)
  {
    case WM_INITDIALOG:
      Center_Dialog(hDlg);
      SetDlgItemText(hDlg, IDC_CONSOLENAME, Game->Genesis.Console_Name);
      SetDlgItemText(hDlg, IDC_COPYRIGHT, Game->Genesis.Copyright);
      SetDlgItemText(hDlg, IDC_ROMNAME, Game->Genesis.Rom_Name);
      SetDlgItemText(hDlg, IDC_ROMNAMEW, Game->Genesis.Rom_Name_W);
      SetDlgItemText(hDlg, IDC_VERSION, Game->Genesis.Version);
      SetDlgItemText(hDlg, IDC_TYPE, Game->Genesis.Type);
      SetDlgItemText(hDlg, IDC_COUNTRIES, Game->Genesis.Countries);
      sprintf(Str_Tmp, "%4.4X", Game->Genesis.Checksum);
      SetDlgItemText(hDlg, IDC_CHECKSUM, Str_Tmp);
      SetDlgItemText(hDlg, IDC_IOSUPPORT, Game->Genesis.IO_Support);
      SetDlgItemText(hDlg, IDC_RAMINFOS, Game->Genesis.Ram_Infos);
      SetDlgItemText(hDlg, IDC_MODEMINFOS, Game->Genesis.Modem_Infos);
      sprintf(Str_Tmp, "%8.8X", Game->Genesis.Ram_Start_Adress);
      SetDlgItemText(hDlg, IDC_STARTADDRESS, Str_Tmp);
      sprintf(Str_Tmp, "%8.8X", Game->Genesis.Ram_End_Adress);
      SetDlgItemText(hDlg, IDC_ENDADDRESS, Str_Tmp);
      SetDlgItemText(hDlg, IDC_DESCRIPTION, Game->Genesis.Description);
      return 1;

    case WM_CLOSE:
      EndDialog(hDlg, 0);
      break;

    case WM_COMMAND:
      if(LOWORD(wParam) == IDCANCEL || LOWORD(wParam) == IDOK) EndDialog(hDlg, 0);
      break;
  }
  return 0;
}


void Center_Dialog(HWND hDlg)
{
  RECT r, r2;
  int  dx1, dy1, dx2, dy2;
  GetWindowRect(ghWnd, &r);
  dx1 = (r.right - r.left) / 2;
  dy1 = (r.bottom - r.top) / 2;
  GetWindowRect(hDlg, &r2);
  dx2 = (r2.right - r2.left) / 2;
  dy2 = (r2.bottom - r2.top) / 2;
  SetWindowPos(hDlg, NULL, r.left + (dx1 - dx2), r.top + (dy1 - dy2), NULL, NULL, SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW);
}
