
#include "gmenu.h"
#include "gmain.h"
#include "resource.h"
#include "net.h"
#include "grom.h"
#include "vdp_rend.h"
#include "misc.h"
#include "gens.h"
#include "vdp_io.h"
#include "gdsound.h"
#include "mem_M68K.h"
#include "YM2612.h"
#include "PSG.h"
#include "PCM.h"
#include "PWM.h"
#include "cd_sys.h"
#include "cd_aspi.h"
#include "wave.h"
#include "vgm.h"
#include "sgm.h"
#include "sms.h"
#include "movie.h"


HMENU ghMenu = NULL; // handle do menu principal

void __fastcall Add_Menu_Item(HMENU menu, int pos, DWORD flags, int id, LPCSTR str,
                              LPCSTR suffix, LPCSTR def)
{
  int len;
  len = GetPrivateProfileString(language_name[Language], str, def, Str_Tmp, 1024, Language_Path);
  if(suffix) strcpy(Str_Tmp + len, suffix);
  InsertMenu(menu, pos, flags, id, Str_Tmp);
}

#define MENU() CreatePopupMenu()
#define ITEM(smenu, pos, flags, id, str, suffix, def) \
  Add_Menu_Item(smenu, pos, flags, id, str, suffix, def)
#define SEPARATOR(smenu, i) \
  InsertMenu(smenu, i, MF_SEPARATOR | MF_BYPOSITION, NULL, NULL);


// cria o menu principal
HMENU __stdcall Build_Main_Menu(void)
{
  HMENU hMainMenu, hActMenu, hSubMenu, hSubMenu2;
  DWORD dwFlags;
  int   i, j, k, len, format, rend;

  if(ghMenu) DestroyMenu(ghMenu);
  Build_Language_String();

  if(Full_Screen)
  { hMainMenu = CreatePopupMenu(); rend = Render_FS; }
  else
  { hMainMenu = CreateMenu();      rend = Render_W; }


  // --- file ---

  hActMenu = MENU();
  ITEM(hMainMenu, 0, MF_BYPOSITION | MF_POPUP | MF_STRING, (UINT)hActMenu, "File", "", "&File");

  i = 0;
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_OPENROM, "Open Rom", "\tCtrl+O", "&Open ROM");
  if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
  { ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_CLOSEROM, "Free Rom", "\tCtrl+C", "&Close ROM"); }
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_BOOTCD, "Boot CD", "\tCtrl+B", "&Boot CD");

  if(Kaillera_Initialised)
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_NETPLAY, "Netplay", NULL, "&Netplay");

  if(Genesis_Started || _32X_Started || SegaCD_Started)
  {
    j = 0;
    SEPARATOR(hActMenu, i++);
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_GAMEGENIE, "Game Genie", "", "&Game Genie");
  }
  else j = 1;

  if((Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started) && *Rom_Name)
  {
    if(j) SEPARATOR(hActMenu, i++);

    // --- file -> cheats ---

    hSubMenu = MENU();
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Cheats", "", "Cheats");
    j = 0;
    ITEM(hSubMenu, j++, MF_BYPOSITION | MF_STRING, ID_FILES_CHEATS, "Edit Cheats", "\tCtrl+E", "&Edit");
    ITEM(hSubMenu, j++, MF_BYPOSITION | MF_STRING, ID_FILES_SEARCHVALUE, "Search value", "", "&Search Value");
    ITEM(hSubMenu, j++, MF_BYPOSITION | MF_STRING, ID_FILES_SAVERAM, "Save RAM", "", "Save &RAM");

    SEPARATOR(hActMenu, i++);

    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_LOADSTATEAS, "Load State as", "\tShift+F8", "Load State...");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_SAVESTATEAS, "Save State as", "\tShift+F5", "Save State as...");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_LOADSTATE, "Load State", "\tF8", "Quick &Load");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_SAVESTATE, "Save State", "\tF5", "Quick &Save");

    // --- file -> state ---

    hSubMenu = MENU();
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Change State", "\tF6-F7", "C&hange State");
    for(j = 0; j < 10; j++)
    {
      sprintf(Str_Tmp ,"&%d", j);
      if(Current_State == j)
        InsertMenu(hSubMenu, j, MF_BYPOSITION | MF_STRING | MF_CHECKED, ID_FILES_CHANGESTATE_0 + i, Str_Tmp);
      else
        InsertMenu(hSubMenu, j, MF_BYPOSITION | MF_STRING | MF_UNCHECKED, ID_FILES_CHANGESTATE_0 + i, Str_Tmp);
    }
  }

  SEPARATOR(hActMenu, i++);

  // --- file -> recent ---

  if(*Recent_Rom[0])
  {
    hSubMenu = MENU();
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu,
         "Rom History", "", "&ROM History");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_CLEARHISTORY,
         "Clear History", "", "Clear &History");
    SEPARATOR(hActMenu, i++);

    for(j = 0; j < GMAX_RECENT_ROM; j++)
    {
      if(*Recent_Rom[j])
      {
        char szTmp[GMAX_PATH];
        format = Recent_Rom_Type[j] >> 1;
        switch(format)
        {
          case (GENESIS_ROM >> 1):
            len = sprintf(szTmp, "%i. [MD]\t- ", j + 1);   break;
          case (_32X_ROM >> 1):
            len = sprintf(szTmp, "%i. [32X]\t- ", j + 1);  break;
          case (SMS_ROM >> 1):
            len = sprintf(szTmp, "%i. [MS]\t- ", j + 1);   break;
          case (GG_ROM >> 1):
            len = sprintf(szTmp, "%i. [GG]\t- ", j + 1);   break;
          case (SEGACD_IMAGE >> 1):
            len = sprintf(szTmp, "%i. [SCD]\t- ", j + 1);  break;
          case (SEGACD_32X_IMAGE >> 1):
            len = sprintf(szTmp, "%i. [SCDX]\t- ", j + 1); break;
          default:
            len = sprintf(szTmp, "%i. [---]\t- ", j + 1);  break;
        }

        Get_Name_From_Path(Recent_Rom[j], Str_Tmp);
        strcpy(szTmp + len, Str_Tmp);
        InsertMenu(hSubMenu, j, MF_BYPOSITION | MF_STRING, ID_FILES_OPENRECENTROM0 + j, szTmp);
      }
      else break;
    }
  }


  if((Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started) && *Rom_Name)
  {
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_ROMINFO, "Rom Info", "", "Rom &Info");
    SEPARATOR(hActMenu, i++);
    if     (Movie_Status & MOVIE_PLAYING)
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_PLAY_MOVIE, "Stop Input Movie", "", "Stop Input Movie");
    else if(Movie_Status & MOVIE_RECORDING)
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_RECORD_MOVIE, "Stop Record Input Movie", "", "Stop Record Input Movie");
    else
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_PLAY_MOVIE, "Play Input Movie", "", "Play Input Movie");
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_RECORD_MOVIE, "Record Input Movie", "", "Record Input Movie");
    }
  }
  else
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_OPENANDRECORDINPUT, "Open and Record Input", "", "Open and Record Input");
  SEPARATOR(hActMenu, i++);

  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_FILES_QUIT, "Quit", "\tESC", "&Quit");	// MK2k


  // --- graphics ---

  hActMenu = MENU();
  ITEM(hMainMenu, 1, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hActMenu, "Graphics", "", "&Graphics");

  // --- graphics -> device ---
  i = 0;
  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Device", "", "&Device");
  j = 0;
  if(Full_Screen)
  {
    if(Device_FS <= GDEVICE_DDRAW) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_DEVICE_DDRAW, "DirectDraw");
#ifdef _DEBUG
    if(Device_FS == GDEVICE_D3D) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                         dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_DEVICE_D3D, "Direct3D");
#else
    InsertMenu(hSubMenu, j++, MF_BYPOSITION | MF_STRING | MF_DISABLED | MF_GRAYED, ID_GRAPHICS_DEVICE_D3D, "Direct3D");
#endif
  }
  else
  {
    if(Device_W == GDEVICE_GDI) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                        dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_DEVICE_GDI, "GDI");
    if(Device_W == GDEVICE_DDRAW) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                          dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_DEVICE_DDRAW, "DirectDraw");
#ifdef _DEBUG
    if(Device_W == GDEVICE_D3D) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                        dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_DEVICE_D3D, "Direct3D");
#else
    InsertMenu(hSubMenu, j++, MF_BYPOSITION | MF_STRING | MF_DISABLED | MF_GRAYED, ID_GRAPHICS_DEVICE_D3D, "Direct3D");
#endif
  }

  SEPARATOR(hActMenu, i++);

  if(Full_Screen)
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_GRAPHICS_SWITCH_MODE, "Windowed", "\tAlt+Enter", "&Windowed");
  else
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_GRAPHICS_SWITCH_MODE, "Full Screen", "\tAlt+Enter", "&Full Screen");

  // --- graphics -> full screen res ---

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Full Screen Resolution", "", "Full Screen Resolution");
  j = 0;
  if(Res_X == 640 && Res_Y == 480)
    dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else
    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_FS_RES1, "640x480");
  if(Res_X == 800 && Res_Y == 600)
    dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else
    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_FS_RES2, "800x600");
  if(Res_X == 1024 && Res_Y == 768)
    dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else
    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, j++, dwFlags, ID_GRAPHICS_FS_RES3, "1024x768");

  if((Full_Screen && VSync_FS) || (!Full_Screen && VSync_W)) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                                                       dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_GRAPHICS_VSYNC, "VSync", "\tShift+F3", "&VSync");

  if(Full_Screen)
  {
    if(Stretch_FS) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  }
  else
  {
    if(Stretch_W)  dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  }
  ITEM(hActMenu, i++, dwFlags, ID_GRAPHICS_STRETCH, "Stretch", "\tShift+F2", "&Stretch");

  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_GRAPHICS_COLOR_ADJUST, "Color", NULL, "&Color Adjust...");

  // --- graphics -> render ---

  const char pszRendID[][32] = {
    "Normal", "Double", "Interpolated", "Scanline", "Interpolated Scanline",
    "Scale2x", "50% Scanline", "25% Scanline", "Interpolated 50% Scanline",
    "Interpolated 25% Scanline", "2xSAI", "Super2xSAI", "SuperEagle", "hq2x",
    "Triple", "Interpolated3x", "Scale3x", "hq3x" };
  const char pszRendName[][32] = {
    "&Normal", "&Double", "&Interpolated", "&Scanline", "Interpolated Scanline",
    "Scale&2x", "&50% Scanline", "&25% Scanline", "Interpolated 50% Scanline",
    "Interpolated 25% Scanline", "2xS&AI", "S&uper2xSAI", "Super&Eagle", "&hq2x",
    "Triple", "Interpolated3x", "Scale&3x", "hq3x" };

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Render", "", "&Render");
  k = 0;
  for(j = 0; j < 6; j++)
  {
    if(rend == j) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else          dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    ITEM(hSubMenu, k++, dwFlags, ID_GRAPHICS_RENDER_NORMAL + j, pszRendID[j], "", pszRendName[j]);
  }
  SEPARATOR(hSubMenu, 1);
  k++;
  if(Have_MMX) // MMX renders
  {
    for( ; j < 14; j++)
    {
      if(rend == j) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else          dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      ITEM(hSubMenu, k++, dwFlags, ID_GRAPHICS_RENDER_NORMAL + j, pszRendID[j], "", pszRendName[j]);
    }
  }
  if(!Full_Screen || (Res_X >= (320 * 3) && Res_Y >= (240 * 3))) // 3x renders
  {
    SEPARATOR(hSubMenu, k++);
    for( ; j < 17; j++)
    {
      if(rend == j) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else          dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      ITEM(hSubMenu, k++, dwFlags, ID_GRAPHICS_RENDER_NORMAL + j, pszRendID[j], "", pszRendName[j]);
    }
    if(Have_MMX) // MMX renders
    {
      for( ; j < 18; j++)
      {
        if(rend == j) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else          dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, k++, dwFlags, ID_GRAPHICS_RENDER_NORMAL + j, pszRendID[j], "", pszRendName[j]);
      }
    }
  }

  SEPARATOR(hActMenu, i++);

  if(Sprite_Over) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else            dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_GRAPHICS_SPRITEOVER, "Sprite Limit", "", "&Sprite Limit");

  SEPARATOR(hActMenu, i++);

  // --- graphics -> frame skip ---

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Frame Skip", "", "&Frame Skip");

  if(Frame_Skip == -1) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                 dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, 0, dwFlags, ID_GRAPHICS_FRAMESKIP_AUTO, "Frameskip Auto", "", "&Auto");

  for(j = 0; j < 9; j++)
  {
    sprintf(Str_Tmp ,"&%d", j);
    if(Frame_Skip == j) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hSubMenu, j + 1, dwFlags, ID_GRAPHICS_FRAMESKIP_0 + j, Str_Tmp);
  }

  if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
  {
    if(Turbo_Mode) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    ITEM(hActMenu, i++, dwFlags, ID_GRAPHICS_TURBO_MODE, "Turbo Mode", "\tBackspace", "&Turbo Mode");
    if(*Rom_Name)
    {
      SEPARATOR(hActMenu, i++);
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_GRAPHICS_SHOT, "Screen Shot", "\tShift+Backspc", "&Screen Shot");
    }
  }


  // --- CPU ---

  hActMenu = MENU();
  ITEM(hMainMenu, 2, MF_BYPOSITION | MF_POPUP | MF_STRING, (UINT)hActMenu, "CPU", "", "&CPU");

  i = 0;

  // --- CPU -> debug ---

#ifdef GENS_DEBUG

  if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
  {
    hSubMenu = MENU();
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Debug", "", "&Debug");

    j = 0;

    if(SMS_Started)
    {
    }
    else
    {
      if(Debug == 1) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_GENESIS_68000, "Genesis - 68000", "", "&Genesis - 68000");

      if(Debug == 2) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_GENESIS_Z80, "Genesis - Z80", "", "Genesis - &Z80");

      if(Debug == 3) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_GENESIS_VDP, "Genesis - VDP", "", "Genesis - &VDP");

      if(SegaCD_Started)
      {
        if(Debug == 4) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_SEGACD_68000, "SegaCD - 68000", "", "&SegaCD - 68000");

        if(Debug == 5) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_SEGACD_CDC, "SegaCD - CDC", "", "SegaCD - &CDC");

        if(Debug == 6) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_SEGACD_GFX, "SegaCD - GFX", "", "SegaCD - GF&X");
      }

      if(_32X_Started)
      {
        if(Debug == (j - 1)) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else                 dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_32X_MAINSH2, "32X - main SH2", "", "32X - main SH2");

        if(Debug == (j - 1)) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else                 dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_32X_SUBSH2, "32X - sub SH2", "", "32X - sub SH2");

        if(Debug == (j - 1)) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
        else                 dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
        ITEM(hSubMenu, j++, dwFlags, ID_CPU_DEBUG_32X_VDP, "32X - VDP", "", "32X - VDP");
      }
    }

    SEPARATOR(hActMenu, i++);
  }

#endif // GENS_DEBUG

  // --- CPU -> country ---

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Country", "", "&Country");

  j = 0;
  if(Country == -1) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else              dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_CPU_COUNTRY_AUTO, "Auto detect", "", "&Auto detect");

  if(Country == 0) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_CPU_COUNTRY_JAPAN, "Japan (NTSC)", "", "&Japan (NTSC)");

  if(Country == 1) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_CPU_COUNTRY_USA, "USA (NTSC)", "", "&USA (NTSC)");

  if(Country == 2) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_CPU_COUNTRY_EUROPE, "Europe (PAL)", "", "&Europe (PAL)");

  if(Country == 3) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_CPU_COUNTRY_MISC, "Japan (PAL)", "", "Japan (PAL)");


  SEPARATOR(hSubMenu, j++);

  hSubMenu2 = MENU();
  ITEM(hSubMenu, j++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu2, "Auto detection order", "", "&Auto detection order");

  // --- CPU -> country -> auto detect order

  for(j = 0; j < 3; j++)
  {
    if(Country_Order[j] == 0)
    {
      ITEM(hSubMenu2, j, MF_BYPOSITION | MF_STRING, ID_CPU_COUNTRY_ORDER + i, "USA (NTSC)", "", "&USA (NTSC)");
    }
    else if(Country_Order[j] == 1)
    {
      ITEM(hSubMenu2, j, MF_BYPOSITION | MF_STRING, ID_CPU_COUNTRY_ORDER + i, "Japan (NTSC)", "", "&Japan (NTSC)");
    }
    else
    {
      ITEM(hSubMenu2, j, MF_BYPOSITION | MF_STRING, ID_CPU_COUNTRY_ORDER + i, "Europe (PAL)", "", "&Europe (PAL)");
    }
  }


  SEPARATOR(hActMenu, i++);
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET, "Hard Reset", "\tTAB", "&Hard Reset");

  if(SMS_Started)
  {
  }
  else if(Genesis_Started)
  {
    if(SegaCD_Started)
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET68K, "Reset main 68000", "", "Reset &main 68000");
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET_SUB68K, "Reset sub 68000", "", "Reset &sub 68000");
    }
    else if(_32X_Started)
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET68K, "Reset 68000", "", "Reset &68000");
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET_MSH2, "Reset master SH2", "", "Reset master SH2");
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET_SSH2, "Reset slave SH2", "", "Reset slave SH2");
    }
    else
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESET68K, "Reset 68K", "", "Reset &68000");
    }

    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_CPU_RESETZ80, "Reset Z80", "", "Reset &Z80");
  }

  if(!Genesis_Started && !_32X_Started && !SMS_Started)
  {
    SEPARATOR(hActMenu, i++);
    if (SegaCD_Accurate) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else                 dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    ITEM(hActMenu, i++, dwFlags, ID_CPU_ACCURATE_SYNCHRO, "Perfect Synchro", "\tCtrl+S", "&Perfect Synchro (slow)");
  }

  if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
  {
    SEPARATOR(hActMenu, i++);
    if(Paused || Debug)
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_EMULATION_PAUSED, "Resume Emulation", "\tP", "Resume Emulation");	// MK2k
      if(!Debug)
      {
        ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_EMULATION_NEXT_FRAME, "Next Frame", "\tEnter", "Next Frame");
      }
    }
    else
    {
      ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_EMULATION_PAUSED, "Pause Emulation", "\tP", "Pause Emulation");	// MK2k
    }
  }


  // --- sound ---

  hActMenu = MENU();
  ITEM(hMainMenu, 3, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hActMenu, "Sound", "", "&Sound");
  i = 0;

  if(Sound_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_SOUND_ENABLE, "Enable", "", "&Enable");

  SEPARATOR(hActMenu, i++);

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Rate", "", "&Rate");
  if(Sound_Rate == 11025) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 0, dwFlags, ID_SOUND_RATE_11000, "&11025");
  if(Sound_Rate == 22050) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 1, dwFlags, ID_SOUND_RATE_22000, "&22050");
  if(Sound_Rate == 44100) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 2, dwFlags, ID_SOUND_RATE_44000, "&44100");

  hSubMenu = MENU();
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Volume", "", "&Volume");
  if(Sound_Volume == 0)   dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 0, dwFlags, ID_SOUND_VOLUME_0, "&0%");
  if(Sound_Volume == 25)  dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 1, dwFlags, ID_SOUND_VOLUME_25, "&25%");
  if(Sound_Volume == 50)  dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 2, dwFlags, ID_SOUND_VOLUME_50, "&50%");
  if(Sound_Volume == 75)  dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 3, dwFlags, ID_SOUND_VOLUME_75, "&75%");
  if(Sound_Volume == 100) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 4, dwFlags, ID_SOUND_VOLUME_100, "&100%");
  if(Sound_Volume == 125) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 5, dwFlags, ID_SOUND_VOLUME_125, "125%");
  if(Sound_Volume == 150) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 6, dwFlags, ID_SOUND_VOLUME_150, "150%");
  if(Sound_Volume == 175) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 7, dwFlags, ID_SOUND_VOLUME_175, "175%");
  if(Sound_Volume == 200) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hSubMenu, 8, dwFlags, ID_SOUND_VOLUME_200, "200%");

  if(Sound_Stereo) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_SOUND_STEREO, "Stereo", "", "&Stereo");

  SEPARATOR(hActMenu, i++);

  if(Sound_Echo) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_SOUND_ECHO, "Reverb", "", "Reverb");

  if(Use_LowPass_Filter) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                   dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hActMenu, i++, dwFlags, ID_SOUND_LOWPASS, "Low-pass Filter", "", "Low-pass &Filter");

  SEPARATOR(hActMenu, i++);

  if(Z80_State & 1) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else              dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_Z80ENABLE, "&Z80");

  if(PSG_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_PSGENABLE, "&PSG");

  if(DAC_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_DACENABLE, "&DAC");

  if(!Genesis_Started && !_32X_Started)
  {
    if(PCM_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_PCMENABLE, "P&CM");
  }

  if(!Genesis_Started && !SegaCD_Started)
  {
    if(PCM_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else           dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_PWMENABLE, "P&WM");
  }

  if(!Genesis_Started && !_32X_Started)
  {
    if(CDDA_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else            dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hActMenu, i++, dwFlags, ID_SOUND_CDDAENABLE, "CDD&A");
  }

  hSubMenu = MENU();
  InsertMenu(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "&YM2612");

  j = 0;
  if(YM2612_Enable) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else              dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_SOUND_YM2612ENABLE, "YM2612 Enable", NULL, "&Enable");

  if(YM2612_Improv) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else              dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_SOUND_YMIMPROV, "YM2612 High Quality", NULL, "High &Quality");

  if(YM2612_Enable_SSGEG) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
  else                    dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
  ITEM(hSubMenu, j++, dwFlags, ID_SOUND_YM_SSGEG, "YM2612 Enable SSG-EG", NULL, "Enable SSG-EG");

  if(Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started)
  {
    SEPARATOR(hActMenu, i++);

    hSubMenu = MENU();
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Log sound", "", "&Log Sound");

    i = 0;
    if(WAV_Dumping)
      ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTWAVDUMP, "Stop WAV", "", "Stop WAV Log");
    else
      ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTWAVDUMP, "Start WAV", "", "Start WAV Log");

    if(Genesis_Started || _32X_Started || SegaCD_Started)
    {
      if(GYM_Dumping)
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTGYMDUMP, "Stop GYM", "", "Stop GYM Log");
      else
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTGYMDUMP, "Start GYM", "", "Start GYM Log");

#ifdef _DEBUG
      if(SGM_File)
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTSGMDUMP, "Stop SGM", "", "Stop SGM Log");
      else
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTSGMDUMP, "Start SGM", "", "Start SGM Log");
#else
      ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING | MF_DISABLED | MF_GRAYED, ID_SOUND_STARTSGMDUMP, "Start SGM", "", "Start SGM Log");
#endif
    }
    else if(SMS_Started)
    {
      if (VGM_File)
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTVGMDUMP, "Stop VGM", "", "Stop VGM Log");
      else
        ITEM(hSubMenu, i++, MF_BYPOSITION | MF_STRING, ID_SOUND_STARTVGMDUMP, "Start VGM", "", "Start VGM Log");
    }
  }

  // --- options ---

  hActMenu = MENU();
  ITEM(hMainMenu, 4, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hActMenu, "Options", "", "&Options");

  i = 0;
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_OPTIONS_JOYPADSETTING, "Configure Keys", "", "Configure &Keys");
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_OPTIONS_HOTKEYS, "Hotkeys", "", "&Hotkeys");
  SEPARATOR(hActMenu, i++);
  j = i;
  SEPARATOR(hActMenu, i++);
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_OPTIONS_LOADCONFIG, "Load config", "", "&Load config");
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_OPTIONS_SAVEASCONFIG, "Save config as", "", "&Save config as");
  SEPARATOR(hActMenu, i++);
  ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_OPTIONS_CONFIGURATION, "Configuration", "\tCtrl+P", "&Configuration");


  // --- options -> cd drive ----
  if(Num_CD_Drive)
  {
    char drive_name[100];

    hSubMenu = MENU();
    ITEM(hActMenu, j++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Current CD Drive", "", "Current CD Drive");

    for(i = 0; i < Num_CD_Drive; i++)
    {
      ASPI_Get_Drive_Info(i, (LPBYTE)drive_name);
      if(CUR_DEV == i) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else             dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      InsertMenu(hSubMenu, i, dwFlags, ID_OPTION_CDDRIVE_0 + i, drive_name + 8);
    }
  }


  // --- options -> SRAM Size ---
  hSubMenu = MENU();
  ITEM(hActMenu, j++, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hSubMenu, "Sega CD SRAM Size", "", "Sega CD SRAM Size");

  if(BRAM_Ex_State & 0x100)
  {
    ITEM(hSubMenu, 0, MF_BYPOSITION | MF_STRING | MF_UNCHECKED, ID_OPTION_SRAMSIZE_0, "None", "", "&None");

    for(i = 0; i < 4; i++)
    {
      char bsize[16];

      sprintf(bsize, "&%d Kb", 8 << i);

      if(BRAM_Ex_Size == i) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
      else                  dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
      InsertMenu(hSubMenu, i + 1, dwFlags, ID_OPTION_SRAMSIZE_8 + i, bsize);
    }
  }
  else
  {
    ITEM(hSubMenu, 0, MF_BYPOSITION | MF_STRING | MF_CHECKED, ID_OPTION_SRAMSIZE_0, "None", "", "&None");

    for (i = 0; i < 4; i++)
    {
      char bsize[16];

      sprintf(bsize, "&%d Kb", 8 << i);
      InsertMenu(hSubMenu, i + 1, MF_BYPOSITION | MF_STRING | MF_UNCHECKED, ID_OPTION_SRAMSIZE_8 + i, bsize);
    }
  }


  // --- help ---

  hActMenu = MENU();
  ITEM(hMainMenu, 5, MF_BYPOSITION | MF_STRING | MF_POPUP, (UINT)hActMenu, "Help", "", "&Help");

  i = 0;
  while(language_name[i])
  {
    GetPrivateProfileString(language_name[i], "Menu Language", "Undefined language", Str_Tmp, 1024, Language_Path);
    if(Language == i) dwFlags = MF_BYPOSITION | MF_STRING | MF_CHECKED;
    else              dwFlags = MF_BYPOSITION | MF_STRING | MF_UNCHECKED;
    InsertMenu(hActMenu, i, dwFlags, ID_HELP_LANG + i, Str_Tmp);
    i++;
  }

  SEPARATOR(hActMenu, i++);

  if(!(GetFileAttributes(Manual_Path) & FILE_ATTRIBUTE_DIRECTORY))
  {
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MENU_FILE, "File menu" ,"", "&File menu");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MENU_GRAPHICS, "Graphics menu" ,"", "&Graphics menu");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MENU_CPU, "CPU menu" ,"", "&CPU menu");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MENU_SOUND, "Sound menu" ,"", "&Sound menu");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MENU_OPTIONS, "Options menu" ,"", "&Options menu");

    SEPARATOR(hActMenu, i++);

    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_NETPLAY, "Netplay" ,"", "&Netplay");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_MEGACD, "Mega/Sega CD" ,"", "&Mega/Sega CD");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_FAQ, "FAQ" ,"", "&FAQ");
    ITEM(hActMenu, i++, MF_BYPOSITION | MF_STRING, ID_HELP_KEYS, "Shortcuts" ,"", "&Defaults keys && Shortcuts");

    SEPARATOR(hActMenu, i++);
  }

  ITEM(hActMenu, i, MF_BYPOSITION | MF_STRING, ID_HELP_ABOUT, "About" ,"", "&About");

  ghMenu = hMainMenu;

  if(Full_Screen) SetMenu(ghWnd, NULL);
  else SetMenu(ghWnd, ghMenu);

  return ghMenu;
}
