/* gintro.cpp - projeto gens+, Rodrigo Cardoso.
   Efeitos de abertura do gens+. */

#include <windows.h>
#include <math.h>
#include "ggraphic.h"
#include "vdp_io.h"
#include "gmain.h"
#include "misc.h"
#include "resource.h"
#include "gintro.h"
#include "giflib.h"

int _r     = 21;
int _minus = 0;
int _red = 0, _green = 0, _blue = 0;
int _rminus = 0, _gminus = 0, _bminus = 0;

void Update_Circle_Effect(HWND hWnd)
{
  int           j;
  CIRCLE_PARAMS c;

  if(_r < 130 && _r > 20)
  { if(_minus) _r--;
    else       _r++; }
  else
  {
    if(_minus) { _minus = 0; _r = 21; }
    else       { _minus = 1; _r = 129; }
  }

  if(_blue > 30)
  {
    _bminus = 1;
    if     (_green > 30) { _gminus = 1; _red++; }
    else if(_green < 1)  { _gminus = 0; }
    if(_gminus) _green--;
    else        _green++;
  }
  else if(_blue < 1) { _bminus = 0; }
  if(_bminus) _blue--;
  else        _blue++;

  Get_Screen_Center(&c.center);
  c.color = MAKE_COLOR(_red, _green, _blue);
  for(j = _r - 20; j < _r + 12; j++)
  {
    c.r = (WORD)j;
    Print_Circle(&c);
  }

  Half_Blur();
  Flip(hWnd);
}


void Update_New_Effect(HWND hWnd)
{
}


void Update_Gens_Logo(HWND hWnd)
{
  int i, j, m, n;
  static short tab[64000], Init = 0;
  static float renv = 0, ang = 0, zoom_x = 0, zoom_y = 0, pas;
  float        fm, fn;
  unsigned short c;

  if (!Init)
  {
    HBITMAP Logo;

    Logo = LoadBitmap(ghInstance,  MAKEINTRESOURCE(IDB_LOGO_BIG));
    GetBitmapBits(Logo, 64000 * 2, tab);
    pas = (float)0.05;
    Init = 1;
  }

  renv += pas;
  zoom_x = (float)sin(renv);
  if (zoom_x == 0.0) zoom_x = (float)0.0000001;
  zoom_x = (1 / zoom_x) * 1;
  zoom_y = 1;

  if (VDP_Reg.Set4 & 0x1)
  {
    for(j = 0; j < 240; j++)
    {
      for(i = 0; i < 320; i++)
      {
        fm = (float)(i - 160) * zoom_x;
        fn = (float)(j - 120) * zoom_y;
        m  = (int)fm;
        n  = (int)fn;

        if ((m < 130) && (m >= -130) && (n < 90) && (n >= -90))
        {
          c = tab[m + 130 + (n + 90) * 260];
          if ((c > 31) || (c < 5)) MD_Screen[TAB336[j] + i + 8] = c;
        }
      }
    }
  }
  else
  {
    for(j = 0; j < 240; j++)
    {
      for(i = 0; i < 256; i++)
      {
        fm = (float)(i - 128) * zoom_x;
        fn = (float)(j - 120) * zoom_y;
        m  = (int)fm;
        n  = (int)fn;

        if ((m < 130) && (m >= -130) && (n < 90) && (n >= -90))
        {
          c = tab[m + 130 + (n + 90) * 260];
          if ((c > 31) || (c < 5)) MD_Screen[TAB336[j] + i + 8] = c;
        }
      }
    }
  }

  Half_Blur();
  Flip(hWnd);
}


void Update_Crazy_Effect(HWND hWnd)
{
  int i, j, offset;
  int r = 0, v = 0, b = 0, prev_l, prev_p;
  int RB, G;

   for(offset = 336 * 240, j = 0; j < 240; j++)
  {
    for(i = 0; i < 336; i++, offset--)
    {
      prev_l = MD_Screen[offset - 336];
      prev_p = MD_Screen[offset - 1];

      if (Mode_555 & 1)
      {
        RB = ((prev_l & 0x7C1F) + (prev_p & 0x7C1F)) >> 1;
        G = ((prev_l & 0x03E0) + (prev_p & 0x03E0)) >> 1;

        if (Intro_Color & 0x4)
        {
          r = RB & 0x7C00;
          if (rand() > 0x2C00) r += 0x0400;
          else r -= 0x0400;
          if (r > 0x7C00) r = 0x7C00;
          else if (r < 0x0400) r = 0;
        }

        if (Intro_Color & 0x2)
        {
          v = G & 0x03E0;
          if (rand() > 0x2C00) v += 0x0020;
          else v -= 0x0020;
          if (v > 0x03E0) v = 0x03E0;
          else if (v < 0x0020) v = 0;
        }

        if (Intro_Color & 0x1)
        {
          b = RB & 0x001F;
          if (rand() > 0x2C00) b++;
          else b--;
          if (b > 0x1F) b = 0x1F;
          else if (b < 0) b = 0;
        }
      }
      else
      {
        RB = ((prev_l & 0xF81F) + (prev_p & 0xF81F)) >> 1;
        G = ((prev_l & 0x07C0) + (prev_p & 0x07C0)) >> 1;

        if (Intro_Color & 0x4)
        {
          r = RB & 0xF800;
          if (rand() > 0x2C00) r += 0x0800;
          else r -= 0x0800;
          if (r > 0xF800) r = 0xF800;
          else if (r < 0x0800) r = 0;
        }

        if (Intro_Color & 0x2)
        {
          v = G & 0x07C0;
          if (rand() > 0x2C00) v += 0x0040;
          else v -= 0x0040;
          if (v > 0x07C0) v = 0x07C0;
          else if (v < 0x0040) v = 0;
        }

        if (Intro_Color & 0x1)
        {
          b = RB & 0x001F;
          if (rand() > 0x2C00) b++;
          else b--;
          if (b > 0x1F) b = 0x1F;
          else if (b < 0) b = 0;
        }
      }

      MD_Screen[offset] = r + v + b;
    }
  }

  Flip(hWnd);
}


void __fastcall Update_TV_Effect(HWND hWnd)
{
  int i, c;

  for(i = 0; i < 336 * 240; i+=2)
  {
    c = rand();
    MD_Screen[i] = MAKE_COLOR(c, c, c);
    c >>= 5;
    MD_Screen[i + 1] = MAKE_COLOR(c, c, c);
  }

  Flip(hWnd);
}

/*
void Print_LineC(LPPOINT ppt, WORD clr)
{
  int x, y;
  int dx, dy, ux, uy, xi, yi;
  int i, max;

  dx = ppt[1].x - ppt[0].x;
  dy = ppt[1].y - ppt[0].y;
  ux = Module(dx);
  uy = Module(dy);
  if(uy > ux) max = uy;
  else        max = ux;
  xi = ppt[0].x;
  yi = ppt[0].y;

  for(i = 0; i < max; i++)
  {
    x = (i * dx / max) + xi;
    y = (i * dy / max) + yi;
    SET_PIXEL_COLOR(x, y, clr);
  }
}

*/
