
#ifndef _INTRO_H
#define _INTRO_H

#include <windows.h>
#include "vdp_rend.h"

#define MAKE_COLOR_555(r, g, b) \
  ((WORD)( ((b) & 0x1F) | (((g) & 0x1F) << 5) | (((r) & 0x1F) << 10) ))

#define MAKE_COLOR_565(r, g, b) \
  ((WORD)( ((b) & 0x1F) | (((g) & 0x1F) << 6) | (((r) & 0x1F) << 11) ))

#define MAKE_COLOR(r, g, b) \
  ( (Mode_555 & 0x01) ? MAKE_COLOR_555(r, g, b) : MAKE_COLOR_565(r, g, b) )

#define GET_R_VALUE_555(clr) (((clr) >> 10) & 0x1F)
#define GET_G_VALUE_555(clr) (((clr) >> 5)  & 0x1F)
#define GET_B_VALUE_555(clr) ((clr) & 0x1F)

#define GET_R_VALUE_565(clr) (((clr) >> 11) & 0x1F)
#define GET_G_VALUE_565(clr) (((clr) >> 6)  & 0x1F)
#define GET_B_VALUE_565(clr) ((clr) & 0x1F)

#define GET_R_VALUE(clr) ( (Mode_555 & 0x01) ? GET_R_VALUE_555(clr) : GET_R_VALUE_565(clr) )
#define GET_G_VALUE(clr) ( (Mode_555 & 0x01) ? GET_G_VALUE_555(clr) : GET_G_VALUE_565(clr) )
#define GET_B_VALUE(clr) ( (Mode_555 & 0x01) ? GET_B_VALUE_555(clr) : GET_B_VALUE_565(clr) )

#define ADD_R_VALUES_555(clr1, clr2) (GET_R_VALUE(clr1) + GET_R_VALUE(clr2))
#define ADD_G_VALUES_555(clr1, clr2) (GET_G_VALUE(clr1) + GET_G_VALUE(clr2))
#define ADD_B_VALUES_555(clr1, clr2) (GET_B_VALUE(clr1) + GET_B_VALUE(clr2))
#define ADD_COLORS_555(clr1, clr2) MAKE_COLOR_555( \
  ( (ADD_R_VALUES_555(clr1, clr2) > 31) ? 31 : ADD_R_VALUES_555(clr1, clr2) ), \
  ( (ADD_G_VALUES_555(clr1, clr2) > 31) ? 31 : ADD_G_VALUES_555(clr1, clr2) ), \
  ( (ADD_B_VALUES_555(clr1, clr2) > 31) ? 31 : ADD_B_VALUES_555(clr1, clr2) ) )

#define ADD_R_VALUES_565(clr1, clr2) (GET_R_VALUE(clr1) + GET_R_VALUE(clr2))
#define ADD_G_VALUES_565(clr1, clr2) (GET_G_VALUE(clr1) + GET_G_VALUE(clr2))
#define ADD_B_VALUES_565(clr1, clr2) (GET_B_VALUE(clr1) + GET_B_VALUE(clr2))
#define ADD_COLORS_565(clr1, clr2) MAKE_COLOR_565( \
  ( (ADD_R_VALUES_565(clr1, clr2) > 31) ? 31 : ADD_R_VALUES_565(clr1, clr2) ), \
  ( (ADD_G_VALUES_565(clr1, clr2) > 31) ? 31 : ADD_G_VALUES_565(clr1, clr2) ), \
  ( (ADD_B_VALUES_565(clr1, clr2) > 31) ? 31 : ADD_B_VALUES_565(clr1, clr2) ) )

#define ADD_COLORS(clr1, clr2) \
  ( Mode_555 & 0x01 ? ADD_COLORS_555(clr1, clr2) : ADD_COLORS_565(clr1, clr2) )

// x = [0, 335] ; y = [0, 239]
#define SET_PIXEL_COLOR(x, y, clr) \
  MD_Screen[ (((UINT)(x) < 336) ? (x) : 335) + ( (((UINT)(y) < 240) ? (239 - y) : 0) * 336) ] = clr
#define GET_PIXEL_COLOR(x, y) \
  ( MD_Screen[ (((UINT)(x) < 336) ? (x) : 335) + ( (((UINT)(y) < 240) ? (239 - y) : 0) * 336) ] )

#ifdef __cplusplus
extern "C" {
#endif

int  __fastcall SinX10k(int);
int  __fastcall CosX10k(int);
int  __fastcall Module(int);
WORD __fastcall Color_24_to_16(COLORREF);
void __fastcall Get_Screen_Center(LPPOINT);
void __fastcall Fill_Screen(WORD);
void __fastcall Clear_Screen(void);
void __fastcall Print_Line(LPPOINT, WORD);
void __fastcall Fill_Rect(LPPOINT, WORD);

typedef struct _CIRCLE_PARAMS {
  POINT center;
  WORD  r;
  WORD  color;
} CIRCLE_PARAMS, *PCIRCLE_PARAMS, *LPCIRCLE_PARAMS;

void __fastcall Print_Circle(LPCIRCLE_PARAMS);

void __fastcall Black_White_Screen(void);
void __fastcall Black_White_Screen_Grad(void);
void __fastcall Update_TV_Effect(HWND);

void __fastcall Print_Text1(LPCSTR text, DWORD color, int x, int y);
void __fastcall Print_Text2(LPCSTR text, DWORD color, int x, int y);
void __fastcall Print_Text3(LPCSTR text, DWORD color, int x, int y);
void __fastcall Print_Text1_Transp(LPCSTR text, DWORD color, int x, int y);
void __fastcall Print_Text2_Transp(LPCSTR text, DWORD color, int x, int y);
void __fastcall Print_Text3_Transp(LPCSTR text, DWORD color, int x, int y);

void Update_Circle_Effect(HWND hWnd);
void Update_New_Effect   (HWND hWnd);
void Update_Gens_Logo    (HWND hWnd);
void Update_Crazy_Effect (HWND hWnd);
void __fastcall Update_Burn_Effect (HWND hWnd);
void __fastcall Update_Smoke_Effect(HWND hWnd);

#ifdef __cplusplus
}
#endif

#endif // _INTRO_H
