; intro.asm - projeto gens+, Rodrigo Cardoso.
; contm funes utilizadas para dar efeitos na tela

%macro DECL 1-2
  %if %0 > 1
    global @%1@%2
  %else
    global _%1
  %endif
    global %1
  %if %0 > 1
    @%1@%2:
  %else
    _%1:
  %endif
    %1:
%endmacro


section .rdata align=64

Sin_Table:
  dw 0x0000, 0x00AF, 0x015D, 0x020B, 0x02BA, 0x0368, 0x0415, 0x04C3, 0x0570, 0x061C
  dw 0x06C8, 0x0774, 0x081F, 0x08CA, 0x0973, 0x0A1C, 0x0AC4, 0x0B6C, 0x0C12, 0x0CB8
  dw 0x0D5C, 0x0E00, 0x0EA2, 0x0F43, 0x0FE3, 0x1082, 0x1120, 0x11BC, 0x1257, 0x12F0
  dw 0x1388, 0x141E, 0x14B3, 0x1546, 0x15D8, 0x1668, 0x16F6, 0x1782, 0x180D, 0x1895
  dw 0x191C, 0x19A1, 0x1A23, 0x1AA4, 0x1B23, 0x1B9F, 0x1C19, 0x1C92, 0x1D07, 0x1D7B
  dw 0x1DEC, 0x1E5B, 0x1EC8, 0x1F32, 0x1F9A, 0x2000, 0x2062, 0x20C3, 0x2120, 0x217C
  dw 0x21D4, 0x222A, 0x227D, 0x22CE, 0x231C, 0x2367, 0x23AF, 0x23F5, 0x2438, 0x2478
  dw 0x24B5, 0x24EF, 0x2527, 0x255B, 0x258D, 0x25BB, 0x25E7, 0x2610, 0x2635, 0x2658
  dw 0x2678, 0x2695, 0x26AF, 0x26C5, 0x26D9, 0x26EA, 0x26F8, 0x2702, 0x270A, 0x270E
  dw 0x2710, 0x270E

  PIx2x10k equ 62831                 ; valor de 2 * pi * 10000
  %define circ_center_x [esi]
  %define circ_center_y [esi + 4]
  %define circ_r        [esi + 8]
  %define circ_clr      [esi + 10]


section .bss align=64

  %define x1 [ecx]
  %define y1 [ecx + 4]
  %define x2 [ecx + 8]
  %define y2 [ecx + 12]

  extern MD_Screen
  extern Mode_555
  extern VDP_Reg
  extern @Flip@4

  pt  resd 4
  %define xd [pt]
  %define yd [pt + 4]
  %define xn [pt + 8]
  %define yn [pt + 12]
  pt2 resd 4
  %define pt_x1 [pt2]
  %define pt_y1 [pt2 + 4]
  %define pt_x2 [pt2 + 8]
  %define pt_y2 [pt2 + 12]


section .data align=64

  random_seed dd 0x5E21231F


section .text align=64


; --------------------------------------------------------------------------------------
; int __fastcall SinX10k(int ang)
; retorna o valor (inteiro) do seno do angulo (em graus) multiplicado por 10000
DECL SinX10k, 4
  xor   eax, eax
  mov   edx, 360

  .pos_ang:                 ; se o ngulo for negativo, converte para equivalente positivo
  cmp   ecx, eax
  jns   .reduce_ang
  add   ecx, edx
  jmp   .pos_ang
  .reduce_ang:              ; se o ngulo for maior que 90, converte para valor
  cmp   ecx, 91             ; equivalente entre [0, 90]
  js    .get_value
  sub   ecx, 181
  js    .ang_180
  inc   ecx
  xor   edx, 1
  jmp   .reduce_ang
  .ang_180:
  not   ecx

  .get_value:
  mov   ax, word [ecx * 2 + Sin_Table]
  test  edx, 1
  jz    .end
  neg   eax
  .end:
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; int __fastcall CosX10k(int ang)
; idem  anterior para cosseno
DECL CosX10k, 4
  add  ecx, 90
  call @SinX10k@4
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; int __fastcall Module(int num)
; retorna o mdulo do nmero
DECL Module, 4
  xor  eax, eax
  cmp  ecx, eax
  jns  near .end
  neg  ecx
  .end:
  mov  eax, ecx
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; WORD __fastcall Color_24_to_16(COLORREF clr24)
; converte cor de 24 bits para 16 bits no formato usado pelo programa (555 ou 565)

; converte o valor que est em cl para al (o valor em cl  alterado)
%macro CONVERT_VALUE 0
  mov  dl, cl
  shr  dl, 3
  cmp  dl, 0x1F
  jz   %%no_inc
  and  cl, 0x07
  cmp  cl, 0x05
  js   %%no_inc
  inc  dl
  %%no_inc:
%endmacro

%macro CONVERT_COLOR_24 1
  xor  edx, edx
  CONVERT_VALUE
%if(%1 == 555)
  shl  dx, 10
%else
  shl  dx, 11
%endif
  mov  eax, edx
  shr  ecx, 8
  xor  dx, dx
  CONVERT_VALUE
%if(%1 == 555)
  shl  dx, 5
%else
  shl  dx, 6
%endif
  or   ax, dx
  shr  ecx, 8
  xor  dl, dl
  CONVERT_VALUE
  or   al, dl
%endmacro

DECL Color_24_to_16, 4
  test byte [Mode_555], 1
  jz   .mode565
  .mode555: CONVERT_COLOR_24 555
  jmp  .end  
  .mode565: CONVERT_COLOR_24 565
  .end:
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall Get_Screen_Center(LPPOINT center)
; retorna o centro da tela em center
DECL Get_Screen_Center, 4
  test byte [VDP_Reg + 48], 0x01
  jnz  .x_true
  mov  dword [ecx], 136
  jmp  .next
  .x_true:
  mov  dword [ecx], 168

  .next:
  test byte [VDP_Reg + 4], 0x08
  jnz  .y_true
  mov  dword [ecx + 4], 120
  .y_true:
  mov  dword [ecx + 4], 128
  ret
; --------------------------------------------------------------------------------------

extern Have_MMX

; --------------------------------------------------------------------------------------
; void __fastcall Fill_Screen(WORD color)
; preenche toda a tela com a cor
DECL Fill_Screen, 4
  mov  ax, cx
  shl  eax, 16
  mov  ax, cx
  mov  ecx, MD_Screen
  lea  edx, [MD_Screen + 161280]
  .loop:
    mov [ecx], eax
    add ecx, 4
    cmp ecx, edx
    js  .loop
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall Clear_Screen(void)
; preenche a tela com a cor preta
DECL Clear_Screen, 0
  test   byte [Have_MMX], 1
  jz     .no_mmx
  
  ; mmx
  pxor   mm0, mm0
  mov    ecx, 336 * 240 * 2 / 64
  mov    eax, MD_Screen
  .mmx_loop:
    movq  [eax],      mm0
    movq  [eax + 8],  mm0
    movq  [eax + 16], mm0
    movq  [eax + 24], mm0
    movq  [eax + 32], mm0
    movq  [eax + 40], mm0
    movq  [eax + 48], mm0
    movq  [eax + 56], mm0
    add   eax, 64
    dec   ecx
    jnz   .mmx_loop
  emms
  jmp    .end
  
  .no_mmx:
  mov    ecx, 336 * 240 * 2 / 32
  mov    eax, MD_Screen
  xor    edx, edx
  .loop:
    mov   [eax],      edx
    mov   [eax + 4],  edx
    mov   [eax + 8],  edx
    mov   [eax + 12], edx
    mov   [eax + 16], edx
    mov   [eax + 20], edx
    mov   [eax + 24], edx
    mov   [eax + 28], edx
    add   eax, 32
    dec   ecx
    jnz   .loop

  .end:
  ret
; --------------------------------------------------------------------------------------

; --------------------------------------------------------------------------------------
; void __fastcall Print_Line(LPPOINT points, WORD clr)
; traa a reta definida pelos dois pontos em points com a cor clr
DECL Print_Line, 8
  push ebx
  push ebp
  push esi
  push edi

  mov  esi, edx

  mov  eax, x2             ; calculando xd = x2 - x1
  sub  eax, x1
  mov  xd, eax
  cmp  eax, 0
  jns  .calc_yd            ; xd >= 0
  neg  eax                 ; eax fica com |xd|

  .calc_yd:
  mov  ebx, y2             ; calculando yd = y2 - y1
  sub  ebx, y1
  mov  yd, ebx
  cmp  ebx, 0
  jns  .calc_max           ; yd >= 0
  neg  ebx                 ; ebx fica com |yd|

  .calc_max:
  cmp  ebx, eax            ; verificando o maior valor entre |xd| e |yd|
  jns  near .prepare
  mov  ebx, eax            ; o maior valor fica armazenado em ebx
  .prepare:
  mov  ebp, ebx
  jmp  .no_print

  .loop:
    mov  eax, xd           ; calculando a coordenada x do pixel
    imul ebx
    idiv ebp
    add  eax, x1
    cmp  eax, 0            ; verificando se o valor  vlido
    js   .no_print
    cmp  eax, 336
    jns  .no_print
    mov  edi, eax          ; salvando o valor em edi

    mov  eax, yd           ; calculando a coordenada y do pixel
    imul ebx
    idiv ebp
    add  eax, y1           ; o valor fica em eax
    cmp  eax, 0            ; verificando se o valor  vlido
    js   .no_print
    cmp  eax, 240
    jns  .no_print

    sub  eax, 239          ; invertendo y
    neg  eax
    imul eax, 336
    add  eax, edi
    mov  [eax * 2 + MD_Screen], si

  .no_print:
  dec  ebx
  cmp  ebx, 0
  jns  .loop

  pop  edi
  pop  esi
  pop  ebp
  pop  ebx
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall Fill_Rect(LPPOINT points, WORD clr)
; imprime o ratngulo definido pelos dois pontos
DECL Fill_Rect, 8
  push ebx
  push ebp

  mov  eax, x2
  mov  ebx, x1
  sub  eax, ebx
  jns  .no_swap_x
  neg  eax
  mov  ebx, x2
  .no_swap_x:
  mov  xn, ebx
  mov  xd, eax

  mov  eax, y2
  mov  ebx, y1
  sub  eax, ebx
  jns  .no_swap_y
  neg  eax
  mov  ebx, y2
  .no_swap_y:
  mov  yn, ebx
  mov  yd, eax

  .loop_y:
  mov eax, xn
  cmp ebx, 335
  jns .no_print_y

    .loop_x:
    mov  ebp, ebx
    sub  ebp, 240
    jns  .no_print_x
    not  ebp
    imul ebp, 336
    add  ebp, eax
    mov  [ebp * 2 + MD_Screen], dx
    .no_print_x:
    inc  eax
    cmp  eax, xd
    jnz  .loop_x

  .no_print_y:
  inc ebx
  cmp ebx, yd
  jnz .loop_y

  pop  ebp
  pop  ebx
  ret
; --------------------------------------------------------------------------------------

; se 1, o programa aproxima os pontos da circunferncia (a circunferncia perde simetria)
%define APROX_POINTS 0

; --------------------------------------------------------------------------------------
; void __fastcall Print_Circle(LPCIRCLE_PARAMS circ)
; imprime uma crcunferencia na tela
DECL Print_Circle, 4
  push  ebx
  push  ebp
  push  esi

  mov   esi, ecx

  ; calculando o permetro da circunferncia
  mov   eax, PIx2x10k
  xor   ebx, ebx
  mov   bx, circ_r
  mul   ebx
  mov   ebx, 10000
  div   ebx
  cmp   edx, 5001
  js    .ok
  inc   eax               ; eax fica com o permetro da circunferncia aproximado
  ; verificando a necessidade em se unir pontos com retas (valores limitados de seno e cosseno)
  .ok:
  cmp   eax, 1
  js    near .end
  cmp   eax, 361
  jns   near .print_lines


  ; aqui a funo s traa pontos
  mov   ebx, eax
  mov   eax, 360
  xor   edx, edx
  div   ebx
  mov   ebp, eax          ; ebp est com o incremento do loop (que vai de 0 a 360)
  ; melhorando a aproximao de ebp
  mov   ecx, edx
  xor   edx, edx
  mov   eax, ebx
  mov   ebx, 2
  div   ebx
  inc   eax
  mov   ebx, 360
  cmp   ecx, eax
  js    .loop_p
  inc   ebp

  .loop_p:                ; calculando o valor x do ponto
  sub   ebx, ebp
  js    near .end

    mov   ecx, ebx
    call  @CosX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_x_p
    inc   eax
    .ok_x_p:
%endif
    add   eax, circ_center_x
    cmp   eax, 336
    jns   .loop_p         ; o valor x est fora da tela
    cmp   eax, 0
    js    .loop_p
    mov   [pt], eax
    ; calculando o valor y do ponto
    mov   ecx, ebx
    call  @SinX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_y_p
    inc   eax
    .ok_y_p:
%endif
    add   eax, circ_center_y
    cmp   eax, 0
    js    .loop_p
    sub   eax, 240
    jns   .loop_p         ; o valor y est fora da tela
    not   eax
    ; marcando o ponto
    mov   ecx, 336
    imul  ecx
    add   eax, [pt]
    mov   dx, circ_clr
    mov   [eax * 2 + MD_Screen], dx

  jmp   .loop_p


  .print_lines:          ; neste caso a funo traa retas entre os pontos da circunferncia
  xor   ebx, ebx

  .loop_l:
  cmp   ebx, 360
  jns   near .end

    ; calculando x do ponto 1
    mov   ecx, ebx
    call  @CosX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_x_l1
    inc   eax
    .ok_x_l1:
%endif
    add   eax, circ_center_x
    mov   pt_x1, eax
    ; calculando y do ponto 1
    mov   ecx, ebx
    call  @SinX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_y_l1
    inc   eax
    .ok_y_l1:
 %endif
    add   eax, circ_center_y
    mov   pt_y1, eax

    inc   ebx

    ; calculando x do ponto 2
    mov   ecx, ebx
    call  @CosX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_x_l2
    inc   eax
    .ok_x_l2:
%endif
    add   eax, circ_center_x
    mov   pt_x2, eax
    ; calculando y do ponto 1
    mov   ecx, ebx
    call  @SinX10k@4
    xor   ecx, ecx
    mov   cx, circ_r
    imul  ecx
    mov   ecx, 10000
    idiv  ecx
%if(APROX_POINTS != 0)
    cmp   edx, 5001
    js    .ok_y_l2
    inc   eax
    .ok_y_l2:
%endif
    add   eax, circ_center_y
    mov   pt_y2, eax

    ; traando a reta entre os dois pontos
    mov   ecx, pt2
    xor   edx, edx
    mov   dx, circ_clr
    call  @Print_Line@8

  jmp   .loop_l


  .end:
  pop   esi
  pop   ebp
  pop   ebx
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall Black_White_Screen(void)
; tira a cor da tela

%macro REMOVE_SCREEN_COLORS 1
  %%loop:
  dec  ecx
  dec  ecx
  mov  bx, [ecx]
  ; decompondo a cor (r, g, b)
  mov  eax, ebx
  and  eax, 0x001F
%if(%1 == 555)
  shr  ebx, 5
%else
  shr  ebx, 6
%endif
  mov  edx, ebx
  and  edx, 0x001F
  shr  ebx, 5
  and  ebx, 0x001F
  ; calculando a mdia dos valores decompostos
  add  eax, edx
  add  eax, ebx
  xor  edx, edx
  mov  ebx, 3
  div  ebx
  ; substituindo a cor
  mov  ebx, eax
%if(%1 == 555)
  shl  eax, 5
%else
  shl  eax, 6
%endif
  or   ebx, eax
  shl  eax, 5
  or   ebx, eax
  mov  [ecx], bx

  cmp  ecx, MD_Screen
  jnz  %%loop
%endmacro

DECL Black_White_Screen, 0
  push ebx

  mov  ecx, MD_Screen
  add  ecx, 161280
  test byte [Mode_555], 1
  jz   near .565

  REMOVE_SCREEN_COLORS 555
  jmp  .end
  .565:
  REMOVE_SCREEN_COLORS 565

  .end:
  pop  ebx
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall Black_White_Screen_Grad(void)
; vai descolorindo a tela gradativamente

%macro APROX 1-2
  cmp  %1, %2
  jz   %%end
  js   %%inc
  dec  %1
  jmp  %%end
  %%inc:
  cmp  %1, 0x1F
  jns  %%end
  inc  %1
  %%end:
%endmacro

%macro REDUCE_SCREEN_COLORS 1
  %%loop:
  dec  ecx
  dec  ecx
  mov  bx, [ecx]
  ; decompondo a cor (r, g, b)
  mov  esi, ebx
  and  esi, 0x001F                ; esi - azul
%if(%1 == 555)
  shr  ebx, 5
%else
  shr  ebx, 6
%endif
  mov  ebp, ebx
  and  ebp, 0x001F                ; ebp - verde
  shr  ebx, 5
  and  ebx, 0x001F                ; ebx - vermelho
  ; calculando a mdia dos valores decompostos
  mov  eax, esi
  add  eax, ebp
  add  eax, ebx
  xor  edx, edx
  div  esp
  ; aproximando valores da mdia
  APROX esi, eax
  APROX ebp, eax
  APROX ebx, eax
  ; montando a nova cor
%if(%1 == 555)
  shl  ebp, 5
%else
  shl  ebp, 6
%endif
  or   esi, ebp
%if(%1 == 555)
  shl  ebx, 10
%else
  shl  ebx, 11
%endif
  or   esi, ebx
  mov [ecx], si

  cmp  ecx, MD_Screen
  jnz  %%loop
%endmacro

DECL Black_White_Screen_Grad, 0
  pushad
  mov  [pt], esp

  mov  ecx, MD_Screen
  add  ecx, 161280
  mov  esp, 3
  test byte [Mode_555], 1
  jz   near .565

  REDUCE_SCREEN_COLORS 555
  jmp  .end
  .565:
  REDUCE_SCREEN_COLORS 565

  .end:
  mov  esp, [pt]
  popad
  ret
; --------------------------------------------------------------------------------------

