%include "nasmhead.inc"

section .data align=64

  extern MD_Screen
  extern MD_Palette
  extern CDD.Control
  extern CDD.Rcv_Status
  extern CDD.Status
  extern CDD.Minute
  extern CDD.Seconde
  extern CDD.Frame
  extern CDD.Ext

  Mask:      dd 0x00000000, 0x00000000
  Mask_GG_15:    dd 0x03E003E0, 0x03E003E0
  Mask_RBRB_15:  dd 0x7C1F7C1F, 0x7C1F7C1F
  Mask_GG_16:    dd 0x07C007C0, 0x07C007C0
  Mask_RBRB_16  dd 0xF81FF81F, 0xF81FF81F

  Mask_1001_64  dd 0xFFFF0000, 0x0000FFFF
  Mask_0011_64  dd 0xFFFFFFFF, 0x00000000
  Mask_1100_64  dd 0x00000000, 0xFFFFFFFF


section .bss align=64

  extern VDP_Reg
  extern Mode_555
  extern MD_Screen

  DECL CPU_Model
  resd 1
  DECL Have_MMX
  resd 1
  DECL MMX_Enable
  resd 1

section .text align=64

%macro AFF_PIXEL 2

    mov eax, ebx              ; eax = donnes pixels
    shr eax, %2                ; on garde le premier
    and eax, 0xF
    mov ax, [MD_Palette + eax * 2 + ebp]  ; conversion 8->16 bits palette
    mov [edi + (%1 * 2)], ax        ; on affiche le pixel dans Dest

%endmacro


%macro AFF_LINE_LETTER 1

  %%Pix0
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 0]
    test dl, dl
    jz %%Pix1
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 2 * %1) + 0], ax

  %%Pix1
    mov  dl, byte [Small_Police + ecx + (%1 * 4) + 1]
    test dl, dl
    jz %%Pix2
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 2 * %1) + 2], ax

  %%Pix2
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 2]
    test dl, dl
    jz %%Pix3
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 2 * %1) + 4], ax

  %%Pix3
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 3]
    test dl, dl
    jz %%End
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 2 * %1) + 6], ax

  %%End

%endmacro


%macro AFF_LINE_LETTER_X2 1

  %%Pix0
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 0]
    test dl, dl
    jz %%Pix1
    mov ax, [ebx + edx * 2]
    rol eax, 16
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 4 * %1) + 0], eax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 0], eax

  %%Pix1
    mov  dl, byte [Small_Police + ecx + (%1 * 4) + 1]
    test dl, dl
    jz %%Pix2
    mov ax, [ebx + edx * 2]
    rol eax, 16
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 4 * %1) + 4], eax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 4], eax

  %%Pix2
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 2]
    test dl, dl
    jz %%Pix3
    mov ax, [ebx + edx * 2]
    rol eax, 16
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 4 * %1) + 8], eax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 8], eax

  %%Pix3
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 3]
    test dl, dl
    jz %%End
    mov ax, [ebx + edx * 2]
    rol eax, 16
    mov ax, [ebx + edx * 2]
    mov [edi + (336 * 4 * %1) + 12], eax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 12], eax

  %%End

%endmacro


%macro AFF_LINE_LETTER_T 1

  %%Pix0
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 0]
    test dl, dl
    jz %%Pix1
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 2 * %1) + 0]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add ax, dx
    xor dh, dh
    mov [edi + (336 * 2 * %1) + 0], ax

  %%Pix1
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 1]
    test dl, dl
    jz %%Pix2
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 2 * %1) + 2]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add ax, dx
    xor dh, dh
    mov [edi + (336 * 2 * %1) + 2], ax

  %%Pix2
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 2]
    test dl, dl
    jz %%Pix3
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 2 * %1) + 4]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add ax, dx
    xor dh, dh
    mov [edi + (336 * 2 * %1) + 4], ax

  %%Pix3
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 3]
    test dl, dl
    jz %%End
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 2 * %1) + 6]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add ax, dx
    xor dh, dh
    mov [edi + (336 * 2 * %1) + 6], ax

  %%End

%endmacro


%macro AFF_LINE_LETTER_T_X2 1

  %%Pix0
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 0]
    test dl, dl
    jz %%Pix1
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 4 * %1) + 0]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 0], dx
    mov dx, [edi + (336 * 4 * %1) + 2]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 2], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 0]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 0], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 2]
    and dx, [Mask]
    shr dx, 1
    add ax, dx
    mov [edi + (336 * 4 * %1) + (336 * 2) + 2], ax
    xor dh, dh

  %%Pix1
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 1]
    test dl, dl
    jz %%Pix2
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 4 * %1) + 4]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 4], dx
    mov dx, [edi + (336 * 4 * %1) + 6]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 6], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 4]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 4], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 6]
    and dx, [Mask]
    shr dx, 1
    add ax, dx
    mov [edi + (336 * 4 * %1) + (336 * 2) + 6], ax
    xor dh, dh

  %%Pix2
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 2]
    test dl, dl
    jz %%Pix3
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 4 * %1) + 8]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 8], dx
    mov dx, [edi + (336 * 4 * %1) + 10]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 10], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 8]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 8], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 10]
    and dx, [Mask]
    shr dx, 1
    add ax, dx
    mov [edi + (336 * 4 * %1) + (336 * 2) + 10], ax
    xor dh, dh

  %%Pix3
    mov dl, byte [Small_Police + ecx + (%1 * 4) + 3]
    test dl, dl
    jz %%End
    mov ax, [ebx + edx * 2]
    mov dx, [edi + (336 * 4 * %1) + 12]
    and ax, [Mask]
    and dx, [Mask]
    shr ax, 1
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 12], dx
    mov dx, [edi + (336 * 4 * %1) + 14]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + 14], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 12]
    and dx, [Mask]
    shr dx, 1
    add dx, ax
    mov [edi + (336 * 4 * %1) + (336 * 2) + 12], dx
    mov dx, [edi + (336 * 4 * %1) + (336 * 2) + 14]
    and dx, [Mask]
    shr dx, 1
    add ax, dx
    mov [edi + (336 * 4 * %1) + (336 * 2) + 14], ax
    xor dh, dh

  %%End

%endmacro


  ALIGN4

  ; void Identify_CPU(void)
  DECL Identify_CPU

    pushad

    mov dword [Have_MMX], 0
    mov dword [CPU_Model], 0
    pushfd
    pop eax
    mov ebx, eax
    xor eax, 0x200000
    push eax
    popfd
    pushfd
    pop eax
    xor eax, ebx
    and eax, 0x200000
    jz .not_supported    ; CPUID instruction not supported

    xor eax, eax
    cpuid          ; get number of CPUID functions
    test eax, eax
    jz .not_supported    ; CPUID function 1 not supported

    mov eax, 1
    cpuid          ; get family and features
    and eax, 0x000000F00  ; family
    and edx, 0x0FFFFF0FF  ; features flags
    or eax, edx        ; combine bits
    mov [CPU_Model], eax  ; Store CPU Model
    test eax, 0x00800000  ; Having MMX ?
    setnz [Have_MMX]    ; Store it

  .not_supported
    popad
    ret

  ALIGN32

  ; int Half_Blur(void)
  DECL Half_Blur

    push ebx
    push ecx
    push edx
    push edi
    push esi

    test byte [Have_MMX], 0xFF
    jz near .No_MMX

    mov esi, MD_Screen
    mov ecx, (336 * 240 * 2) / 8
    xor edi, edi
    xor edx, edx

    movq mm6, [Mask_RBRB_16]
    movq mm7, [Mask_GG_16]

    test byte [Mode_555], 1
    jz short .MMX_Loop

    movq mm6, [Mask_RBRB_15]
    movq mm7, [Mask_GG_15]
    jmp short .MMX_Loop

  ALIGN32

  .MMX_Loop
      movq mm0, [esi]
      movq mm1, mm0
      movq mm2, [esi + 2]
      movq mm3, mm2
      pand mm0, mm6
      pand mm1, mm7
      pand mm2, mm6
      pand mm3, mm7
      psrlw mm0, 1
      psrlw mm1, 1
      psrlw mm2, 1
      psrlw mm3, 1
      paddusw mm0, mm2
      paddusw mm1, mm3
      pand mm0, mm6
      pand mm1, mm7
      add esi, 8
      paddw mm0, mm1
      dec ecx
      movq [esi - 8], mm0
      jnz short .MMX_Loop

    emms
    pop esi
    pop edi
    pop edx
    pop ecx
    pop ebx
    ret

  ALIGN32

  .No_MMX
    mov esi, MD_Screen
    mov ecx, 336 * 240  ; nombre de pix 16 bits  rendre en blur
    xor edi, edi
    xor edx, edx
    test byte [Mode_555], 1
    jnz short .Loop_555
    jmp short .Loop_565

  ALIGN32

  .Loop_555
      mov ax, [esi]
      add esi, 2
      shr ax, 1
      mov bx, ax
      and ax, 0x3C0F
      and bx, 0x01E0
      add di, ax
      add dx, bx
      add dx, di
      dec ecx
      mov [esi - 2], dx
      mov di, ax
      mov dx, bx
      jnz short .Loop_555

    pop esi
    pop edi
    pop edx
    pop ecx
    pop ebx
    ret

  ALIGN32

  .Loop_565
      mov ax, [esi]
      add esi, 2
      shr ax, 1
      mov bx, ax
      and ax, 0x780F
      and bx, 0x03E0
      add di, ax
      add dx, bx
      add dx, di
      dec ecx
      mov [esi - 2], dx
      mov di, ax
      mov dx, bx
      jnz .Loop_565

    pop esi
    pop edi
    pop edx
    pop ecx
    pop ebx
    ret


  ALIGN4

  ; void Byte_Swap(void *Ptr, int NumByte)
  DECL Byte_Swap

    push eax
    push ecx
    push edi

    mov ecx, [esp + 20]
    mov edi, [esp + 16]
    shr ecx, 1
    jz short .end

  ALIGN4

  .loop
      mov ax, [edi]
      add edi, 2
      rol ax, 8
      dec ecx
      mov [edi - 2], ax
      jnz short .loop

  .end

    pop edi
    pop ecx
    pop eax
    ret


  ALIGN32

    ;void Cell_8x8_Dump(unsigned char *Adr, int Palette)
    DECL Cell_8x8_Dump

    push ebx
    push ecx
    push edx
    push edi
    push esi
    push ebp

    xor eax, eax          ; eax = 0
    mov ebp, [esp + 32]        ; ebp = nb_pal
    mov edx, 20            ; edx = Nombre de lignes de pattern  afficher
    mov esi, [esp + 28]        ; esi = Adresse
    shl ebp, 5            ; ebp = nb_pal * 32
    lea edi, [MD_Screen  + 6780]    ; edi = MD_Screen + marge pour l'affichage

  .Loop_EDX
    mov ecx, 16            ; ecx = Nombre de pattern par ligne

  .Loop_ECX
    mov ebx, 8            ; ebx = Nombre de ligne de chaque pattern

  .Loop_EBX
    push ebx
    mov ebx, [esi]
    AFF_PIXEL 0, 12
    AFF_PIXEL 1, 8
    AFF_PIXEL 2, 4
    AFF_PIXEL 3, 0
    AFF_PIXEL 4, 28
    AFF_PIXEL 5, 24
    AFF_PIXEL 6, 20
    AFF_PIXEL 7, 16
    pop ebx
    add esi, 4            ; on avance de 4 dans la Src
    add edi, 336 * 2        ; va sur la prochaine ligne dans Dest
    dec ebx              ; s'il reste des lignes du pattern
    jnz near .Loop_EBX        ; alors on continue

    sub edi, ((336 * 8) - 8) * 2  ; on retourne 8 lignes en arriere et on avance de 8 pixels pour Dest
    dec ecx              ; s'il reste des pattern en longueur
    jnz near .Loop_ECX        ; alors on continue

    add edi, ((336 * 8) - (8 * 16)) * 2    ; on avance de 8 lignes et on recule de 16 * 8 pixels (pattern) pour Dest
    dec edx
    jnz near .Loop_EDX

    pop ebp
    pop esi
    pop edi
    pop edx
    pop ecx
    pop ebx
    ret


  ALIGN32

    ;void Cell_16x16_Dump(unsigned char *Adr, int Palette)
    DECL Cell_16x16_Dump

    push ebx
    push ecx
    push edx
    push edi
    push esi
    push ebp

    xor eax, eax          ; eax = 0
    mov ebp, [esp + 32]        ; ebp = nb_pal
    mov edx, 10            ; edx = Nombre de lignes de pattern  afficher
    mov esi, [esp + 28]        ; esi = Adresse
    shl ebp, 5            ; ebp = nb_pal * 32
    lea edi, [MD_Screen  + 6780]    ; edi = MD_Screen + marge pour l'affichage

  .Loop_EDX
    mov ecx, 16            ; ecx = Nombre de pattern par ligne

  .Loop_ECX
    mov ebx, 8            ; ebx = Nombre de ligne de chaque pattern

  .Loop_EBX
    push ebx
    mov ebx, [esi]
    AFF_PIXEL 0, 12
    AFF_PIXEL 1, 8
    AFF_PIXEL 2, 4
    AFF_PIXEL 3, 0
    AFF_PIXEL 4, 28
    AFF_PIXEL 5, 24
    AFF_PIXEL 6, 20
    AFF_PIXEL 7, 16
    pop ebx
    add esi, 4            ; on avance de 4 dans la Src
    add edi, 336 * 2        ; va sur la prochaine ligne dans Dest
    dec ebx              ; s'il reste des lignes du pattern
    jnz near .Loop_EBX        ; alors on continue

    sub edi, ((336 * 8) - 8) * 2  ; on retourne 8 lignes en arriere et on avance de 8 pixels pour Dest
    add esi, 0x20          ; pattern  droite
    dec ecx              ; s'il reste des pattern en longueur
    jnz near .Loop_ECX        ; alors on continue

    add edi, ((336 * 8) - (8 * 16)) * 2    ; on avance de 8 lignes et on recule de 16 * 8 pixels (pattern) pour Dest
    sub esi, 0x400 - 0x20
    mov ecx, 16            ; ecx = Nombre de pattern par ligne

  .Loop_ECX_2
    mov ebx, 8            ; ebx = Nombre de ligne de chaque pattern

  .Loop_EBX_2
    push ebx
    mov ebx, [esi]
    AFF_PIXEL 0, 12
    AFF_PIXEL 1, 8
    AFF_PIXEL 2, 4
    AFF_PIXEL 3, 0
    AFF_PIXEL 4, 28
    AFF_PIXEL 5, 24
    AFF_PIXEL 6, 20
    AFF_PIXEL 7, 16
    pop ebx
    add esi, 4            ; on avance de 4 dans la Src
    add edi, 336 * 2        ; va sur la prochaine ligne dans Dest
    dec ebx              ; s'il reste des lignes du pattern
    jnz near .Loop_EBX_2      ; alors on continue

    sub edi, ((336 * 8) - 8) * 2  ; on retourne 8 lignes en arriere et on avance de 8 pixels pour Dest
    add esi, 0x20          ; pattern  droite
    dec ecx              ; s'il reste des pattern en longueur
    jnz near .Loop_ECX_2      ; alors on continue

    add edi, ((336 * 8) - (8 * 16)) * 2    ; on avance de 8 lignes et on recule de 16 * 8 pixels (pattern) pour Dest
    sub esi, 0x20
    dec edx
    jnz near .Loop_EDX

    pop ebp
    pop esi
    pop edi
    pop edx
    pop ecx
    pop ebx
    ret


  ALIGN32

  ; void CDD_Export_Status(void)
  DECL CDD_Export_Status
    push ebx
    push ecx

    mov ax, [CDD.Status]
    mov bx, [CDD.Minute]
    mov cx, [CDD.Seconde]
    mov [CDD.Rcv_Status + 0], ax
    mov [CDD.Rcv_Status + 2], bx
    mov [CDD.Rcv_Status + 4], cx
    add al, bl
    add al, bh
    mov bx, [CDD.Frame]
    add al, ch
    add al, cl
    and byte [CDD.Control], 0x3
    add al, ah
    add al, bl
    mov ah, [CDD.Ext]
    add al, bh
    add al, ah
    mov [CDD.Rcv_Status + 6], bx
    not al
    and al, 0x0F
    mov [CDD.Rcv_Status + 8], ax

    pop ecx
    pop ebx
    ret
