/* cheats.cpp - projeto gens+. Rodrigo Cardoso.
   Este arquivo contm as rotinas para compilar os arquivos de script com o cheats. */

#include "gmain.h"
#include "cheats.h"
#include "grom.h"

// macros usadas pela funo Compile_Cheats_File
#define CHECK_MNEMONIC(mn)  script.is_value_mnemonic(mn)
#define CHECK_CHARACTER(ch) script.is_value_char(ch)
#define CHECK_NUMBER       (script.is_value_string ? 0 : script.buf.convert_to_number())

#define SKIP (SKIP_SPACES | SKIP_COMMENTS)
#define LOOP script.read_next_value(SKIP, sp_char)
#define END  goto end_compile

#define VALUE_LEN       script.buf.len
#define READ_NEXT_VALUE if(!script.read_next_value (SKIP, sp_char)) { END; }
#define READ_NEXT_NUM   if(!script.read_next_number(SKIP, sp_char)) { END; }

#define SAVE_POS(pos)    if((pos = ftell(pfile)) == -1)       { END; }
#define SET_POS(pos)     if(fseek(pfile, pos, SEEK_SET))      { END; }
#define WRITE(ptr, size) if(fwrite(ptr, size, 1, pfile) != 1) { END; }
#define WRITE_VALUE      WRITE(script.buf.ptr, script.buf.len + 1);

#define NUM           script.buf.num
#define WRITE_NUM     WRITE(&NUM, 4)
#define WRITE_NUM_(n) { NUM = n; WRITE_NUM; }

#define WRITE_VALUE_TYPE                                \
  if     (CHECK_MNEMONIC("dword"  )) NUM = CFT_DWORD;   \
  else if(CHECK_MNEMONIC("word"   )) NUM = CFT_WORD;    \
  else if(CHECK_MNEMONIC("byte"   )) NUM = CFT_BYTE;    \
  else if(CHECK_MNEMONIC("iword"  )) NUM = CFT_IWORD;   \
  else if(CHECK_MNEMONIC("diword" )) NUM = CFT_DIWORD;  \
  else if(CHECK_MNEMONIC("idword" )) NUM = CFT_IDWORD;  \
  else if(CHECK_MNEMONIC("idiword")) NUM = CFT_IDIWORD; \
  else END;                                             \
  WRITE_NUM

#define ADD_TABLE(pos)  tables.add_string(script.buf.ptr, pos)
#define ADD_TVALUE(pos) tvalues.add_string(script.buf.ptr, pos)


FILE *__stdcall Compile_Cheats_File(LPCSTR lpInFile, LPCSTR lpOutFile)
{
  SCRIPT     script;
  FILE      *pfile;
  STRINGS    tables, tvalues;
  int        pos1, pos2, pos3, n, size;
  BOOL       rval = FALSE;
  const char sp_char[] = "{}=,:";
  char       ptmp[GMAX_PATH * 2], pflags[8];

  if(!lpInFile)
  {
    if(!(*Rom_Name)) return FALSE;
    lpInFile = ptmp;
    sprintf(ptmp, "%s%s.cht", Cheats_Dir, Rom_Name);
  }
  script.pfile = fopen(lpInFile, "rtS");
  if(!script.pfile) return FALSE;

  if(lpOutFile) strcpy(pflags, "w+b");
  else
  {
    lpOutFile = ptmp;
    GetTempPath(GMAX_PATH, ptmp + GMAX_PATH);
    GetTempFileName(ptmp + GMAX_PATH, "cht", 0, ptmp);
    strcpy(pflags, "w+bRD");
  }
  pfile = fopen(lpOutFile, pflags);
  if(!pfile) { goto end_compile; }

  // inserindo identificador no arquivo
  NUM = CCFILE_TYPE;    WRITE_NUM;
  NUM = CCFILE_VERSION; WRITE_NUM;

  // ------------- lendo o arquivo de script -------------
  while(LOOP)
  {

    // ------------- TABELA -------------
    if(CHECK_MNEMONIC("TABLE"))
    {
      SAVE_POS(pos1);               // salvando a posio da tabela
      WRITE_NUM_(CFI_TABLE);        // inserindo identificador
      WRITE_NUM;                    // reservando espao para o tamanho da tabela
      WRITE_NUM;                    // reservando espao para o nmero de itens na tabela
      READ_NEXT_VALUE;              // tipo de valores
      WRITE_VALUE_TYPE;
      READ_NEXT_VALUE;              // nome da tabela
      if(CHECK_CHARACTER(',')) { READ_NEXT_VALUE; }
      ADD_TABLE(pos1);              // adicionando o nome e a posio da tabela na memria
      size = 8;
      READ_NEXT_VALUE;              // "begin"
      if(CHECK_MNEMONIC("BEGIN") || CHECK_CHARACTER('{'))
      {
        n = 0;                      // nmero de itens
        READ_NEXT_VALUE;
        // lendo todos os dados da tabela
        while(!CHECK_MNEMONIC("END") && !CHECK_CHARACTER('}'))
        {
          size += VALUE_LEN + 5;
          n++;
          WRITE_VALUE;              // nome do item
          READ_NEXT_VALUE;
          if(CHECK_CHARACTER('=')) { READ_NEXT_VALUE; }
          if(!CHECK_NUMBER) END;
          WRITE_NUM;
          READ_NEXT_VALUE;
          if(CHECK_CHARACTER(',')) { READ_NEXT_VALUE; }
        }
        SAVE_POS(pos2);
        SET_POS(pos1 + 4);
        WRITE(&size, 4);            // salvando o tamanho da tabela
        WRITE(&n, 4);               // salvando o nmero de itens na tabela
        SET_POS(pos2);
      }
      else END; // erro
    }
    // --------------------------


    // ------------- VALOR -------------
    else if(CHECK_MNEMONIC("VALUE"))
    {
      WRITE_NUM_(CFI_VALUE);        // inserindo identificador
      SAVE_POS(pos1);
      WRITE_NUM;                    // reservando espao para o tamanho
      READ_NEXT_NUM;                // endereo do valor na RAM
      WRITE_NUM;
      READ_NEXT_VALUE;              // tipo de valor
      // o valor est associado  uma tabela
      if(CHECK_MNEMONIC("USE_TABLE"))
      {
        NUM = CFT_TABLE;
        WRITE_NUM;
        READ_NEXT_VALUE;            // lendo o nome da tabela associada
        if(CHECK_CHARACTER(':') || CHECK_CHARACTER('='))
        { READ_NEXT_VALUE; }
        SAVE_POS(pos3);
        ADD_TVALUE(pos3);           // adicionando o nome  memria
      }
      else
      { WRITE_VALUE_TYPE; NUM = 0; }
      WRITE_NUM;                    // reservando espao para o endereo da tabela
      READ_NEXT_VALUE;              // nome do valor
      if(CHECK_CHARACTER(',')) { READ_NEXT_VALUE; }
      WRITE_VALUE;                  // inserindo nome
      size = VALUE_LEN + 13;
      SAVE_POS(pos2);
      SET_POS(pos1);
      WRITE(&size, 4);              // salvando o tamanho
      SET_POS(pos2);
    }
    // --------------------------

    else END;
  }

  // --------------------------


  // ------------- associando valores e tabelas -------------
  for(pos1 = 0; pos1 < tvalues.nstr; pos1++)
  {
    pos3 = 1;
    for(pos2 = 0; pos2 < tables.nstr; pos2++)
    {
      if(!strcmpi(tvalues.ptr[pos1].str, tables.ptr[pos2].str))
      { pos3 = 0; break; }
    }
    if(pos3) END; // a tabela associada ao valor no existe
    SET_POS(tvalues.ptr[pos1].value);
    WRITE(&tables.ptr[pos2].value, 4);
  }
  // --------------------------

  rval = TRUE;
end_compile:
  fclose(script.pfile);
  if(rval) { fseek(pfile, 0, SEEK_SET); }
  else     { fclose(pfile); pfile = NULL; }
  return pfile;
}
