/*
  O arquivo de cheats compilado segue a seguinte formatao:
  * os primeiros quatro bytes identificam o arquivo e devem ser CCFILE_TYPE;
  * os quatro bytes seguintes contm a verso do arquivo (CCFILE_VERSION);
  *  seguir vm as tabelas e valores:
  -- TABELA (ver estrutura TABLEHDR):
  DWORD - CFI_TABLE (identifica o que vem como tabela);
  DWORD - tamanho da tabela (nmero de bytes entre a posio  seguir e o fim da
          tabela);
  DWORD - nmero de itens na tabela;
  DWORD - tipo (pode ser qualquer tipo, com excesso de CFT_TABLE);
   seguir vem os itens da tabela:
    LPSTR - nome do item (string terminada em zero);
    DWORD - valor nmerico do item (os valores sempre tero 4 bytes independente do tipo).
  -- VALOR (ver estrutura VALUEHDR):
  DWORD - CFI_VALUE (identificador);
  DWORD - tamanho (idem ao tamanho da tabela);
  DWORD - endereo do valor;
  DWORD - tipo de valor:
  DWORD - endereo da tabela associada ao valor (s  vlido se o valor anterior for
          CFT_TABLE, caso contrrio, esse valor no tem importncia).
  LPSTR - nome do valor (tamanho varivel - string terminada em 0);
*/


#ifndef _CHEATS_H
#define _CHEATS_H

#include <windows.h>
#include <stdio.h>
#include "script.h"


typedef struct _TABLEHDR {
  DWORD  dwID;       // deve ser CFI_TABLE
  DWORD  dwOffset;   // distncia em bytes da posio atual at o fim da tabela
  DWORD  nItems;     // nmero de itens na tabela
  DWORD  dwType;     // tipo (pode ser qualquer um, menos CFT_TABLE)
} TABLEHDR, *LPTABLEHDR;

typedef struct _VALUEHDR {
  DWORD  dwID;       // deve ser CFI_VALUE
  DWORD  dwOffset;   // idem  tabela
  DWORD  dwAdr;      // endereo do valor na memria
  DWORD  dwType;     // tipo de valor
  DWORD  dwTable;    // se dwType == CFT_TABLE, posio da tabela no arquivo
} VALUEHDR, *LPVALUEHDR;


// identifica um arquivo de cheats compilado
#define CCFILE_TYPE    0x00464343
#define CCFILE_VERSION 0x0001

// estes so os identificadores usados no arquivo de cheats compilado
#define CFI_TABLE   0x0001  // tabela
#define CFI_VALUE   0x0002  // valor

// tipos de valores
#define CFT_TABLE   0x0001
#define CFT_DWORD   0x0002
#define CFT_WORD    0x0003
#define CFT_BYTE    0x0004
#define CFT_IWORD   0x0005
#define CFT_DIWORD  0x0006
#define CFT_IDWORD  0x0007
#define CFT_IDIWORD 0x0008

/*
  Esta funo converte um arquivo de cheats em script para arquivo binrio.
  * lpInFile - nome do arquivo de script de onde os cheats devem ser lidos, caso este
    valor seja NULL, a funo criar um nome  partir do nome da rom atualmente aberta;
  * lpOutFile - nome do arquivo binrio que dever ser criado, caso for NULL, a funo
    criar um arquivo temporrio com o flag FILE_FLAG_DELETE_ON_CLOSE.
*/
FILE *__stdcall Compile_Cheats_File(LPCSTR lpInFile, LPCSTR lpOutFile);


#endif // _CHEATS_H
