
#ifndef _SMS_H_
#define _SMS_H_

#include <windows.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include "smscpu.h"
#include "sms.h"
#include "smsvdp.h"
#include "ym2413.h"
#include "smsrend.h"
#include "sn76496.h"
#include "system.h"
#include "gmain.h"
#include "gens.h"
#include "ggraphic.h"
#include "gdsound.h"
#include "gdinput.h"
#include "grom.h"
#include "config.h"
#include "gintro.h"
#include "gio.h"
#include "mem_z80.h"
#include "mem_m68k.h"

#define TYPE_OVERSEAS   0
#define TYPE_DOMESTIC   1

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned char Rom_Data[];

extern int  SMS_Started;
extern int  SMS_Rom_Pages;
extern int  Is_GG;
#define     SMS_Dummy  (Rom_Data + (1024 * 512 * 4))

// SMS context
typedef struct _SMS
{
  BYTE fcr[4];
  BYTE country;
  BYTE port_3F;
  BYTE port_F2;
  BYTE psg_mask;
  BYTE ym_cur_reg;
  int  paused;
} SMS_CONTEXT;

extern SMS_CONTEXT sms;

int  __fastcall Do_SMS_Frame(void);
int  __fastcall Do_SMS_Frame_Fast(void);

void __fastcall SMS_Reset(void);

void __stdcall  SMS_Load_SRAM(void);
void __stdcall  SMS_Save_SRAM(void);
void __stdcall  Export_SMS(LPBYTE);
void __stdcall  Import_SMS(LPBYTE);

int  __fastcall SMS_Init(LPGROM_INFO);
void __fastcall SMS_End_Emulation(void);

#ifdef ASMZ80

#define SMS_STATE_FILE_LENGHT \
  (0x60A0 + sizeof(SMS_CONTEXT) + sizeof(SZ80_CONTEXT) - 0x108 + sizeof(SVDP) + sizeof(OPLL) + sizeof(t_SN76496))

#else

#define SMS_STATE_FILE_LENGHT \
  (0x60A0 + sizeof(SMS_CONTEXT) + sizeof(SZ80) + sizeof(SVDP) + sizeof(OPLL) + sizeof(t_SN76496))

#endif

#ifdef __cplusplus
}
#endif

#endif // _SMS_H_
