; smsrendx.asm - projeto gens+, Rodrigo Cardoso
; render do master/gg

%include "nasmhead.inc"

  extern _vp_hstart
  extern _vp_hend
  extern _vp_vstart
  extern _vp_vend
  extern _SMS_VDP
  extern _linebuf
  extern _MD_Screen
  extern _MD_Palette
  extern @update_cache@0
  extern @render_bg_sms@4
  extern @render_bg_gg@4
  extern @render_obj@4

section .text align=64

; --------------------------------------------------------------------------------------
; void __fastcall SMS_Render_Line(int line)
; rendereiza uma linha para o master
DECLF SMS_Render_Line, 4
  cmp  ecx, [_vp_vstart]
  js   near .end
  cmp  ecx, [_vp_vend]
  jns  near .end

  push edi
  push ecx
  
  call @update_cache@0

  test byte [_SMS_VDP + 1], 0x40
  jz   .blank
  test byte [_SMS_VDP + 2], 0x01
  jz   .blank

  mov   ecx, [esp]
  call  @render_bg_sms@4
  mov   ecx, [esp]
  call  @render_obj@4
  test  byte [_SMS_VDP], 0x20
  jz    .copy
  mov   al, [_SMS_VDP + 7]
  and   al, 0x0F
  or    al, 0x10
  mov   ah, al
  mov   dx, ax
  shl   eax, 16
  mov   ax, dx
  mov   [_linebuf], eax
  mov   [_linebuf + 4], eax
  jmp   .copy

  ALIGN4
  .blank:
  mov   al, [_SMS_VDP + 7]
  and   al, 0x0F
  or    al, 0x10
  mov   ah, al
  mov   dx, ax
  shl   eax, 16
  mov   ax, dx
  mov   edi, [_vp_hstart]
  shr   edi, 3
  add   edi, _linebuf
  mov   ecx, 256 / 8
  ALIGN4
  .loop_blank:
    mov  [edi], eax
    mov  [edi + 4], eax
    add  edi, 8
    dec  ecx
    jnz  .loop_blank

  ALIGN4
  .copy:
  pop  ecx
  push esi
  push ebx

  imul ecx, 336
  add  ecx, 8
  shl  ecx, 1
  lea  edi, [_MD_Screen + ecx]
  mov  esi, _linebuf
  mov  ecx, 256 / 4
  xor  ebx, ebx
  ALIGN4
  .loop_copy: ; convertendo cores de 8 para 16 bits (de acordo com a palheta)
    mov  eax, [esi]
    and  eax, 0x1F1F1F1F
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi], dx
    shr  eax, 8
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi + 2], dx
    shr  eax, 8
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi + 4], dx
    shr  eax, 8
    mov  dx, [eax * 2 + _MD_Palette]
    mov  [edi + 6], dx
    add  edi, 8
    add  esi, 4
    dec  ecx
    jnz  .loop_copy

  pop  ebx
  pop  esi
  pop  edi

  .end:
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall GG_Render_Line(int line)
; rendereiza uma linha para o gg
DECLF GG_Render_Line, 4
  cmp  ecx, [_vp_vstart]
  js   near .end
  cmp  ecx, [_vp_vend]
  jns  near .end

  push ecx
  
  call @update_cache@0

  mov   ecx, [esp]
  call  @render_bg_gg@4
  mov   ecx, [esp]
  call  @render_obj@4
  test  byte [_SMS_VDP], 0x20
  jz    .copy
  mov   al, [_SMS_VDP + 7]
  and   al, 0x0F
  or    al, 0x10
  mov   ah, al
  mov   dx, ax
  shl   eax, 16
  mov   ax, dx
  mov   [_linebuf], eax
  mov   [_linebuf + 4], eax

  .copy:
  pop  ecx
  push edi
  push ebx
  push esi

  imul ecx, 336
  add  ecx, 8 + 48
  shl  ecx, 1
  lea  edi, [_MD_Screen + ecx]
  lea  esi, [_linebuf + 48]
  mov  ecx, 160 / 4
  xor  ebx, ebx
  ALIGN4
  .loop_copy: ; convertendo cores de 8 para 16 bits (de acordo com a palheta)
    mov  eax, [esi]
    and  eax, 0x1F1F1F1F
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi], dx
    shr  eax, 8
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi + 2], dx
    shr  eax, 8
    mov  bl, al
    mov  dx, [ebx * 2 + _MD_Palette]
    mov  [edi + 4], dx
    shr  eax, 8
    mov  dx, [eax * 2 + _MD_Palette]
    mov  [edi + 6], dx
    add  edi, 8
    add  esi, 4
    dec  ecx
    jnz  .loop_copy

  pop  esi
  pop  ebx
  pop  edi

  .end:
  ret
; --------------------------------------------------------------------------------------
