
#ifndef _VDP_H_
#define _VDP_H_

/* Display timing (NTSC) */
#define MASTER_CLOCK        (3579545)
#define LINES_PER_FRAME     (262)
#define FRAMES_PER_SECOND   (60)
#define CYCLES_PER_LINE     ((MASTER_CLOCK / FRAMES_PER_SECOND) / LINES_PER_FRAME)

#ifdef __cplusplus
extern "C" {
#endif

/* VDP context */
typedef struct _SVDP
{
  BYTE  reg[0x10];  
  BYTE  status;
  BYTE  latch;
  BYTE  pending;
  BYTE  buffer;
  BYTE  code;
  WORD  addr;
  int   ntab;
  int   satb;
  int   line;
  int   left;
  BYTE  limit;
} SVDP;

/* Global data */
extern SVDP SMS_VDP;

/* Function prototypes */
void __fastcall SMS_VDP_Reset(void);
void __fastcall vdp_ctrl_w(int data);
int  __fastcall vdp_ctrl_r(void);
void __fastcall vdp_data_w(int data);
int  __fastcall vdp_data_r(void);
void __fastcall SMS_VDP_Run(void);

extern const BYTE vcnt[];
#define vdp_vcounter_r() vcnt[(SMS_VDP.line & 0x1FF)]

BYTE __fastcall vdp_hcounter_r(void);

#ifdef __cplusplus
}
#endif

#endif /* _VDP_H_ */

