
#ifndef SN76496_H
#define SN76496_H

#include <windows.h>

#define MAX_76496 4

typedef struct _t_SN76496
{
  int  Channel;
  int  SampleRate;
  UINT UpdateStep;
  int  VolTable[16];
  int  Register[8];
  int  LastRegister;
  int  Volume[4];
  UINT RNG;
  int  NoiseFB;
  int  Period[4];
  int  Count[4];
  int  Output[4];
} t_SN76496;

#ifdef __cplusplus
extern "C" {
#endif

extern t_SN76496 sn;

void SN76496Write(int data);
void SN76496Update(short *buffer[2],int length,BYTE mask);
void SN76496_set_clock(int clock);
void SN76496_set_gain(int gain);
int  SN76496_init(int clock,int volume,int sample_rate);


#ifdef __cplusplus
}
#endif

#endif
