
#include "sms.h"

SMS_SOUND  snd;
OPLL      *opll;

void __stdcall SMS_Audio_Init(void)
{
  /* Clear sound context */
  memset(&snd, 0, sizeof(SMS_SOUND));

  /* Calculate buffer size in samples */
  snd.bufsize = Seg_Lenght;

  /* Sound output */
  snd.buffer[0] = Seg_L;
  snd.buffer[1] = Seg_R;

  /* SN76489 sound stream */
  snd.psg_buffer[0] = (short *)malloc(snd.bufsize * 2);
  snd.psg_buffer[1] = (short *)malloc(snd.bufsize * 2);
  if(!snd.psg_buffer[0] || !snd.psg_buffer[1]) return;

  /* Set up SN76489 emulation */
  SN76496_init(MASTER_CLOCK, 255, Sound_Rate);

  /* Set up YM2413 emulation */
  opll = OPLL_new(3579545, Sound_Rate);
  OPLL_reset(opll);
  OPLL_reset_patch(opll, 0);
  OPLL_setMask(opll, OPLL_MASK_RYTHM);
  OPLL_set_quality(opll, SMS_YM2413_Quality);
  sms.ym_cur_reg = 0;

  /* Inform other functions that we can use sound */
  snd.init_flag = 1;
}


void __stdcall SMS_Audio_End(void)
{
  if(snd.init_flag)
  {
    OPLL_delete(opll);
  }
}


void system_reset(void)
{
  SMS_VDP_Reset();
  SMS_Reset();
  render_reset();
  SMS_Load_SRAM();
  if(snd.init_flag) OPLL_reset(opll);
}







