
#ifndef _SYSTEM_H_
#define _SYSTEM_H_

#define SMS_PALETTE_SIZE        (0x20)

#define IS_GG               Is_GG
#define IS_SMS              (!Is_GG)

/* Macro to get offset to actual display within bitmap */
#define SMS_X_OFFSET        (Is_GG ? 48 : 0)
#define SMS_Y_OFFSET        (Is_GG ? 24 : 0)

#define SMS_WIDTH           (Is_GG ? 160 : 256)
#define SMS_HEIGHT          (Is_GG ? 144 : 192)

/* Mask for removing unused pixel data */
#define PIXEL_MASK          (0x1F)

#ifdef __cplusplus
extern "C" {
#endif

/* Sound emulation structure */
typedef struct
{
  int    init_flag;
  int    bufsize;
  int   *buffer[2];
  short *psg_buffer[2];    /* internal use only */
} SMS_SOUND;

/* Global variables */
extern SMS_SOUND snd;           /* Sound streams */
extern OPLL *opll;

/* Function prototypes */
void system_reset(void);
void system_save_state(void *fd);
void system_load_state(void *fd);
void __stdcall SMS_Audio_Init(void);
void __stdcall SMS_Audio_End(void);

#ifdef __cplusplus
}
#endif

#endif /* _SYSTEM_H_ */
