
#ifndef _SOUND_H
#define _SOUND_H

#include <windows.h>
#define DIRECTSOUND_VERSION         0x0300
#include <dsound.h>

#ifdef __cplusplus
extern "C" {
#endif

extern int Sound_Rate;
extern int Sound_Segs;
extern int Sound_Enable;
extern int Sound_Stereo;
extern int Sound_Volume;
extern int Use_LowPass_Filter;
extern int Sound_Echo;
extern int Sound_Is_Playing;
extern int Sound_Initialised;
extern int WAV_Dumping;
extern int GYM_Playing;
extern int Seg_L[882], Seg_R[882];
extern int Seg_Lenght;
extern int WP, RP;

extern unsigned int Sound_Extrapol[312][2];

extern LPVOID Echo_Buffer;

int  Init_Sound(HWND hWnd);
void End_Sound(void);
int  Write_Sound_Buffer(LPVOID Dump_Buf);
int  Clear_Sound_Buffer(void);
int  Play_Sound(void);
int  Stop_Sound(void);
int  Start_WAV_Dump(void);
int  Update_WAV_Dump(void);
int  Stop_WAV_Dump(void);
int  Start_GYM_Dump(void);
int  Stop_GYM_Dump(void);
int  Start_Play_GYM(void);
int  Play_GYM(void);
int  Stop_Play_GYM(void);

extern LPDIRECTSOUNDBUFFER lpDSBuffer;
extern DWORD               s_tmp_R;
extern int                 Bytes_Per_Unit;

#define Get_Current_Seg()                              \
(  lpDSBuffer->GetCurrentPosition(&s_tmp_R, NULL),     \
  (int)(s_tmp_R / (Seg_Lenght * Bytes_Per_Unit)) )

#define Check_Sound_Timing()                           \
( lpDSBuffer->GetCurrentPosition(&s_tmp_R, NULL),      \
  RP = s_tmp_R / (Seg_Lenght * Bytes_Per_Unit),        \
  (RP == ((WP + 1) & (Sound_Segs - 1))) ? 2 : ( (RP != WP) ? 1 : 0 ) )



void __cdecl Write_Sound_Mono_MMX(int *Left, int *Right, short *Dest, int lenght);
void __cdecl Write_Sound_Stereo_MMX(int *Left, int *Right, short *Dest, int lenght);
void __cdecl Set_Sound_Volume(short *buf, int len, int percent);
// sound buffer lenght must be > 11025
void __fastcall Set_Sound_Echo(short *buf, int len);
void __fastcall Set_Sound_Echo_MMX(short *buf, int len);

void __fastcall LowPass_Filter_Stereo(LPVOID buf, int len);
void __fastcall LowPass_Filter_Mono(LPVOID buf, int len);

#ifdef __cplusplus
}
#endif

#endif // _SOUND_H
