; LowPass.asm - este arquivo  parte do projeto gens+
; Rodrigo Cardoso
; Filtro de som low-pass

%macro DECL 1-2
  %if %0 > 1
    global @%1@%2
  %else
    global _%1
  %endif
    global %1
  %if %0 > 1
    @%1@%2:
  %else
    _%1:
  %endif
    %1:
%endmacro

section .data align=64  
  
  a1a equ 0x00003137 ; 12599
  a2a equ 0xFFFFF7AA ; -2134
  b0a equ 0x00002A38 ; 10808
  b1a equ 0x00005470 ; 21616
  b2a equ 0x00002A38 ; 10808
  a1b equ 0xFFFF472A ; -47318
  a2b equ 0x00003D24 ; 15652
  b0b equ 0x00000196 ; 406
  b1b equ 0x0000032C ; 812
  b2b equ 0x00000196 ; 406

%macro VAR_TABLE 1
  i1_%1:  dw 0
  i2_%1:  dw 0
  o1a_%1: dw 0
  o2a_%1: dw 0
  o1b_%1: dw 0
  o2b_%1: dw 0
%endmacro

  VAR_TABLE left
  VAR_TABLE right


section .text align=64

; macros
%macro MOVE 2
  mov   bx, [%2]
  mov   [%1], bx
%endmacro

%macro MULADD 2
  movsx ebx, word [%2]
  imul  ebx, %1
  add   eax, ebx
%endmacro

%macro MULSUB 2
  movsx ebx, word [%2]
  imul  ebx, %1
  sub   eax, ebx
%endmacro

%macro OVRFLW 0
  jno   %%value_ok
  js    %%min
  mov   eax, 0x7FFFFFFF
  jmp   %%value_ok
  %%min:
  mov   eax, 0x80000000
  %%value_ok:
%endmacro

%macro CALC 1
  movsx   eax, word [edx]
  imul    eax, b0a
  MULADD  b1a, i1_%1
  MULADD  b2a, i2_%1
  MULSUB  a1a, o1a_%1
  MULSUB  a2a, o2a_%1
  imul    eax, 2
  OVRFLW
  shr     eax, 16
  MOVE    o2a_%1, o1a_%1
  mov     [o1a_%1], ax

  movsx   eax, word [edx]
  imul    eax, b0b
  MULADD  b1b, i1_%1
  MULADD  b2b, i2_%1
  MULSUB  a1b, o1b_%1
  MULSUB  a2b, o2b_%1
  imul    eax, 2
  OVRFLW
  shr     eax, 16
  MOVE    o2b_%1, o1b_%1
  mov     [o1b_%1], ax

  MOVE  i2_%1, i1_%1
  mov   bx, [edx]
  mov   [i1_%1], bx
  
  add   ax, [o1a_%1]
  jno   %%value_ok
  jns   %%min
  mov   ax, 0x7FFF
  jmp   %%value_ok
  %%min:
  mov   ax, 0x8000
  %%value_ok:
  mov   [edx], ax
%endmacro


; --------------------------------------------------------------------------------------
; void __fastcall LowPass_Filter_Stereo(LPVOID buf, int len)
; filtro low-pass stereo
DECL LowPass_Filter_Stereo, 8
  push  ebx

  xchg  ecx, edx
  test  ecx, ecx
  jz    near .end
  
  .loop
    CALC  left
    inc   edx
    inc   edx
    CALC  right
    inc   edx
    inc   edx
    dec   ecx
    jnz   .loop
    
  .end:
  pop   ebx
  ret
; --------------------------------------------------------------------------------------


; --------------------------------------------------------------------------------------
; void __fastcall LowPass_Filter_Stereo(LPVOID buf, int len)
; filtro low-pass mono
DECL LowPass_Filter_Mono, 8
  push  ebx

  xchg  ecx, edx
  test  ecx, ecx
  jz    near .end
    
  .loop
    CALC  left
    inc   edx
    inc   edx
    dec   ecx
    jnz   .loop
    
  .end:
  pop   ebx
  ret
; --------------------------------------------------------------------------------------
