/* sgm.cpp - projeto gens+. Rodrigo Cardoso.
   Loga arquivos SGM. O formato VGM fica muito grande para genesis, estou tentando criar
   um formato que fique menor. */

#ifndef _SGM_H
#define _SGM_H

#include "gmain.h"
#include "grom.h"
#include "ym2612.h"
#include "psg.h"

#ifdef __cplusplus
extern "C" {
#endif

#define SGM_TYPE    0x004D4753
#define SGM_VERSION 0x00000001

// cabealho do arquivo, deve vir logo no incio
typedef struct tagSGMHEADER {
  DWORD            dwType;                  // deve ser SGM_TYPE
  DWORD            dwVersion;               // deve ser SGM_VERSION
  DWORD            dwExtraHdr;              // tamanho de algum dado extra depois desta estrutura
  DWORD            dwFileSize;              // tamanho do arquivo (descompactado)
  DWORD            dwTotalLength;           // nmero total de samples
  DWORD            dwOffsetLoop;            // distncia at o loop (0 se no houver loop)
  DWORD            dwLoopLength;            // tamanho do loop (0 se no houver loop)
  DWORD            dwSamplesLoop;           // nmero de samples no loop (0 se no houver loop)
  DWORD            dwMode;                  // 0 NTSC 1 PALM
  GENESIS_ROM_INFO griRomInfo;              // dados sobre a rom de onde o som foi extrado
} SGMHEADER, *PSGMHEADER, *LPSGMHEADER;

// aps o cabealho, segue esta estrutura que possui o estado inicial dos chips
typedef struct tagCHIPSINFO {
  BYTE             YM2612_Reg[0x200];       // YM2612
  int              PSG_Reg[8];              // PSG
} CHIPSINFO, *PCHIPSINFO, *LPCHIPSINFO;


void __stdcall Start_SGM_Dump(void);
void __stdcall Stop_SGM_Dump(void);
void __stdcall Update_SGM_Dump(int, int, int);
int  __stdcall Compress_SGM_File(void);

extern FILE *SGM_File;

#ifdef __cplusplus
}
#endif

#endif // _SGM_H
