// vgm.cpp - loga arquivos VGM para o SMS - Rodrigo Cardoso

#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include "gmain.h"
#include "grom.h"
#include "config.h"
#include "sms.h"
#include "vgm.h"

FILE     *VGM_File = NULL;
VGMHEADER vgmhdr;

#define vgmputc(c) putc(c, VGM_File);

// cria o arquivo e inicia o cabealho
void __stdcall Start_VGM_Dump(void)
{
  char      name[GMAX_PATH];
  LPSTR     sufix;
  int       i, j, d;
  int       file;

  if(!(*Rom_Name)) return;

  i = sprintf(name, "%s%s", Dump_Dir, Rom_Name);
  sufix = name + i;
  d   = -1;
  do
  {
    if (d++ > 99999) return;
    sufix[0] = '_';
    i = 1;
    j = d / 10000;
    if (j) sufix[i++] = '0' + j;
    j = (d / 1000) % 10;
    if (j) sufix[i++] = '0' + j;
    j = (d / 100) % 10;
    sufix[i++] = '0' + j;
    j = (d / 10) % 10;
    sufix[i++] = '0' + j;
    j = d % 10;
    sufix[i++] = '0' + j;
    sufix[i++] = '.';
    sufix[i++] = 'v';
    sufix[i++] = 'g';
    sufix[i++] = 'm';
    sufix[i]   = 0;
    file = open(name, _O_CREAT | _O_EXCL | _O_WRONLY | _O_BINARY | _O_SEQUENTIAL);
  } while(file == -1);
  
  VGM_File = fdopen(file, "wbS");
  if(!VGM_File) return;

  memset(&vgmhdr, 0, sizeof(VGMHEADER));
  vgmhdr.dwType     = VGM_TYPE;
  vgmhdr.dwVersion  = VGM_VERSION;
  vgmhdr.dwPSGClock = 3579545;
  vgmhdr.dwFMClock  = 3579545;
  fwrite(&vgmhdr, sizeof(VGMHEADER), 1, VGM_File);

  // valor inicial dos registradores
  if(opll)
  {
    for(i = 0; i < 0x40; i++)
    { vgmputc(0x51); vgmputc(0x40); vgmputc(opll->reg[i]); }
  }
}

// fim
void __stdcall Stop_VGM_Dump(void)
{
  if(!VGM_File) return;
  vgmputc(0x66);
  vgmhdr.dwOffsetEOF = ftell(VGM_File) - 4;
  fseek(VGM_File, 0, SEEK_SET);
  fwrite(&vgmhdr, sizeof(VGMHEADER), 1, VGM_File);
  fclose(VGM_File);
  VGM_File = NULL;
}

// adiciona novo comando
void __stdcall Update_VGM_Dump(int command, int reg, int value)
{
  switch(command)
  {
    case 0x4F:
      vgmputc(command); vgmputc(value);
      break;

    case 0x50:
      vgmputc(command); vgmputc(value);
      break;

    case 0x51:
      vgmputc(command); vgmputc(reg); vgmputc(value);
      break;

    case 0x62:
      vgmputc(command);
      vgmhdr.dwTotalLength += 735;
      break;
    case 0x63:
      vgmputc(command);
      vgmhdr.dwTotalLength += 882;
      break;

    case 0x61:
      if(value < 16)
      {
        vgmputc(0x70 | (value - 1));
      }
      else if(value < 256)
      {
        vgmputc(0x64); vgmputc(value & 0xFF);
      }
      else switch(value)
      {
        case (2 * 882):
          vgmputc(0x63); vgmputc(0x63);
          break;
        case 882:
          vgmputc(0x63);
          break;
        case (2 * 735):
          vgmputc(0x62); vgmputc(0x62);
          break;
        case 735:
          vgmputc(0x62);
          break;
        case (735 + 882):
          vgmputc(0x62); vgmputc(0x63);
          break;
        default:
          if(value) vgmputc(0x61); vgmputc(LOBYTE(value)); vgmputc(HIBYTE(value));
          break;
      }
      vgmhdr.dwTotalLength += value;
      break;

      default:
        break;
  }
}
