// vgm.cpp - loga arquivos VGM para o SMS - Rodrigo Cardoso

#ifndef _VGM_H
#define _VGM_H

#include <windows.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

#define VGM_TYPE    0x206D6756
#define VGM_VERSION 0x00000101

typedef struct tagVGMHEADER {
  DWORD    dwType;                  // deve ser VGM_TYPE
  DWORD    dwOffsetEOF;             // tamanho do arquivo - 4
  DWORD    dwVersion;               // deve ser VGM_VERSION
  DWORD    dwPSGClock;              // 3579545, 0 sem PSG
  DWORD    dwFMClock;               // 7670453, 0 sem FM
  DWORD    dwOffsetGD3;             // distncia at o GD3 (0 se no houver tag)
  DWORD    dwTotalLength;           // nmero total de samples
  DWORD    dwOffsetLoop;            // distncia at o loop (0 se no houver loop)
  DWORD    dwLoopLength;            // tamanho do loop (0 se no houver loop)
  DWORD    dwSamplesLoop;           // nmero de samples no loop (0 se no houver loop)
  DWORD    dwRate;                  // 50 Hz PALM, 60 Hz NTSC ou 0
  DWORD    pdwPadding[5];           // deve ser preenchido com zeros
} VGMHEADER, *PVGMHEADER, *LPVGMHEADER;


void __stdcall Start_VGM_Dump(void);
void __stdcall Stop_VGM_Dump(void);
void __stdcall Update_VGM_Dump(int, int, int);

extern FILE *VGM_File;

#ifdef __cplusplus
}
#endif

#endif // _VGM_H
