
%include "nasmhead.inc"

section .data align=64

  extern MD_Screen
  extern TAB336
  extern Have_MMX
  extern Mode_555

  Var:           dd 0
  NB_X:          dd 0
  NB_X2:         dd 0
  NB_X4:         dd 0
  MASK_DIV2:     dd 0x7BCF7BCF, 0x7BCF7BCF
  MASK_DIV2_15:  dd 0x3DEF3DEF, 0x3DEF3DEF
  MASK_DIV2_16:  dd 0x7BEF7BEF, 0x7BEF7BEF
  MASK_DIV4_15:  dd 0x1CE71CE7, 0x1CEF1CE7
  MASK_DIV4_16:  dd 0x39E739E7, 0x39E739E7
  MASK_DIV8_15:  dd 0x0C630C63, 0x0C630C63
  MASK_DIV8_16:  dd 0x18E318E3, 0x18E318E3
  MASK_RBG_15:   dd 0x7C1F03E0, 0x7C1F03E0
  MASK_GRB_15:   dd 0x03E07C1F, 0x03E07C1F
  MASK_RBG_16:   dd 0xF81F07E0, 0xF81F07E0
  MASK_GRB_16:   dd 0x07E0F81F, 0x07E0F81F
  MASK_RBG_15_2: dd 0x3C0F01E0, 0x3C0F01E0
  MASK_GRB_15_2: dd 0x01E03C0F, 0x01E03C0F
  MASK_RBG_16_2: dd 0x780F03E0, 0x780F03E0
  MASK_GRB_16_2: dd 0x03E0780F, 0x03E0780F
  MASK_GG_15:    dd 0x03E003E0, 0x03E003E0
  MASK_RBRB_15:  dd 0x7C1F7C1F, 0x7C1F7C1F
  MASK_GG_16:    dd 0x07C007C0, 0x07C007C0
  MASK_RBRB_16   dd 0xF81FF81F, 0xF81FF81F


section .bss align=64

  Line1Int:   resb 640 * 2
  Line2Int:   resb 640 * 2
  Line1IntP:  resd 1
  Line2IntP:  resb 1


section .text align=64

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X1(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X1

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  add ecx, ecx          ; ecx = Nb bytes par ligne
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 3            ; on transfert 8 bytes  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
      mov eax, [esi]      ; on transferts 2 pixels d'un coup
      mov edx, [esi + 4]    ; on transferts 2 pixels d'un coup
      add esi, 8
      mov [edi], eax
      mov [edi + 4], edx
      add edi, 8
      dec ecx
      jnz .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X1_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X1_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  add ecx, ecx          ; ecx = Nb bytes par ligne
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 6            ; on transfert 64 bytes  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
      movq mm0, [esi]
      add edi, 64
      movq mm1, [esi + 8]
      movq mm2, [esi + 16]
      movq mm3, [esi + 24]
      movq mm4, [esi + 32]
      movq mm5, [esi + 40]
      movq mm6, [esi + 48]
      movq mm7, [esi + 56]
      movq [edi + 0 - 64], mm0
      add esi, 64
      movq [edi + 8 - 64], mm1
      movq [edi + 16 - 64], mm2
      movq [edi + 24 - 64], mm3
      movq [edi + 32 - 64], mm4
      movq [edi + 40 - 64], mm5
      movq [edi + 48 - 64], mm6
      dec ecx
      movq [edi + 56 - 64], mm7
      jnz .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X2(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X2

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 16 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      mov eax, [esi]          ; on transferts 2 pixels d'un coup
      add esi, 8
      mov edx, eax
      rol eax, 16
      xchg ax, dx
      mov [edi], eax
      mov [edi + 4], edx
      add edi, 16
      mov eax, [esi - 4]        ; on transferts 2 pixels d'un coup
      mov edx, eax
      rol eax, 16
      xchg ax, dx
      dec ecx
      mov [edi - 8], eax
      mov [edi - 4], edx
      jnz short .Loop_X1

    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 3
    sub esi, ecx
    shr ecx, 3
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      mov eax, [esi]          ; on transferts 2 pixels d'un coup
      add esi, 8
      mov edx, eax
      rol eax, 16
      xchg ax, dx
      mov [edi], eax
      mov [edi + 4], edx
      add edi, 16
      mov eax, [esi - 4]        ; on transferts 2 pixels d'un coup
      mov edx, eax
      rol eax, 16
      xchg ax, dx
      dec ecx
      mov [edi - 8], eax
      mov [edi - 4], edx
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz near .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X2_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X2_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 6            ; on transfert 64 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add edi, byte 64
      movq mm2, [esi + 8]
      movq mm1, mm0
      movq mm4, [esi + 16]
      movq mm3, mm2
      movq mm6, [esi + 24]
      movq mm5, mm4
      movq mm7, mm6
      punpcklwd mm1, mm1
      punpckhwd mm0, mm0
      movq [edi + 0 - 64], mm1
      punpcklwd mm3, mm3
      movq [edi + 8 - 64], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 64], mm3
      punpcklwd mm5, mm5
      movq [edi + 24 - 64], mm2
      punpckhwd mm4, mm4
      movq [edi + 32 - 64], mm5
      punpcklwd mm7, mm7
      movq [edi + 40 - 64], mm4
      punpckhwd mm6, mm6
      movq [edi + 48 - 64], mm7
      add esi, byte 32
      dec ecx
      movq [edi + 56 - 64], mm6
      jnz short .Loop_X1

    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 5
    sub esi, ecx
    shr ecx, 5
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [esi]
      add edi, byte 64
      movq mm2, [esi + 8]
      movq mm1, mm0
      movq mm4, [esi + 16]
      movq mm3, mm2
      movq mm6, [esi + 24]
      movq mm5, mm4
      movq mm7, mm6
      punpcklwd mm1, mm1
      punpckhwd mm0, mm0
      movq [edi + 0 - 64], mm1
      punpcklwd mm3, mm3
      movq [edi + 8 - 64], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 64], mm3
      punpcklwd mm5, mm5
      movq [edi + 24 - 64], mm2
      punpckhwd mm4, mm4
      movq [edi + 32 - 64], mm5
      punpcklwd mm7, mm7
      movq [edi + 40 - 64], mm4
      punpckhwd mm6, mm6
      movq [edi + 48 - 64], mm7
      add esi, byte 32
      dec ecx
      movq [edi + 56 - 64], mm6
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz near .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X2_Int(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X2_Int

  push ebx
  push ecx
  push edx
  push edi
  push esi
  push ebp

  mov ecx, [esp + 36]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 32]        ; ebx = pitch de la surface Dest
  mov eax, Line1Int        ; eax = offset Line 1 Int buffer
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  mov [Line1IntP], eax      ; store first buffer addr
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  mov eax, Line2Int        ; eax = offset Line 2 Int buffer
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 2            ; on transfert 4 bytes Dest  chaque boucle
  mov [Line2IntP], eax      ; store second buffer addr
  mov edi, [esp + 28]        ; edi = Dest
  mov [esp + 32], ebx        ; on stocke complment offset pour ligne suivante
  mov [esp + 36], ecx        ; on stocke cette nouvelle valeur pour X
  mov ebp, [Line1IntP]      ; ebp = First Line buffer
  mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation
  jmp short .First_Copy

ALIGN4

.First_Copy
.Loop_X_FL
    mov ax, [esi]
    mov dx, [esi + 2]
    shr ax, 1
    add esi, byte 2
    shr dx, 1
    and ax, 0x7BCF
    and dx, 0x7BCF
    add ebp, byte 4
    add ax, dx
    dec ecx
    mov dx, [esi]
    mov [ebp + 0 - 4], ax
    mov [ebp + 2 - 4], dx
    jnz short .Loop_X_FL

  dec dword [esp + 40]      ; une ligne en moins
  jz near .Last_Line

  mov ecx, [esp + 36]        ; on transfert 4 octects Dest par itration...
  add esi, [esp + 44]        ; on augmente la source pour pointer sur la prochaine ligne
  mov ebp, [Line2IntP]      ; ebp = Second Line buffer
  mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      mov ax, [esi]
      mov dx, [esi + 2]
      shr ax, 1
      add esi, byte 2
      shr dx, 1
      and ax, 0x7BCF
      and dx, 0x7BCF
      add ebp, byte 4
      add ax, dx
      dec ecx
      mov dx, [esi]
      mov [ebp + 0 - 4], ax
      mov [ebp + 2 - 4], dx
      jnz short .Loop_X1

    mov ecx, [esp + 36]        ; Dest num bytes / 4
    add esi, [esp + 44]        ; on augmente la source pour pointer sur la prochaine ligne
    shr ecx, 1            ; Dest num bytes / 8
    mov ebx, [Line1IntP]      ; ebx = First Line buffer
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      mov eax, [ebx]
      mov edx, [ebx + 4]
      add edi, byte 8
      add ebx, byte 8
      dec ecx
      mov [edi + 0 - 8], eax
      mov [edi + 4 - 8], edx
      jnz short .Loop_X2

    mov ecx, [esp + 36]        ; Dest num bytes / 4
    add edi, [esp + 32]        ; Next Dest line
    mov ebx, [Line1IntP]      ; ebx = First Line buffer
    mov ebp, [Line2IntP]      ; ebp = Second Line buffer
    jmp short .Loop_X3

ALIGN64

.Loop_X3
      mov eax, [ebx]
      mov edx, [ebp]
      shr eax, 1
      add edi, byte 4
      shr edx, 1
      and eax, 0x7BCF7BCF
      and edx, 0x7BCF7BCF
      add ebx, byte 4
      add eax, edx
      add ebp, byte 4
      dec ecx
      mov [edi - 4], eax
      jnz short .Loop_X3

    add edi, [esp + 32]        ; Next Dest line
    mov ebx, [Line1IntP]      ; Swap line buffer
    mov ebp, [Line2IntP]
    mov [Line2IntP], ebx
    mov [Line1IntP], ebp
    mov ecx, [esp + 36]        ; on transfert 4 octects Dest par itration...
    dec dword [esp + 40]      ; encore des lignes ?
    mov ebp, [Line2IntP]      ; ebp = Second Line buffer
    mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation
    jnz near .Loop_Y

.Last_Line
  mov ecx, [esp + 36]        ; Dest num bytes / 4
  mov ebx, [Line1IntP]      ; ebx = First Line buffer
  shr ecx, 1            ; Dest num bytes / 8
  jmp short .Loop_X1_LL

ALIGN4

.Loop_X1_LL
    mov eax, [ebx]
    mov edx, [ebx + 4]
    add edi, byte 8
    add ebx, byte 8
    dec ecx
    mov [edi + 0 - 8], eax
    mov [edi + 4 - 8], edx
    jnz short .Loop_X1_LL

  add edi, [esp + 32]        ; Next Dest line
  mov ecx, [esp + 36]        ; Dest num bytes / 4
  mov ebx, [Line1IntP]      ; ebx = First Line buffer
  shr ecx, 1            ; Dest num bytes / 8
  jmp short .Loop_X2_LL

ALIGN4

.Loop_X2_LL
    mov eax, [ebx]
    add edi, byte 8
    mov edx, [ebx + 4]
    shr eax, 1
    add ebx, byte 8
    shr edx, 1
    and eax, 0x7BCF7BCF
    and edx, 0x7BCF7BCF
    mov [edi + 0 - 8], eax
    dec ecx
    mov [edi + 4 - 8], edx
    jnz short .Loop_X2_LL

  pop ebp
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X2_Int_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_X2_Int_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi
  push ebp

  mov ecx, [esp + 36]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 32]        ; ebx = pitch de la surface Dest
  mov eax, Line1Int        ; eax = offset Line 1 Int buffer
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  mov [Line1IntP], eax      ; store first buffer addr
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  mov eax, Line2Int        ; eax = offset Line 2 Int buffer
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 16 bytes Dest  chaque boucle
  mov [Line2IntP], eax      ; store second buffer addr
  mov edi, [esp + 28]        ; edi = Dest
  mov [esp + 32], ebx        ; on stocke complment offset pour ligne suivante
  mov [esp + 36], ecx        ; on stocke cette nouvelle valeur pour X
  mov ebp, [Line1IntP]      ; ebp = First Line buffer
  mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation

  test byte [Mode_555], 1      ; set good mask for current video mode
  movq mm7, [MASK_DIV2_15]
  jnz short .First_Copy

  movq mm7, [MASK_DIV2_16]
  jmp short .First_Copy

ALIGN4

.First_Copy
.Loop_X_FL
    movq mm0, [esi]
    add ebp, byte 16
    movq mm2, mm0
    movq mm1, [esi + 2]
    psrlw mm0, 1
    psrlw mm1, 1
    pand mm0, mm7
    pand mm1, mm7
    movq mm3, mm2
    paddw mm0, mm1
    add esi, byte 8
    punpcklwd mm2, mm0
    punpckhwd mm3, mm0
    movq [ebp + 0 - 16], mm2
    dec ecx
    movq [ebp + 8 - 16], mm3
    jnz short .Loop_X_FL

  dec dword [esp + 40]      ; une ligne en moins
  jz near .Last_Line

  mov ecx, [esp + 36]        ; on transfert 16 octets Dest par itration...
  add esi, [esp + 44]        ; on augmente la source pour pointer sur la prochaine ligne
  mov ebp, [Line2IntP]      ; ebp = Second Line buffer
  mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add ebp, byte 16
      movq mm2, mm0
      movq mm1, [esi + 2]
      psrlw mm0, 1
      psrlw mm1, 1
      pand mm0, mm7
      pand mm1, mm7
      movq mm3, mm2
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm2, mm0
      punpckhwd mm3, mm0
      movq [ebp + 0 - 16], mm2
      dec ecx
      movq [ebp + 8 - 16], mm3
      jnz short .Loop_X1

    mov ecx, [esp + 36]        ; Dest num bytes / 16
    add esi, [esp + 44]        ; on augmente la source pour pointer sur la prochaine ligne
    mov ebx, [Line1IntP]      ; ebx = First Line buffer
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [ebx]
      add edi, byte 16
      movq mm1, [ebx + 8]
      add ebx, byte 16
      movq [edi + 0 - 16], mm0
      dec ecx
      movq [edi + 8 - 16], mm1
      jnz short .Loop_X2

    mov ecx, [esp + 36]        ; Dest num bytes / 16
    add edi, [esp + 32]        ; Next Dest line
    mov ebx, [Line1IntP]      ; ebx = First Line buffer
    mov ebp, [Line2IntP]      ; ebp = Second Line buffer
    jmp short .Loop_X3

ALIGN64

.Loop_X3
      movq mm0, [ebx]
      add edi, byte 16
      movq mm1, [ebx + 8]
      psrlw mm0, 1
      movq mm2, [ebp]
      psrlw mm1, 1
      movq mm3, [ebp + 8]
      psrlw mm2, 1
      psrlw mm3, 1
      pand mm0, mm7
      pand mm1, mm7
      pand mm2, mm7
      pand mm3, mm7
      paddw mm0, mm2
      paddw mm1, mm3
      add ebx, byte 16
      movq [edi + 0 - 16], mm0
      add ebp, byte 16
      dec ecx
      movq [edi + 8 - 16], mm1
      jnz short .Loop_X3

    add edi, [esp + 32]        ; Next Dest line
    mov ebx, [Line1IntP]      ; Swap line buffer
    mov ebp, [Line2IntP]
    mov [Line2IntP], ebx
    mov [Line1IntP], ebp
    mov ecx, [esp + 36]        ; on transfert 4 octects Dest par itration...
    dec dword [esp + 40]      ; encore des lignes ?
    mov ebp, [Line2IntP]      ; ebp = Second Line buffer
    mov word [esi + 320 * 2], 0    ; clear last pixel for correct interpolation
    jnz near .Loop_Y

.Last_Line
  mov ecx, [esp + 36]        ; Dest num bytes / 16
  mov ebx, [Line1IntP]      ; ebx = First Line buffer
  jmp short .Loop_X1_LL

ALIGN4

.Loop_X1_LL
    movq mm0, [ebx]
    add edi, byte 16
    movq mm1, [ebx + 8]
    add ebx, byte 16
    movq [edi + 0 - 16], mm0
    dec ecx
    movq [edi + 8 - 16], mm1
    jnz short .Loop_X1_LL

  add edi, [esp + 32]        ; Next Dest line
  mov ecx, [esp + 36]        ; Dest num bytes / 16
  mov ebx, [Line1IntP]      ; ebx = First Line buffer
  jmp short .Loop_X2_LL

ALIGN4

.Loop_X2_LL
    movq mm0, [ebx]
    add edi, byte 16
    movq mm1, [ebx + 8]
    psrlw mm0, 1
    add ebx, byte 16
    psrlw mm1, 1
    pand mm0, mm7
    pand mm1, mm7
    movq [edi + 0 - 16], mm0
    dec ecx
    movq [edi + 8 - 16], mm1
    jnz short .Loop_X2_LL

  pop ebp
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  add ebx, ebx          ; ebx = pitch * 2
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 16 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
      mov eax, [esi]          ; on transferts 2 pixels d'un coup
      add esi, byte 4
      mov edx, eax
      rol eax, 16
      xchg ax, dx
      mov [edi], eax
      mov [edi + 4], edx
      add edi, byte 8
      mov eax, [esi]          ; on transferts 2 pixels d'un coup
      add esi, byte 4
      mov edx, eax
      rol eax, 16
      add edi, byte 8
      xchg ax, dx
      dec ecx
      mov [edi - 8], eax
      mov [edi - 4], edx
      jnz short .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz short .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  add ebx, ebx          ; ebx = pitch * 2
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 5            ; on transfert 32 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jnp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
      movq mm0, [esi]
      add edi, byte 32
      movq mm2, [esi + 8]
      movq mm1, mm0
      movq mm3, mm2
      punpcklwd mm1, mm0
      add esi, byte 16
      punpckhwd mm0, mm0
      movq [edi + 0 - 32], mm1
      punpcklwd mm3, mm2
      movq [edi + 8 - 32], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 32], mm3
      dec ecx
      movq [edi + 24 - 32], mm2
      jnz short .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]
    jnz short .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_50_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_50_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 5            ; on transfert 32 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  test byte [Mode_555], 1
  movq mm7, [MASK_DIV2_15]
  jnz short .Loop_Y

  movq mm7, [MASK_DIV2_16]
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add edi, byte 32
      movq mm2, [esi + 8]
      movq mm1, mm0
      movq mm3, mm2
      punpcklwd mm1, mm0
      add esi, byte 16
      punpckhwd mm0, mm0
      movq [edi + 0 - 32], mm1
      punpcklwd mm3, mm2
      movq [edi + 8 - 32], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 32], mm3
      dec ecx
      movq [edi + 24 - 32], mm2
      jnz short .Loop_X1

    mov ecx, [esp + 32]
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 4
    sub esi, ecx
    shr ecx, 4
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [esi]
      add edi, byte 32
      movq mm2, [esi + 8]
      psrlq mm0, 1
      psrlq mm2, 1
      pand mm0, mm7
      pand mm2, mm7
      movq mm1, mm0
      movq mm3, mm2
      punpcklwd mm1, mm1
      add esi, byte 16
      punpckhwd mm0, mm0
      movq [edi + 0 - 32], mm1
      punpcklwd mm3, mm3
      movq [edi + 8 - 32], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 32], mm3
      dec ecx
      movq [edi + 24 - 32], mm2
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]
    jnz near .Loop_Y

.End
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_25_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_25_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 5            ; on transfert 32 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  test byte [Mode_555], 1
  movq mm6, [MASK_DIV2_15]
  movq mm7, [MASK_DIV4_15]
  jnz short .Loop_Y

  movq mm6, [MASK_DIV2_16]
  movq mm7, [MASK_DIV4_16]
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add edi, byte 32
      movq mm2, [esi + 8]
      movq mm1, mm0
      movq mm3, mm2
      punpcklwd mm1, mm0
      add esi, byte 16
      punpckhwd mm0, mm0
      movq [edi + 0 - 32], mm1
      punpcklwd mm3, mm2
      movq [edi + 8 - 32], mm0
      punpckhwd mm2, mm2
      movq [edi + 16 - 32], mm3
      dec ecx
      movq [edi + 24 - 32], mm2
      jnz short .Loop_X1

    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 32 dans une ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 4
    sub esi, ecx
    shr ecx, 4
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [esi]
      add edi, byte 32
      movq mm3, [esi + 8]
      movq mm2, mm0
      movq mm5, mm3
      psrlq mm0, 2
      psrlq mm2, 1
      psrlq mm3, 2
      psrlq mm5, 1
      pand mm0, mm7
      pand mm2, mm6
      pand mm3, mm7
      pand mm5, mm6
      paddw mm0, mm2
      paddw mm3, mm5
      movq mm1, mm0
      movq mm4, mm3
      punpcklwd mm1, mm1
      add esi, byte 16
      punpckhwd mm0, mm0
      movq [edi + 0 - 32], mm1
      punpcklwd mm4, mm4
      movq [edi + 8 - 32], mm0
      punpckhwd mm3, mm3
      movq [edi + 16 - 32], mm4
      dec ecx
      movq [edi + 24 - 32], mm3
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz near .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_Int(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_Int

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  add ebx, ebx          ; ebx = pitch * 2
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 2            ; on transfert 4 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
;        mov eax, [esi]
;        add esi, byte 2
;        shr eax, 1
;        mov edx, eax
;        and eax, 0x03E0780F
;        and edx, 0x780F03E0
;        rol eax, 16
;        add edi, byte 4
;        add eax, edx
;        mov dx, ax
;        shr eax, 16
;        or dx, ax
;        dec ecx
;        mov ax, [esi]
;        mov [edi + 0 - 4], dx
;        mov [edi + 2 - 4], ax
;        jnz short .Loop_X

      mov ax, [esi]
      mov dx, [esi + 2]
      shr ax, 1
      add esi, byte 2
      shr dx, 1
      and ax, 0x7BCF
      and dx, 0x7BCF
      add edi, byte 4
      add ax, dx
      dec ecx
      mov dx, [esi]
      mov [edi + 0 - 4], ax
      mov [edi + 2 - 4], dx
      jnz short .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz short .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_Int_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_Int_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  add ebx, ebx          ; ebx = pitch * 2
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 16 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X

  test byte [Mode_555], 1      ; set good mask for current video mode
  movq mm7, [MASK_DIV2_15]
  jnz short .Loop_Y

  movq mm7, [MASK_DIV2_16]
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X
      movq mm0, [esi]
      add edi, byte 16
      movq mm2, mm0
      movq mm1, [esi + 2]
      psrlw mm0, 1
      psrlw mm1, 1
      pand mm0, mm7
      pand mm1, mm7
      movq mm3, mm2
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm2, mm0
      punpckhwd mm3, mm0
      movq [edi + 0 - 16], mm2
      dec ecx
      movq [edi + 8 - 16], mm3
      jnz short .Loop_X

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz short .Loop_Y

  emms
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_50_Int_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_50_Int_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 32 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  test byte [Mode_555], 1
  movq mm6, [MASK_DIV2_15]
  movq mm7, [MASK_DIV4_15]
  jnz short .Loop_Y

  movq mm6, [MASK_DIV2_16]
  movq mm7, [MASK_DIV4_16]
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add edi, byte 16
      movq mm2, mm0
      movq mm1, [esi + 2]
      psrlw mm0, 1
      psrlw mm1, 1
      pand mm0, mm6
      pand mm1, mm6
      movq mm3, mm2
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm2, mm0
      punpckhwd mm3, mm0
      movq [edi + 0 - 16], mm2
      dec ecx
      movq [edi + 8 - 16], mm3
      jnz short .Loop_X1

    mov ecx, [esp + 32]
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 3
    sub esi, ecx
    shr ecx, 3
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [esi]
      add edi, byte 16
      movq mm2, mm0
      movq mm1, [esi + 2]
      psrlw mm0, 2
      psrlw mm2, 1
      psrlw mm1, 2
      pand mm0, mm7
      pand mm2, mm6
      pand mm1, mm7
      movq mm3, mm2
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm2, mm0
      punpckhwd mm3, mm0
      movq [edi + 0 - 16], mm2
      dec ecx
      movq [edi + 8 - 16], mm3
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]
    jnz near .Loop_Y

.End
  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_Scanline_25_Int_MMX(unsigned char *Dest, int pitch, int x, int y, int offset)
DECL Blit_Scanline_25_Int_MMX

  push ebx
  push ecx
  push edx
  push edi
  push esi

  mov ecx, [esp + 32]        ; ecx = Nombre de pix par ligne
  mov ebx, [esp + 28]        ; ebx = pitch de la surface Dest
  lea ecx, [ecx * 4]        ; ecx = Nb bytes par ligne Dest
  lea esi, [MD_Screen + 8 * 2]  ; esi = Source
  sub ebx, ecx          ; ebx = Complment offset pour ligne suivante
  shr ecx, 4            ; on transfert 32 bytes Dest  chaque boucle
  mov edi, [esp + 24]        ; edi = Destination
  mov [esp + 32], ecx        ; on stocke cette nouvelle valeur pour X
  test byte [Mode_555], 1
  movq mm6, [MASK_DIV2_15]
  movq mm7, [MASK_DIV4_15]
  movq mm5, [MASK_DIV8_15]
  jnz short .Loop_Y

  movq mm6, [MASK_DIV2_16]
  movq mm7, [MASK_DIV4_16]
  movq mm5, [MASK_DIV8_16]
  jmp short .Loop_Y

ALIGN64

.Loop_Y
.Loop_X1
      movq mm0, [esi]
      add edi, byte 16
      movq mm2, mm0
      movq mm1, [esi + 2]
      psrlw mm0, 1
      psrlw mm1, 1
      pand mm0, mm6
      pand mm1, mm6
      movq mm3, mm2
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm2, mm0
      punpckhwd mm3, mm0
      movq [edi + 0 - 16], mm2
      dec ecx
      movq [edi + 8 - 16], mm3
      jnz short .Loop_X1

    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 32 dans une ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    shl ecx, 3
    sub esi, ecx
    shr ecx, 3
    jmp short .Loop_X2

ALIGN64

.Loop_X2
      movq mm0, [esi]
      add edi, byte 16
      movq mm1, [esi + 2]
      movq mm2, mm0
      movq mm3, mm1
      psrlq mm0, 2
      psrlq mm2, 1
      pand mm0, mm7
      pand mm2, mm6
      psrlq mm1, 3
      paddw mm0, mm2
      psrlq mm3, 2
      movq mm4, mm0
      pand mm1, mm5
      pand mm3, mm7
      psrlq mm0, 1
      paddw mm1, mm3
      pand mm0, mm6
      movq mm2, mm4
      paddw mm0, mm1
      add esi, byte 8
      punpcklwd mm4, mm0
      punpckhwd mm2, mm0
      movq [edi + 0 - 16], mm4
      dec ecx
      movq [edi + 8 - 16], mm2
      jnz short .Loop_X2

    add esi, [esp + 40]      ; on augmente la source pour pointer sur la prochaine ligne
    add edi, ebx        ; on augmente la destination avec le debordement du pitch
    dec dword [esp + 36]    ; on continue tant qu'il reste des lignes
    mov ecx, [esp + 32]      ; ecx = Nombre de pixels / 4 dans une ligne
    jnz near .Loop_Y

  pop esi
  pop edi
  pop edx
  pop ecx
  pop ebx
  emms
  ret
; --------------------------------------------------------------------------------------


%define REG_PUSH 4
%define DEST     esp + ((REG_PUSH + 1) * 4)
%define PITCH    esp + ((REG_PUSH + 2) * 4)
%define X        esp + ((REG_PUSH + 3) * 4)
%define Y        esp + ((REG_PUSH + 4) * 4)
%define OFFSET   esp + ((REG_PUSH + 5) * 4)
%define SOURCE   MD_Screen + 16

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X3(LPBYTE Dest, int pitch, int x, int y, int offset)
; triplica o tamanho da imagem
DECL Blit_X3
  push ebx
  push ebp
  push edi
  push esi

  mov  edi, [DEST]            ; destino
  lea  esi, [SOURCE]          ; origem
  mov  ecx, [X]               ; nmero de pixels por linha na origem
  imul ecx, 6                 ; nmero de bytes impressos por linha no destino
  mov  ebp, [PITCH]           ; ebp = tamanho em bytes de uma linha no destino
  mov  edx, ebp
  sub  edx, ecx               ; parte da linha do destino que no  impressa
  mov  [PITCH], edx
  shr  dword [X], 1           ; divide por dois, pois cada etapa do loop faz dois pixels
  mov  ecx, [X]
  jmp  .loop_y

  ALIGN64
  .loop_y:
    .loop_x:
    mov  eax, [esi]
    mov  edx, eax
    shr  edx, 16
    mov  ebx, eax
    mov  bx, dx
    mov  dx, ax
    shl  edx, 16
    mov  dx, ax
    mov  [edi], edx
    mov  [edi + 4], eax
    mov  [edi + 8], ebx
    mov  [edi + ebp], edx
    mov  [edi + ebp + 4], eax
    mov  [edi + ebp + 8], ebx
    mov  [edi + ebp + ebp], edx
    mov  [edi + ebp + ebp + 4], eax
    mov  [edi + ebp + ebp + 8], ebx
    add  edi, 12
    add  esi, 4
    dec  ecx
    jnz  .loop_x
  
  add  edi, [PITCH]
  lea  edi, [edi + ebp + ebp]
  add  esi, [OFFSET]
  mov  ecx, [X]
  dec  dword [Y]
  jnz  .loop_y

  pop  esi
  pop  edi
  pop  ebp
  pop  ebx
  ret
; --------------------------------------------------------------------------------------
  
%define REG_PUSH 3

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X3_MMX(LPBYTE Dest, int pitch, int x, int y, int offset)
; triplica o tamanho da imagem
DECL Blit_X3_MMX
  push ebx
  push edi
  push esi

  mov  edi, [DEST]            ; destino
  lea  esi, [SOURCE]          ; origem
  mov  ecx, [X]               ; nmero de pixels por linha na origem
  imul ecx, 6                 ; nmero de bytes impressos por linha no destino
  mov  ebx, [PITCH]           ; ebx = tamanho em bytes de uma linha no destino
  mov  edx, ebx
  sub  edx, ecx               ; parte da linha do destino que no  impressa
  mov  [PITCH], edx
  shr  dword [X], 3           ; divide por oito, pois cada etapa do loop faz oito pixels
  mov  ecx, [X]  
  jmp  .loop_y

  ALIGN64
  .loop_y:
    .loop_x:
    movq      mm0, [esi]
    movq      mm4, [esi + 8]

    movq      mm1, mm0
    punpcklwd mm1, mm1
    punpcklwd mm1, mm0
    psrlq     mm0, 16
    movq      mm2, mm0
    punpcklwd mm2, mm2
    psrlq     mm0, 16
    movq      mm3, mm0
    psrlq     mm3, 16
    punpcklwd mm3, mm3
    punpcklwd mm0, mm3

    movq      mm5, mm4
    punpcklwd mm5, mm5
    punpcklwd mm5, mm4
    psrlq     mm4, 16
    movq      mm6, mm4
    punpcklwd mm6, mm6
    psrlq     mm4, 16
    movq      mm7, mm4
    psrlq     mm7, 16
    punpcklwd mm7, mm7
    punpcklwd mm4, mm7

    movq      [edi], mm1
    movq      [edi + 8], mm2
    movq      [edi + 16], mm0
    movq      [edi + 24], mm5
    movq      [edi + 32], mm6
    movq      [edi + 40], mm4
    movq      [edi + ebx], mm1
    movq      [edi + ebx + 8], mm2
    movq      [edi + ebx + 16], mm0
    movq      [edi + ebx + 24], mm5
    movq      [edi + ebx + 32], mm6
    movq      [edi + ebx + 40], mm4
    movq      [edi + ebx + ebx], mm1
    movq      [edi + ebx + ebx + 8], mm2
    movq      [edi + ebx + ebx + 16], mm0
    movq      [edi + ebx + ebx + 24], mm5
    movq      [edi + ebx + ebx + 32], mm6
    movq      [edi + ebx + ebx + 40], mm4

    add  edi, 48
    add  esi, 16
    dec  ecx
    jnz  .loop_x
  
  add  edi, [PITCH]
  lea  edi, [edi + ebx + ebx]
  add  esi, [OFFSET]
  mov  ecx, [X]
  dec  dword [Y]
  jnz  .loop_y

  pop  esi
  pop  edi
  pop  ebx
  emms
  ret
; --------------------------------------------------------------------------------------
  
%define REG_PUSH 4

ALIGN64

; --------------------------------------------------------------------------------------
; void Blit_X3_Int(LPBYTE Dest, int pitch, int x, int y, int offset)
; usa interpolao com intensidade
DECL Blit_X3_Int
  push ebx
  push ebp
  push edi
  push esi

  mov  edi, [DEST]            ; destino
  lea  esi, [SOURCE]          ; origem
  mov  ecx, [X]               ; nmero de pixels por linha na origem
  imul ecx, 6                 ; nmero de bytes impressos por linha no destino
  mov  ebp, [PITCH]           ; ebp = tamanho em bytes de uma linha no destino
  mov  edx, ebp
  sub  edx, ecx               ; parte da linha do destino que no  impressa
  mov  [PITCH], edx
  mov  ecx, [X]
  jmp  .loop_y

  ALIGN64
  .loop_y:
    .loop_x:
    mov  eax, [esi]
    mov  edx, eax
    ror  edx, 16
    shr  edx, 1
    and  edx, 0x7BCF7BCF
    add  edx, edx
    mov  ebx, eax
    shr  ebx, 1
    and  ebx, 0x7BCF7BCF
    shr  edx, 1
    and  edx, 0x7BCF7BCF
    add  edx, ebx
    xchg ax, dx
    mov  [edi], edx
    mov  [edi + 4], ax
    mov  [edi + ebp], edx
    mov  [edi + ebp + 4], ax
    mov  [edi + ebp + ebp], edx
    mov  [edi + ebp + ebp + 4], ax
    add  edi, 6
    add  esi, 2
    dec  ecx
    jnz  .loop_x
  
  add  edi, [PITCH]
  lea  edi, [edi + ebp + ebp]
  add  esi, [OFFSET]
  mov  ecx, [X]
  dec  dword [Y]
  jnz  .loop_y

  pop  esi
  pop  edi
  pop  ebp
  pop  ebx
  ret
; --------------------------------------------------------------------------------------
