
#include "ggraphic.h"
#include "gddraw.h"
#include "ggdi.h"
#include "gdsound.h"
#include "gdinput.h"
#include "gmain.h"
#include "resource.h"
#include "gens.h"
#include "mem_M68K.h"
#include "vdp_io.h"
#include "vdp_rend.h"
#include "misc.h"
#include "blit.h"
#include "net.h"
#include "cdda_mp3.h"
#include "config.h"
#include "state.h"
#include "sms.h"

// o device padro full screen  o ddraw
int  (__stdcall *Init_Graphics_FS)(HWND)        = Init_DDraw;
void (__stdcall *End_Graphics_FS)(void)         = End_DDraw;
void (__stdcall *Flip_FS)(HWND)                 = Flip_DDraw_FS;
int  (__stdcall *Clear_Primary_Screen_FS)(HWND) = Clear_DDraw_Primary_Screen;
int  (__stdcall *Clear_Back_Screen_FS)(HWND)    = Clear_DDraw_Back_Screen;
void (__stdcall *Restore_Primary)(void)         = Restore_DDraw_Primary;

// o padro janela  o gdi
int  (__stdcall *Init_Graphics_W)(HWND)         = Init_DDraw;
void (__stdcall *End_Graphics_W)(void)          = End_DDraw;
void (__stdcall *Flip_W)(HWND)                  = Flip_DDraw_W;
int  (__stdcall *Clear_Primary_Screen_W)(HWND)  = Clear_DDraw_Primary_Screen;
int  (__stdcall *Clear_Back_Screen_W)(HWND)     = Clear_DDraw_Back_Screen;

int Flag_Clr_Scr = 0;

char Info_String[1024] = "";
int  Message_Showed    = 0;
UINT Info_Time         = 0;
int  MiniShot_Showed   = 0;
UINT MiniShot_Time     = 0;

void (*Blit_FS)(unsigned char *Dest, int pitch, int x, int y, int offset);
void (*Blit_W)(unsigned char *Dest, int pitch, int x, int y, int offset);
int (__fastcall *Update_Frame)(void);
int (__fastcall *Update_Frame_Fast)(void);

int Sleep_Time;
int Kaillera_Error = 0;

clock_t Last_Time = 0, New_Time = 0;
clock_t Used_Time = 0;

//MK2k
int MemstateFrameSkip = 0; // Every N frames save to a Memstate
int MemstateFrame = 0;
int RewindTimer = 0;

int __fastcall Flip(HWND hWnd)
{
  int            i;
  static float   FPS = 0.0f, frames[8] = {0, 0, 0, 0, 0, 0, 0, 0};
  static UINT    old_time = 0, view_fps = 0, index_fps = 0, freq_cpu[2] = {0, 0};
  UINT           new_time[2];


  if((Genesis_Started || _32X_Started || SegaCD_Started || SMS_Started) && !Debug)
  {
    if(MiniShot_Showed)
    {
      if(GetTickCount() > MiniShot_Time || MiniShot_ID != MINISHOT_ID)
      { MiniShot_Showed = 0; }
      else
      { Print_MiniShot(20, 170); }
    }
  }

  if(!Paused || Debug)
  {
    if(Message_Showed)
    {
      if(GetTickCount() > Info_Time)
      {
        Message_Showed = 0;
        *Info_String = 0;
      }
      else if(Print_Message)
        Print_Message(Info_String, Message_Color, 12, SMS_Started ? 50 : 20);
    }
    else if(Show_FPS && !Debug &&
           (Genesis_Started || _32X_Started || SegaCD_Started))
    {
      if(freq_cpu[0] > 1)        // accurate timer ok
      {
        if(++view_fps >= 16)
        {
          QueryPerformanceCounter((union _LARGE_INTEGER *) new_time);

          if(new_time[0] != old_time)
          {
            FPS = (float) (freq_cpu[0]) * 16.0f / (float) (new_time[0] - old_time);
            sprintf(Info_String, "%.1f", FPS);
          }
          else
          {
            sprintf(Info_String, "too much...");
          }

          old_time = new_time[0];
          view_fps = 0;
        }
      }
      else if(freq_cpu[0] == 1)      // accurate timer not supported
      {
        if(++view_fps >= 10)
        {
          new_time[0] = GetTickCount();

          if(new_time[0] != old_time) frames[index_fps] = 10000 / (float)(new_time[0] - old_time);
          else frames[index_fps] = 2000;

          index_fps++;
          index_fps &= 7;
          FPS = 0.0f;

          for(i = 0; i < 8; i++) FPS += frames[i];

          FPS /= 8.0f;
          old_time = new_time[0];
          view_fps = 0;
        }

        sprintf(Info_String, "%.1f", FPS);
      }
      else
      {
        QueryPerformanceFrequency((union _LARGE_INTEGER *) freq_cpu);
        if(freq_cpu[0] == 0) freq_cpu[0] = 1;

        sprintf(Info_String, "", FPS);
      }

      if(Print_FPS) Print_FPS(Info_String, FPS_Color, 12, 20);
    }
  }

  if(Fast_Blur) Half_Blur();

  if(Full_Screen) Flip_FS(hWnd);
  else            Flip_W(hWnd);

  return 1;
}

int __fastcall Update_Emulation(HWND hWnd)
{
  static int Over_Time = 0;
  int        current_div;

  if(Frame_Skip != -1 || Turbo_Mode)
  {
    if(Sound_Enable)
    {
      WP = (WP + 1) & (Sound_Segs - 1);

      if(WP == Get_Current_Seg())
        WP = (WP + Sound_Segs - 1) & (Sound_Segs - 1);

      Write_Sound_Buffer(NULL);
    }

    Update_Controllers();

    if(Frame_Number++ < (Turbo_Mode ? 8 : Frame_Skip))
    {
      Update_Frame_Fast();
    }
    else
    {
      Frame_Number = 0;

			//MK2k - RewindRequested
			if(RewindRequested())
			{
				MESSAGE_L("REWiND", "REWiND", 200);
				if(RewindTimer <= 0)
				{
					if (load_Memstate())
					{
						Update_Frame();
						Flip(hWnd);
					}
					RewindTimer = MemstateFrameSkip;
				}
				else
				{
					RewindTimer--;
				}
			}
			else
			{
				Update_Frame();

				//MK2k: Autosave
				if(MemstateFrame++ >= MemstateFrameSkip)
				{
					MemstateFrame = 0;
					save_Memstate();
				}
			}

      Flip(hWnd);
    }
  }
  else
  {
    if(Sound_Enable)
    {
      while (WP == Get_Current_Seg()) Sleep(Sleep_Time);

      RP = Get_Current_Seg();

      while (WP != RP)
      {
        Write_Sound_Buffer(NULL);
        WP = (WP + 1) & (Sound_Segs - 1);
        Update_Controllers();

        if(WP != RP)
        {
          Update_Frame_Fast();
        }
        else
        {
					//MK2k - RewindRequested
					if(RewindRequested())
					{
						MESSAGE_L("REWiND", "REWiND", 200);
						if(RewindTimer <= 0)
						{
							if (load_Memstate())
							{
								Update_Frame();
							}
							RewindTimer = MemstateFrameSkip;
						}
						else
						{
							RewindTimer--;
						}
					}

					//MK2k: Autosave
					else
					{
						Update_Frame();

						if(MemstateFrame++ >= MemstateFrameSkip)
						{
					    MemstateFrame = 0;
							save_Memstate();
						}
					}

					Flip(hWnd);
        }
      }
    }
    else
    {
      if(CPU_Mode) current_div = 20;
      else current_div = 16 + (Over_Time ^= 1);

      New_Time = GetTickCount();
      Used_Time += (New_Time - Last_Time);
      Frame_Number = Used_Time / current_div;
      Used_Time %= current_div;
      Last_Time = New_Time;

      if(Frame_Number > 8) Frame_Number = 8;

      for (; Frame_Number > 1; Frame_Number--)
      {
        Update_Controllers();
        Update_Frame_Fast();
      }

      if(Frame_Number)
      {
				//MK2k - RewindRequested
				if(RewindRequested())
				{
					MESSAGE_L("REWiND", "REWiND", 200);
					if(RewindTimer <= 0)
					{
						if (load_Memstate())
						{
							Update_Frame();
							Update_Controllers();
							Flip(hWnd);
						}
						RewindTimer = MemstateFrameSkip;
					}
					else
					{
						RewindTimer--;
					}
				}
				else
				{
					Update_Controllers();
		      Update_Frame();

			    //MK2k: Autosave
					if(MemstateFrame++ >= MemstateFrameSkip)
					{
					  MemstateFrame = 0;
					  save_Memstate();
					}

					Flip(hWnd);
				}
      }
      else Sleep(Sleep_Time);
    }
  }

  return 1;
}


int __fastcall Update_Emulation_One(HWND hWnd)
{
  Update_Controllers();
  Update_Frame();
  Flip(hWnd);

  return 1;
}


int __fastcall Update_Emulation_Netplay(HWND hWnd, int player, int num_player)
{
  static int Over_Time = 0;
  int current_div;

  if(CPU_Mode) current_div = 20;
  else current_div = 16 + (Over_Time ^= 1);

  New_Time = GetTickCount();
  Used_Time += (New_Time - Last_Time);
  Frame_Number = Used_Time / current_div;
  Used_Time %= current_div;
  Last_Time = New_Time;

  if(Frame_Number > 6) Frame_Number = 6;

  for (; Frame_Number > 1; Frame_Number--)
  {
    if(Sound_Enable)
    {
      if(WP == Get_Current_Seg()) WP = (WP - 1) & (Sound_Segs - 1);
      Write_Sound_Buffer(NULL);
      WP = (WP + 1) & (Sound_Segs - 1);
    }

    Scan_Player_Net(player);
    if(Kaillera_Error != -1) Kaillera_Error = Kaillera_Modify_Play_Values((void *) (Kaillera_Keys), 2);
    //Kaillera_Error = Kaillera_Modify_Play_Values((void *) (Kaillera_Keys), 2);
    Update_Controllers_Net(num_player);
    Update_Frame_Fast();
  }

  if(Frame_Number)
  {
    if(Sound_Enable)
    {
      if(WP == Get_Current_Seg()) WP = (WP - 1) & (Sound_Segs - 1);
      Write_Sound_Buffer(NULL);
      WP = (WP + 1) & (Sound_Segs - 1);
    }

    Scan_Player_Net(player);
    if(Kaillera_Error != -1) Kaillera_Error = Kaillera_Modify_Play_Values((void *) (Kaillera_Keys), 2);
    //Kaillera_Error = Kaillera_Modify_Play_Values((void *) (Kaillera_Keys), 2);
    Update_Controllers_Net(num_player);
    Update_Frame();
    Flip(hWnd);
  }

  return 1;
}
