
#ifndef GGRAPHIC_H
#define GGRAPHIC_H

#include <windows.h>
#include <time.h>
#include "gddraw.h"
#include "ggdi.h"
#include "gd3d.h"
#include "gmain.h"
#include "gintro.h"

#ifdef __cplusplus
extern "C" {
#endif

#define GDEVICE_GDI   0
#define GDEVICE_DDRAW 1
#define GDEVICE_D3D   2

// device functions
extern int  (__stdcall *Init_Graphics_FS)(HWND);
extern void (__stdcall *End_Graphics_FS)(void);
extern void (__stdcall *Flip_FS)(HWND);
extern int  (__stdcall *Clear_Primary_Screen_FS)(HWND);
extern int  (__stdcall *Clear_Back_Screen_FS)(HWND);
extern void (__stdcall *Restore_Primary)(void);

extern int  (__stdcall *Init_Graphics_W)(HWND);
extern void (__stdcall *End_Graphics_W)(void);
extern void (__stdcall *Flip_W)(HWND);
extern int  (__stdcall *Clear_Primary_Screen_W)(HWND);
extern int  (__stdcall *Clear_Back_Screen_W)(HWND);

extern clock_t Last_Time;
extern clock_t New_Time;
extern clock_t Used_Time;

// clear flag
extern int Flag_Clr_Scr;

extern int Sleep_Time;
extern int Kaillera_Error;

extern void (*Blit_FS)(unsigned char *Dest, int pitch, int x, int y, int offset);
extern void (*Blit_W)(unsigned char *Dest, int pitch, int x, int y, int offset);
extern int  (__fastcall *Update_Frame)(void);
extern int  (__fastcall *Update_Frame_Fast)(void);

extern char Info_String[1024];
extern int  Message_Showed;
extern UINT Info_Time;
extern int  MiniShot_Showed;
extern UINT MiniShot_Time;

BOOL __fastcall Save_Shot(void);
void __fastcall Create_MiniShot(void);
void __fastcall Print_MiniShot(int x, int y);

void __inline Put_Info(LPCSTR Message, int Duree)
{ if(Show_Message)
  { strcpy(Info_String, Message);
    Info_Time = GetTickCount() + Duree;
    Message_Showed = 1; } }

__inline void Show_MiniShot(int Duree)
{ if(Use_State_MiniShot)
  { MiniShot_Time = GetTickCount() + Duree;
    MiniShot_Showed = 1; } }

#define Erase_MiniShot() (MiniShot_Showed = 0)

#define Show_Genesis_Screen(hWnd) Do_VDP_Only(), Flip(hWnd)

int  __fastcall Update_Emulation(HWND hWnd);
int  __fastcall Update_Emulation_One(HWND hWnd);
int  __fastcall Update_Emulation_Netplay(HWND hWnd, int player, int num_player);
int  __fastcall Flip(HWND hWnd);


#ifdef __cplusplus
};
#endif

#endif // GGRAPHIC_H
