; minishot.asm - projeto gens+. Rodrigo Cardoso.
; cria e imprime minishots

%include "nasmhead.inc"

section .bss  align=64

  extern MD_Screen
  extern _Mode_555
  extern _Update_Frame
  extern _VDP_Reg
  extern _SMS_Started
  extern @Do_SMS_Frame@0
  DECL   MiniShot_Data
  DECL   MiniShot_ID
  resd   1
  DECL   MiniShot_Buffer
  resw   (80 * 60)
  src: resd 1
  ix:  resd 1
  iy:  resd 1
  cy:  resd 1


section .text align=64

; --------------------------------------------------------------------------------------
; void __fastcall Print_MiniShot(int x, int y)
; imprime o minishot na tela
DECLF Print_MiniShot, 8
  sub   edx, 182
  jns   near .error
  not   edx
  imul  edx, 336
  cmp   ecx, 242
  jns   .error
  add   ecx, edx
  imul  ecx, 2

  push  edi
  push  esi

  mov   eax, 0x001F001F
  lea   edi, [MD_Screen + ecx]
  lea   esi, [MiniShot_Buffer]

  ; traando as linhas horizontais
  mov   ecx, 40
  ALIGN4
  .loop1:
    mov   [edi], eax
    mov   [edi + (20496 * 2)], eax
    add   edi, 4
    dec   ecx
    jnz   .loop1

  add   edi, 512

  ; copiando a imagem
  mov   edx, 60
  cld
  .loopy:
    mov   ecx, 40
    ALIGN4
    .loopx:
      movsd
      dec   ecx
      jnz   .loopx
    add   edi, 512
    dec   edx
    jnz   .loopy

  ; traando as linhas verticais
  add   edi, 160
  mov   ecx, 62
  ALIGN4
  .loop3:
    mov   [edi], ax
    mov   [edi - 162], ax
    sub   edi, 672
    dec   ecx
    jnz   .loop3

  pop   esi
  pop   edi

  .error:
  ret
; --------------------------------------------------------------------------------------


%define MINISHOT_ID 0x00534D47

; calcula a mdia das cores ax e %1 para ax
%macro MEDCLR 1
  mov  dx, [%1]
  shr  ax, 1
  shr  dx, 1
  and  ax, 0x7BCF
  and  dx, 0x7BCF
  add  ax, dx
%endmacro

; --------------------------------------------------------------------------------------
; void __fastcall Create_MiniShot(void)
; cria um shot da tela com 1/4 do tamanho original em MiniShot_Buffer
DECLF Create_MiniShot, 0
  push  ebx
  push  edi
  push  esi
  push  ebp

  ; inserindo o identificador
  mov   dword [MiniShot_ID], MINISHOT_ID

  mov   edi, MiniShot_Buffer
  mov   esi, MD_Screen + 16
  mov   [cy], dword 240 / 4

  ; refazendo o frame
  test  [_SMS_Started], byte 1
  jnz   .sms

  ; refazendo o frame (para tirar possveis textos na tela)
  call  [_Update_Frame]
  mov   dword [ix], 320 * 4 / 320
  test  [_VDP_Reg + (12 * 4)], byte 1
  jnz    .next
  add   esi, 16
  dec   dword [ix]
  .next:
  mov   dword [iy], 240 * 4 / 240
  mov   [src], esi
  jmp   .loop_y

  ALIGN4
  .sms:
  call  @Do_SMS_Frame@0
  mov   dword [ix], 256 * 4 / 320
  mov   dword [iy], 190 * 4 / 240
  add   esi, 16
  mov   [src], esi

  ALIGN4
  .loop_y:
    mov  ecx, 320 / 4
    ALIGN4
    .loop_x:
      mov    ax, [esi]
      mov    ebx, [ix]
      dec    ebx
      .xpix:
        MEDCLR ebx * 2 + esi
        dec    ebx
        jnz    .xpix
      mov    ebx, [iy]
      dec    ebx
      mov    ebp, esi
      .ypix:
        add    ebp, 336 * 2
        MEDCLR ebp
        dec    ebx
        jnz    .ypix
      mov   [edi], ax

      mov   ebx, [ix]
      lea   esi, [ebx * 2 + esi]
      add   edi, 2
      dec   ecx
      jnz   .loop_x

    mov   ecx, [iy]
    imul  ecx, 336 * 2
    add   [src], ecx
    mov   esi, [src]
    dec   dword [cy]
    jnz   .loop_y


  pop   ebp
  pop   esi
  pop   edi
  pop   ebx
  ret
; --------------------------------------------------------------------------------------
