//Gens Movie
//Jyzero

#include "zlib.h"
#include "gens.h"
#include "gmain.h"
#include "gmenu.h"
#include "gio.h"
#include "gddraw.h"
#include "gdinput.h"
#include "sms.h"
#include "z80.h"
#include "state.h"
#include "mem_m68k.h"
#include "movie.h"

// current opened movie file
GZFILE Movie_File_Playing         = NULL;
FILE  *Movie_File_Recording       = NULL;
char   Movie_File_Name[GMAX_PATH] = "";

// I changed the name of this variable to don't confound with gens emulation variables
UINT Movie_Frame_Count = 0; // Number of frame elapsed since reset
UINT Movie_Last_Frame  = 0;
int  Movie_Status      = MOVIE_FINISHED;
UINT Movie_Save_Joys[8];   // this is to save the joy type before we change it in movie playing

extern "C" int Genesis_Started;
extern "C" int _32X_Started;
extern "C" int SegaCD_Started;
extern "C" int CRam_Flag, VRam_Flag;

// *** called instead of Update_Controllers() when a movie is playing ***
// I change it, now this function is called inside the Update_Controllers() function when Movie_Status is set to MOVIE_PLAYING.
void __stdcall MoviePlayingStuff(void)
{
  int  Pad_Data_Size, i;
	char PadData[8];

	// Check_Misc_Key();  //Quicksave, quickload, slowdown
  if(Movie_Status & MOVIE_ALLJOYS) Pad_Data_Size = 12;
  else                             Pad_Data_Size = 3;
  // reading the next input from the file
  if(gzread(Movie_File_Playing, PadData, Pad_Data_Size) != Pad_Data_Size)
  { StopPlayMovie(); return; } // error reading file

  // you made a mistake here, the controller one is Control[0] not Control[1], fixed
	Control[0].Up    = (PadData[0]&1);
	Control[0].Down  = (PadData[0]&2)>>1;
	Control[0].Left  = (PadData[0]&4)>>2;
	Control[0].Right = (PadData[0]&8)>>3;
	Control[0].A     = (PadData[0]&16)>>4;
	Control[0].B     = (PadData[0]&32)>>5;
	Control[0].C     = (PadData[0]&64)>>6;
	Control[0].Start = (PadData[0]&128)>>7;
	Control[1].Up    = (PadData[1]&1);
	Control[1].Down  = (PadData[1]&2)>>1;
	Control[1].Left  = (PadData[1]&4)>>2;
	Control[1].Right = (PadData[1]&8)>>3;
	Control[1].A     = (PadData[1]&16)>>4;
	Control[1].B     = (PadData[1]&32)>>5;
	Control[1].C     = (PadData[1]&64)>>6;
	Control[1].Start = (PadData[1]&128)>>7;
	Control[0].X     = (PadData[2]&1);
	Control[0].Y     = (PadData[2]&2)>>1;
	Control[0].Z     = (PadData[2]&4)>>2;
	Control[0].Mode  = (PadData[2]&8)>>3;
	Control[1].X     = (PadData[2]&16)>>4;
	Control[1].Y     = (PadData[2]&32)>>5;
	Control[1].Z     = (PadData[2]&64)>>6;
	Control[1].Mode  = (PadData[2]&128)>>7;

  // this is to suport games that uses more then two joys
  if(Movie_Status & MOVIE_ALLJOYS)
  {
    for(i = 2; i < 8; i += 2)
    {
	    Control[i].Up        = (PadData[(i >> 1) * 3]&1);
	    Control[i].Down      = (PadData[(i >> 1) * 3]&2)>>1;
	    Control[i].Left      = (PadData[(i >> 1) * 3]&4)>>2;
	    Control[i].Right     = (PadData[(i >> 1) * 3]&8)>>3;
	    Control[i].A         = (PadData[(i >> 1) * 3]&16)>>4;
	    Control[i].B         = (PadData[(i >> 1) * 3]&32)>>5;
	    Control[i].C         = (PadData[(i >> 1) * 3]&64)>>6;
	    Control[i].Start     = (PadData[(i >> 1) * 3]&128)>>7;
	    Control[i + 1].Up    = (PadData[(i >> 1) * 3 + 1]&1);
	    Control[i + 1].Down  = (PadData[(i >> 1) * 3 + 1]&2)>>1;
	    Control[i + 1].Left  = (PadData[(i >> 1) * 3 + 1]&4)>>2;
	    Control[i + 1].Right = (PadData[(i >> 1) * 3 + 1]&8)>>3;
	    Control[i + 1].A     = (PadData[(i >> 1) * 3 + 1]&16)>>4;
	    Control[i + 1].B     = (PadData[(i >> 1) * 3 + 1]&32)>>5;
	    Control[i + 1].C     = (PadData[(i >> 1) * 3 + 1]&64)>>6;
	    Control[i + 1].Start = (PadData[(i >> 1) * 3 + 1]&128)>>7;
	    Control[i].X         = (PadData[(i >> 1) * 3 + 2]&1);
	    Control[i].Y         = (PadData[(i >> 1) * 3 + 2]&2)>>1;
	    Control[i].Z         = (PadData[(i >> 1) * 3 + 2]&4)>>2;
	    Control[i].Mode      = (PadData[(i >> 1) * 3 + 2]&8)>>3;
	    Control[i + 1].X     = (PadData[(i >> 1) * 3 + 2]&16)>>4;
	    Control[i + 1].Y     = (PadData[(i >> 1) * 3 + 2]&32)>>5;
	    Control[i + 1].Z     = (PadData[(i >> 1) * 3 + 2]&64)>>6;
	    Control[i + 1].Mode  = (PadData[(i >> 1) * 3 + 2]&128)>>7;
    }
  }

  // end of the movie
  if(++Movie_Frame_Count >= Movie_Last_Frame) StopPlayMovie();
}

// this function is called in Update_Controllers() when Movie_Status is set to MOVIE_RECORDING
void __stdcall MovieRecordingStuff(void)
{
  int  Pad_Data_Size, i;
	char PadData[8]; //Modif

  PadData[0] = Control[0].Up+(Control[0].Down<<1)+(Control[0].Left<<2)+(Control[0].Right<<3)
		+(Control[0].A<<4)+(Control[0].B<<5)+(Control[0].C<<6)+(Control[0].Start<<7);
	PadData[1] = Control[1].Up+(Control[1].Down<<1)+(Control[1].Left<<2)+(Control[1].Right<<3)
		+(Control[1].A<<4)+(Control[1].B<<5)+(Control[1].C<<6)+(Control[1].Start<<7);
	PadData[2] = Control[0].X+(Control[0].Y<<1)+(Control[0].Z<<2)+(Control[0].Mode<<3)
		+(Control[1].X<<4)+(Control[1].Y<<5)+(Control[1].Z<<6)+(Control[1].Mode<<7);

  if(Movie_Status & MOVIE_ALLJOYS) // suport for all eight joys
  {
    Pad_Data_Size = 6;
    for(i = 2; i < 8; i += 2)
    {
      PadData[(i >> 1) * 3] =
        Control[i].Up+(Control[i].Down<<1)+(Control[i].Left<<2)+(Control[i].Right<<3)
		    +(Control[i].A<<4)+(Control[i].B<<5)+(Control[i].C<<6)+(Control[i].Start<<7);
	    PadData[(i >> 1) * 3 + 1] =
        Control[i + 1].Up+(Control[i + 1].Down<<1)+(Control[i + 1].Left<<2)+(Control[i + 1].Right<<3)
		    +(Control[i + 1].A<<4)+(Control[i + 1].B<<5)+(Control[i + 1].C<<6)+(Control[i + 1].Start<<7);
	    PadData[(i >> 1) * 3 + 1] =
        Control[i].X+(Control[i].Y<<1)+(Control[i].Z<<2)+(Control[i].Mode<<3)
		    +(Control[i + 1].X<<4)+(Control[i + 1].Y<<5)+(Control[i + 1].Z<<6)+(Control[i + 1].Mode<<7);
    }
  }
  else Pad_Data_Size = 3;

  for(i = 0; i < Pad_Data_Size; i++)
  {
    if(putc(PadData[i], Movie_File_Recording) == EOF) { StopRecordMovie(); return; }
  }

  Movie_Frame_Count++; // count the total number of frames saved
}

// this function is called when the user choose play movie in the menu
int __stdcall StartPlayMovie(void)
{
  GZFILE        file;
  GMOVIEFILEHDR hdr;
  LPBYTE        buf;
  int           i;

  if     (Movie_Status & MOVIE_PLAYING)   StopPlayMovie();   // previous movie playing
  else if(Movie_Status & MOVIE_RECORDING) StopRecordMovie(); // previous movie recording

  file = gzopen(Movie_File_Name, "rb"); // trying to open the file
  if(!file) return 0;
  // trying to read the file header
  if(gzread(file, &hdr, sizeof(GMOVIEFILEHDR)) != sizeof(GMOVIEFILEHDR))
  { gzclose(file); return 0; }
  // check the magic and file version
  if(hdr.dwMagic != GMOVIE_FILE_TYPE || hdr.dwVersion != GMOVIE_FILE_VERSION)
  { gzclose(file); return 0; }
  // if the file has a state, we try to read it
  if(hdr.dwFlags & GMVF_USESTATE)
  {
    if(gzread(file, State_Buffer, hdr.uStateSize) != hdr.uStateSize)
    { gzclose(file); return 0; }
    buf = State_Buffer;
    // put the emulation at the state saved
    if(SMS_Started) Import_SMS(buf);
    else
    {
      z80_Reset(&M_Z80);
      Import_Genesis(buf);
      buf += 0x22500;
      if(SegaCD_Started) { Import_SegaCD(buf); buf += 0xE0000; }
      if(_32X_Started)   { Import_32X(buf);    buf += 0x82A00; }
      CRam_Flag = 1;
      VRam_Flag = 1;
    }
  }
  // otherwise it starts from the begining
  else
  {
    if     (SMS_Started)     SMS_Reset();
    else if(Genesis_Started) Reset_Genesis();
    else if(_32X_Started)    Reset_32X();
    else if(SegaCD_Started)  Reset_SegaCD();
  }
  // SRAM
  if(hdr.dwFlags & GMVF_USESRAM)
  {
    memset(SRAM, 0, 64 * 1024);
    if(gzread(file, SRAM, hdr.uSRAMSize) != hdr.uSRAMSize)
    { gzclose(file); return 0; }
  }

  Flag_Clr_Scr      = 1;
  Erase_MiniShot();
  Movie_Frame_Count = 0;
  Movie_Last_Frame  = hdr.dwFrames;
  Movie_Status      = MOVIE_PLAYING;
  if(hdr.dwFlags & GMVF_ALLJOYS) Movie_Status |= MOVIE_ALLJOYS;
  Movie_File_Playing = file;
  // saving the original joy configuration and put the new one
  for(i = 0; i < 8; i++)
  { Movie_Save_Joys[i] = Control[i].Type;
    Control[i].Type = hdr.wPlayerType[i]; }
  Build_Main_Menu();
  MESSAGE_L("Playing movie", "Playing movie", 2000);

  return 1;           // everything ok, we can start to play the file
}

// stops the movie playing
void __stdcall StopPlayMovie(void)
{
  int i;
  gzclose(Movie_File_Playing);
  Movie_File_Playing = NULL;
  Movie_Status       = MOVIE_FINISHED;
  // restore the original joy configuration
  for(i = 0; i < 8; i++) Control[i].Type = Movie_Save_Joys[i];
  Build_Main_Menu();
  MESSAGE_L("Movie stoped", "Movie stoped", 2000);
}

// starts to record a movie
int __stdcall StartRecordMovie(BOOL bSaveState)
{
  FILE         *file;
  GMOVIEFILEHDR hdr;
  LPBYTE        buf;
  int           i;

  if     (Movie_Status & MOVIE_PLAYING)   StopPlayMovie();   // previous movie playing
  else if(Movie_Status & MOVIE_RECORDING) StopRecordMovie(); // previous movie recording

  file = fopen(Movie_File_Name, "wbS"); // trying to create the file
  if(!file) return 0;
  // filling the file header with the current movie information
  memset(&hdr, 0, sizeof(GMOVIEFILEHDR));
  hdr.dwMagic        = GMOVIE_FILE_TYPE;               // put the magic
  hdr.dwVersion      = GMOVIE_FILE_VERSION;            // current file version
  hdr.dwFramesPerSec = CPU_Mode ? 50 : 60;
  // saving all the control types
  for(i = 0; i < 8; i++) hdr.wPlayerType[i] = Control[i].Type;
  if(Control[0].Type & 0x10 || Control[1].Type & 0x10) // detect teamplayer
    hdr.dwFlags |= GMVF_ALLJOYS;

  if(bSaveState) // state must be saved
  {
    hdr.dwFlags |= GMVF_USESTATE;
    // calculate the lenght of the state data
    if     (SMS_Started)     hdr.uStateSize = SMS_STATE_FILE_LENGHT;
    else if(Genesis_Started) hdr.uStateSize = GENESIS_STATE_FILE_LENGHT;
    else if(SegaCD_Started)  hdr.uStateSize = SEGACD_STATE_FILE_LENGHT;
    else if(_32X_Started)    hdr.uStateSize = G32X_STATE_FILE_LENGHT;
    // saving the current state in the file
    buf = State_Buffer;
    memset(buf, 0, hdr.uStateSize);
    if(SMS_Started) Export_SMS(buf);
    else
    {
      Export_Genesis(buf);
      buf += 0x22500;
      if(SegaCD_Started) { Export_SegaCD(buf); buf += 0xE0000; }
      if(_32X_Started)   { Export_32X(buf);    buf += 0x82A00; }
    }
  }

  // verify the need to save SRAM
  i = (64 * 1024) - 1;
  while(i >= 0 && !SRAM[i]) i--;
  if(i >= 0)
  {
    hdr.dwFlags |= GMVF_USESRAM;
    i++;
    hdr.uSRAMSize = 1;
    while((UINT)i > hdr.uSRAMSize) hdr.uSRAMSize <<= 1;
  }

  // trying to write the header in the file
  if(fwrite(&hdr, sizeof(GMOVIEFILEHDR), 1, file) != 1)
  { fclose(file); return 0; }
  // saving the state
  if(hdr.dwFlags & GMVF_USESTATE)
  {
    if(fwrite(State_Buffer, hdr.uStateSize, 1, file) != 1)
    { fclose(file); return 0; }
  }
  // saving SRAM
  if(hdr.dwFlags & GMVF_USESRAM)
  {
    if(fwrite(SRAM, hdr.uSRAMSize, 1, file) != 1)
    { fclose(file); return 0; }
  }

  Movie_Status         = MOVIE_RECORDING;
  if(hdr.dwFlags & GMVF_ALLJOYS) Movie_Status |= MOVIE_ALLJOYS;
  Movie_File_Recording = file;
  Movie_Frame_Count    = 0;
  Build_Main_Menu();
  MESSAGE_L("Recording movie", "Recording movie", 2000);

  return 1;
}

void __stdcall StopRecordMovie(void)
{
  // put the total number of frames saved in the file
  if(!fseek(Movie_File_Recording, 12, SEEK_SET))
  {
    fwrite(&Movie_Frame_Count, 4, 1, Movie_File_Recording);
  }
  fclose(Movie_File_Recording);
  Movie_File_Recording = NULL;
  Movie_Status         = MOVIE_FINISHED;
  Build_Main_Menu();
  MESSAGE_L("Stop movie record", "Stop movie record", 2000);
}

// compress the movie file in Movie_File_Name
int __stdcall CompressMovieFile(void)
{
  HANDLE  fIn;
  GZFILE  fOut;
  char    pOutName[GMAX_PATH];
  LPSTR   ext;
  int     i;
  DWORD   sz;

  // open the input file for reading
  fIn = CreateFile(Movie_File_Name, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
  if(fIn == INVALID_HANDLE_VALUE) return 0;
  // creating output compressed file
  ext = strrchr(Movie_File_Name, '.');
  if(ext) *ext = 0;
  sprintf(pOutName, "%s.%s", Movie_File_Name, "giz");
  fOut = gzopen(pOutName, "wb5");
  if(!fOut) { CloseHandle(fIn); return 0; }

  i  = 1;
  sz = 0x4000;
  while(sz == 0x4000)
  {
    // reading the input file
    if(ReadFile(fIn, State_Buffer, 0x4000, &sz, NULL))
    { 
      // compressing data to output file
      if(gzwrite(fOut, State_Buffer, sz) != sz) { sz = 0; i = 0; break; }
    }
    else break;
  }

  gzclose(fOut);
  CloseHandle(fIn);

  return i;
}

