// cria screen da tela sem filtro e compacta gif

#include "gmain.h"
#include "state.h"
#include "gddraw.h"
#include "gens.h"
#include "vdp_io.h"
#include "gintro.h"
#include "giflib.h"
#include "sms.h"

#define MAKE_CLRREF_555(clr) RGB((GET_R_VALUE_555(clr) * 255 / 31), \
  (GET_G_VALUE_555(clr) * 255 / 31), (GET_B_VALUE_555(clr) * 255 / 31))
#define MAKE_CLRREF_565(clr) RGB((GET_R_VALUE_565(clr) * 255 / 31), \
  (GET_G_VALUE_565(clr) * 255 / 31), (GET_B_VALUE_565(clr) * 255 / 31))
#define MAKE_CLRREF(clr) \
  ( (Mode_555 & 0x01) ? MAKE_CLRREF_555(clr) : MAKE_CLRREF_565(clr) )

typedef struct _GIFOUTBUF {
  LPBYTE pBuf;
  int    nUsed;
} GIFOUTBUF, *LPGIFOUTBUF;

int __stdcall gif_write(GIFFILE *gFile, LPCBYTE pData, int nSize)
{
  LPGIFOUTBUF gif_buf = (LPGIFOUTBUF)gFile->UserData;
  memcpy(gif_buf->pBuf + gif_buf->nUsed, pData, nSize);
  gif_buf->nUsed += nSize;
  return nSize;
}

BOOL __fastcall Save_Shot(void)
{
  HANDLE            hFile;
  LPSTR             sufix;
  char              ext[4];
  BITMAPFILEHEADER *pbfh;
  BITMAPINFOHEADER *pbih;
  COLORREF         *pal, cur_color;
  RGBQUAD          *bmp_pal;
  LPBYTE            buf, bmp_buf;
  DWORD             dw, bmp_size;
  int               i, j, n, d;
  int               cmp, colors, error;
  int               ix, iy, ex, ey, sx, sy;
  GIFFILE          *gFile;
  COLORMAPOBJECT    gMap;
  GIFOUTBUF         gif_buf;

  SetCurrentDirectory(Gens_Path);
  // salvando o screen atual
  memcpy(State_Buffer, MD_Screen, 336 * 240 * 2);

  if(!Debug)
  {
    Update_Frame();
    if(SMS_Started)
    { ix = 8; ex = 264; sx = 256;
      iy = 46; ey = 196 + 46; sy = 196; }
    else
    {
      if(VDP_Reg.Set4 & 0x01) { ix = 8;  ex = 328; sx = 320; }
      else                    { ix = 8;  ex = 264; sx = 256; }
      if(VDP_Reg.Set2 & 0x08) { iy = 0;  ey = 240; sy = 240; }
      else                    { iy = 16; ey = 240; sy = 224; }
    }
  }
  else { ix = 8;  ex = 328; sx = 320; iy = 0;  ey = 240; sy = 240; }

  bmp_buf = State_Buffer + (336 * 240 * 2);
  bmp_size = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 1024 + (sx * sy);
  memset(bmp_buf, 0, bmp_size + 1024);

  buf     = bmp_buf;
  pbfh    = (BITMAPFILEHEADER *)buf;
  buf    += sizeof(BITMAPFILEHEADER);
  pbih    = (BITMAPINFOHEADER *)buf;
  buf    += sizeof(BITMAPINFOHEADER);
  bmp_pal = (RGBQUAD *)buf;
  buf    += 1024;
  pal     = (LPCOLORREF) ( buf + (sx * sy) );

  i = sprintf(Str_Tmp, "%s%s", ScrShot_Dir, Rom_Name);
  sufix = Str_Tmp + i;
  d   = -1;
  if(Compress_ScrShots) { ext[0] = 'g'; ext[1] = 'i'; ext[2] = 'f'; }
  else                  { ext[0] = 'b'; ext[1] = 'm'; ext[2] = 'p'; }
  ext[3] = 0;
  do
  {
    if (d++ > 99999) return FALSE;
    sufix[0] = '_';
    i = 1;
    j = d / 10000;
    if (j) sufix[i++] = '0' + j;
    j = (d / 1000) % 10;
    if (j) sufix[i++] = '0' + j;
    j = (d / 100) % 10;
    sufix[i++] = '0' + j;
    j = (d / 10) % 10;
    sufix[i++] = '0' + j;
    j = d % 10;
    sufix[i++] = '0' + j;
    sufix[i++] = '.';
    sufix[i++] = ext[0];
    sufix[i++] = ext[1];
    sufix[i++] = ext[2];
    sufix[i]   = 0;
    hFile = CreateFile(Str_Tmp, GENERIC_WRITE, 0, NULL, CREATE_NEW, FILE_ATTRIBUTE_ARCHIVE, NULL);
  } while(hFile == INVALID_HANDLE_VALUE);

  // criando imagem em 8 bits
  error = colors = 0;
  for(j = iy; j < ey; j++)
  {
    for(i = ix; i < ex; i++)
    {
      cur_color = MAKE_CLRREF(MD_Screen[i + ((239 - j) * 336)]);

      cmp = 0;
      for(n = 0; n < colors; n++)
      {
        if(cur_color == pal[n])
        { cmp = 1; break; }
      }

      if(!cmp)
      {
        if(colors > 255) { error = 1; break; }
        pal[colors] = cur_color;
        n = colors++;
      }

      buf[((j - iy) * sx) + (i - ix)] = 0xFF & n;
    }
  }

  if(!error)
  {
    if(Compress_ScrShots) // salvando imagem GIF
    {
      for(i = j = 1; i <= 8; i++)
      { j <<= 1; if(colors <= j) { gMap.ColorCount = j; gMap.BitsPerPixel = i; break; } }
      gMap.Colors       = (GIFCOLOR *)( ((LPBYTE)pal + 1024) );
      gif_buf.nUsed     = 0;
      gif_buf.pBuf      = ((LPBYTE)gMap.Colors) + 1024;
      gFile = EGifOpen(&gif_buf, gif_write);
      if(gFile)
      {
        // convertendo a palheta de cores para o formato gif
        for(i = 0; i < 256; i++)
        { gMap.Colors[i].Red   = GetRValue(pal[i]);
          gMap.Colors[i].Green = GetGValue(pal[i]);
          gMap.Colors[i].Blue  = GetBValue(pal[i]); }

        if(EGifPutScreenDesc(gFile, sx, sy, gMap.ColorCount, 0, &gMap) == GIF_OK)
        {
          if(EGifPutImageDesc(gFile, 0, 0, sx, sy, 0, NULL) == GIF_OK)
          { for(i = sy - 1; i >= 0; i--) EGifPutLine(gFile, buf + (i * sx), sx); }
          else error = 1;
        }
        else error = 1;

        EGifCloseFile(gFile);

        if(!WriteFile(hFile, gif_buf.pBuf, gif_buf.nUsed, &dw, NULL)) error = 1;
        else if(dw != gif_buf.nUsed)                                  error = 1;
      }
    }
    else // salvando imagem no formato BMP
    {
      pbfh->bfType     = MAKEWORD('B', 'M');
      pbfh->bfOffBits  = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + 1024;
      pbih->biSize     = sizeof(BITMAPINFOHEADER);
      pbih->biBitCount = 8;
      pbih->biPlanes   = 1;
      pbih->biWidth    = sx;
      pbih->biHeight   = sy;
      for(j = 0; j < 256; j++)
      { bmp_pal[j].rgbRed   = GetRValue(pal[j]);
        bmp_pal[j].rgbGreen = GetGValue(pal[j]);
        bmp_pal[j].rgbBlue  = GetBValue(pal[j]); }
      if(!WriteFile(hFile, bmp_buf, bmp_size, &dw, NULL)) error = 1;
      else if(dw != bmp_size)                             error = 1;
    }
  }

  CloseHandle(hFile);

  if(error)
  {
    DeleteFile(Str_Tmp);
    sprintf(Str_Tmp, "Error save screen shot %d", d);
  }
  else sprintf(Str_Tmp, "Screen shot %d saved", d);

  // recuperando o screen
  memcpy(MD_Screen, State_Buffer, 336 * 240 * 2);

  Put_Info(Str_Tmp, 1500);

  return TRUE;
}
